// This program was compiled from OCaml by js_of_ocaml 1.4
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (this.len == null) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_convert_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_convert_raw_backtrace' not implemented");
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_raw_backtrace' not implemented");
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_get_console () {
  var c = this.console?this.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_const_word_size () { return 32; }
function caml_sys_random_seed () {
  var x = new Date()^0xffffffff*Math.random();
  return {valueOf:function(){return x;},0:0,1:x,length:2};
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function(){function g4(mA,mB,mC,mD,mE,mF,mG){return mA.length==6?mA(mB,mC,mD,mE,mF,mG):caml_call_gen(mA,[mB,mC,mD,mE,mF,mG]);}function cU(mw,mx,my,mz){return mw.length==3?mw(mx,my,mz):caml_call_gen(mw,[mx,my,mz]);}function dn(mt,mu,mv){return mt.length==2?mt(mu,mv):caml_call_gen(mt,[mu,mv]);}function a8(mr,ms){return mr.length==1?mr(ms):caml_call_gen(mr,[ms]);}var a=[0,new MlString("Failure")],b=[0,new MlString("Invalid_argument")],c=[0,new MlString("Assert_failure")],d=new MlString("File \"%s\", line %d, characters %d-%d: %s");caml_register_global(6,[0,new MlString("Not_found")]);caml_register_global(5,[0,new MlString("Division_by_zero")]);caml_register_global(3,b);caml_register_global(2,a);var aJ=[0,new MlString("Out_of_memory")],aI=[0,new MlString("Match_failure")],aH=[0,new MlString("Stack_overflow")],aG=[0,new MlString("Undefined_recursive_module")],aF=new MlString("%.12g"),aE=new MlString("."),aD=new MlString("%d"),aC=new MlString("true"),aB=new MlString("false"),aA=new MlString("Pervasives.do_at_exit"),az=new MlString("\\b"),ay=new MlString("\\t"),ax=new MlString("\\n"),aw=new MlString("\\r"),av=new MlString("\\\\"),au=new MlString("\\'"),at=new MlString("String.blit"),as=new MlString("String.sub"),ar=new MlString("Queue.Empty"),aq=new MlString("Buffer.add: cannot grow buffer"),ap=new MlString(""),ao=new MlString(""),an=new MlString("%.12g"),am=new MlString("\""),al=new MlString("\""),ak=new MlString("'"),aj=new MlString("'"),ai=new MlString("nan"),ah=new MlString("neg_infinity"),ag=new MlString("infinity"),af=new MlString("."),ae=new MlString("printf: bad positional specification (0)."),ad=new MlString("%_"),ac=[0,new MlString("printf.ml"),143,8],ab=new MlString("'"),aa=new MlString("Printf: premature end of format string '"),$=new MlString("'"),_=new MlString(" in format string '"),Z=new MlString(", at char number "),Y=new MlString("Printf: bad conversion %"),X=new MlString("Sformat.index_of_int: negative argument "),W=new MlString(""),V=new MlString(", %s%s"),U=[1,1],T=new MlString("%s\n"),S=new MlString("(Program not linked with -g, cannot print stack backtrace)\n"),R=new MlString("Raised at"),Q=new MlString("Re-raised at"),P=new MlString("Raised by primitive operation at"),O=new MlString("Called from"),N=new MlString("%s file \"%s\", line %d, characters %d-%d"),M=new MlString("%s unknown location"),L=new MlString("Out of memory"),K=new MlString("Stack overflow"),J=new MlString("Pattern matching failed"),I=new MlString("Assertion failed"),H=new MlString("Undefined recursive module"),G=new MlString("(%s%s)"),F=new MlString(""),E=new MlString(""),D=new MlString("(%s)"),C=new MlString("%d"),B=new MlString("%S"),A=new MlString("_"),z=new MlString("Random.int"),y=new MlString("x"),x=[0,987910699,495797812,364182224,414272206,318284740,990407751,383018966,270373319,840823159,24560019,536292337,512266505,189156120,730249596,143776328,51606627,140166561,366354223,1003410265,700563762,981890670,913149062,526082594,1021425055,784300257,667753350,630144451,949649812,48546892,415514493,258888527,511570777,89983870,283659902,308386020,242688715,482270760,865188196,1027664170,207196989,193777847,619708188,671350186,149669678,257044018,87658204,558145612,183450813,28133145,901332182,710253903,510646120,652377910,409934019,801085050],w=[0,new MlString("src/core/lwt.ml"),648,20],v=[0,new MlString("src/core/lwt.ml"),651,8],u=[0,new MlString("src/core/lwt.ml"),498,8],t=[0,new MlString("src/core/lwt.ml"),487,9],s=new MlString("Lwt.wakeup_result"),r=new MlString("Lwt.Canceled"),q=new MlString("canvas"),p=new MlString("2d"),o=new MlString("Dom_html.Canvas_not_available"),n=new MlString("Exception during Lwt.async: "),m=new MlString("copy"),l=new MlString("lighter"),k=new MlString("source-over"),j=new MlString("#a8a8f6"),i=new MlString("#d9d9d9"),h=new MlString("#767676");function g(e){throw [0,a,e];}function aK(f){throw [0,b,f];}function aR(aL,aN){var aM=aL.getLen(),aO=aN.getLen(),aP=caml_create_string(aM+aO|0);caml_blit_string(aL,0,aP,0,aM);caml_blit_string(aN,0,aP,aM,aO);return aP;}function aS(aQ){return caml_format_int(aD,aQ);}var aT=caml_ml_open_descriptor_out(2);function a1(aV,aU){return caml_ml_output(aV,aU,0,aU.getLen());}function a0(aZ){var aW=caml_ml_out_channels_list(0);for(;;){if(aW){var aX=aW[2];try {}catch(aY){}var aW=aX;continue;}return 0;}}caml_register_named_value(aA,a0);function a5(a3,a2){return caml_ml_output_char(a3,a2);}function bd(a4){return caml_ml_flush(a4);}function bc(a6,a7){if(0===a6)return [0];var a9=caml_make_vect(a6,a8(a7,0)),a_=1,a$=a6-1|0;if(!(a$<a_)){var ba=a_;for(;;){a9[ba+1]=a8(a7,ba);var bb=ba+1|0;if(a$!==ba){var ba=bb;continue;}break;}}return a9;}function bq(be,bg){var bf=caml_create_string(be);caml_fill_string(bf,0,be,bg);return bf;}function br(bj,bh,bi){if(0<=bh&&0<=bi&&!((bj.getLen()-bi|0)<bh)){var bk=caml_create_string(bi);caml_blit_string(bj,bh,bk,0,bi);return bk;}return aK(as);}function bs(bn,bm,bp,bo,bl){if(0<=bl&&0<=bm&&!((bn.getLen()-bl|0)<bm)&&0<=bo&&!((bp.getLen()-bl|0)<bo))return caml_blit_string(bn,bm,bp,bo,bl);return aK(at);}var bt=caml_sys_const_word_size(0),bu=caml_mul(bt/8|0,(1<<(bt-10|0))-1|0)-1|0,bP=252,bO=253,bN=[0,ar];function bM(bv){var bw=1<=bv?bv:1,bx=bu<bw?bu:bw,by=caml_create_string(bx);return [0,by,0,bx,by];}function bQ(bz){return br(bz[1],0,bz[2]);}function bG(bA,bC){var bB=[0,bA[3]];for(;;){if(bB[1]<(bA[2]+bC|0)){bB[1]=2*bB[1]|0;continue;}if(bu<bB[1])if((bA[2]+bC|0)<=bu)bB[1]=bu;else g(aq);var bD=caml_create_string(bB[1]);bs(bA[1],0,bD,0,bA[2]);bA[1]=bD;bA[3]=bB[1];return 0;}}function bR(bE,bH){var bF=bE[2];if(bE[3]<=bF)bG(bE,1);bE[1].safeSet(bF,bH);bE[2]=bF+1|0;return 0;}function bS(bK,bI){var bJ=bI.getLen(),bL=bK[2]+bJ|0;if(bK[3]<bL)bG(bK,bJ);bs(bI,0,bK[1],bK[2],bJ);bK[2]=bL;return 0;}function bW(bT){return 0<=bT?bT:g(aR(X,aS(bT)));}function bX(bU,bV){return bW(bU+bV|0);}var bY=a8(bX,1);function b5(bZ){return br(bZ,0,bZ.getLen());}function b7(b0,b1,b3){var b2=aR(_,aR(b0,$)),b4=aR(Z,aR(aS(b1),b2));return aK(aR(Y,aR(bq(1,b3),b4)));}function c0(b6,b9,b8){return b7(b5(b6),b9,b8);}function c1(b_){return aK(aR(aa,aR(b5(b_),ab)));}function cw(b$,ch,cj,cl){function cg(ca){if((b$.safeGet(ca)-48|0)<0||9<(b$.safeGet(ca)-48|0))return ca;var cb=ca+1|0;for(;;){var cc=b$.safeGet(cb);if(48<=cc){if(!(58<=cc)){var ce=cb+1|0,cb=ce;continue;}var cd=0;}else if(36===cc){var cf=cb+1|0,cd=1;}else var cd=0;if(!cd)var cf=ca;return cf;}}var ci=cg(ch+1|0),ck=bM((cj-ci|0)+10|0);bR(ck,37);var cm=cl,cn=0;for(;;){if(cm){var co=cm[2],cp=[0,cm[1],cn],cm=co,cn=cp;continue;}var cq=ci,cr=cn;for(;;){if(cq<=cj){var cs=b$.safeGet(cq);if(42===cs){if(cr){var ct=cr[2];bS(ck,aS(cr[1]));var cu=cg(cq+1|0),cq=cu,cr=ct;continue;}throw [0,c,ac];}bR(ck,cs);var cv=cq+1|0,cq=cv;continue;}return bQ(ck);}}}function er(cC,cA,cz,cy,cx){var cB=cw(cA,cz,cy,cx);if(78!==cC&&110!==cC)return cB;cB.safeSet(cB.getLen()-1|0,117);return cB;}function c2(cJ,cT,cY,cD,cX){var cE=cD.getLen();function cV(cF,cS){var cG=40===cF?41:125;function cR(cH){var cI=cH;for(;;){if(cE<=cI)return a8(cJ,cD);if(37===cD.safeGet(cI)){var cK=cI+1|0;if(cE<=cK)var cL=a8(cJ,cD);else{var cM=cD.safeGet(cK),cN=cM-40|0;if(cN<0||1<cN){var cO=cN-83|0;if(cO<0||2<cO)var cP=1;else switch(cO){case 1:var cP=1;break;case 2:var cQ=1,cP=0;break;default:var cQ=0,cP=0;}if(cP){var cL=cR(cK+1|0),cQ=2;}}else var cQ=0===cN?0:1;switch(cQ){case 1:var cL=cM===cG?cK+1|0:cU(cT,cD,cS,cM);break;case 2:break;default:var cL=cR(cV(cM,cK+1|0)+1|0);}}return cL;}var cW=cI+1|0,cI=cW;continue;}}return cR(cS);}return cV(cY,cX);}function dr(cZ){return cU(c2,c1,c0,cZ);}function dH(c3,dc,dm){var c4=c3.getLen()-1|0;function dp(c5){var c6=c5;a:for(;;){if(c6<c4){if(37===c3.safeGet(c6)){var c7=0,c8=c6+1|0;for(;;){if(c4<c8)var c9=c1(c3);else{var c_=c3.safeGet(c8);if(58<=c_){if(95===c_){var da=c8+1|0,c$=1,c7=c$,c8=da;continue;}}else if(32<=c_)switch(c_-32|0){case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 9:case 12:case 15:break;case 0:case 3:case 11:case 13:var db=c8+1|0,c8=db;continue;case 10:var dd=cU(dc,c7,c8,105),c8=dd;continue;default:var de=c8+1|0,c8=de;continue;}var df=c8;c:for(;;){if(c4<df)var dg=c1(c3);else{var dh=c3.safeGet(df);if(126<=dh)var di=0;else switch(dh){case 78:case 88:case 100:case 105:case 111:case 117:case 120:var dg=cU(dc,c7,df,105),di=1;break;case 69:case 70:case 71:case 101:case 102:case 103:var dg=cU(dc,c7,df,102),di=1;break;case 33:case 37:case 44:case 64:var dg=df+1|0,di=1;break;case 83:case 91:case 115:var dg=cU(dc,c7,df,115),di=1;break;case 97:case 114:case 116:var dg=cU(dc,c7,df,dh),di=1;break;case 76:case 108:case 110:var dj=df+1|0;if(c4<dj){var dg=cU(dc,c7,df,105),di=1;}else{var dk=c3.safeGet(dj)-88|0;if(dk<0||32<dk)var dl=1;else switch(dk){case 0:case 12:case 17:case 23:case 29:case 32:var dg=dn(dm,cU(dc,c7,df,dh),105),di=1,dl=0;break;default:var dl=1;}if(dl){var dg=cU(dc,c7,df,105),di=1;}}break;case 67:case 99:var dg=cU(dc,c7,df,99),di=1;break;case 66:case 98:var dg=cU(dc,c7,df,66),di=1;break;case 41:case 125:var dg=cU(dc,c7,df,dh),di=1;break;case 40:var dg=dp(cU(dc,c7,df,dh)),di=1;break;case 123:var dq=cU(dc,c7,df,dh),ds=cU(dr,dh,c3,dq),dt=dq;for(;;){if(dt<(ds-2|0)){var du=dn(dm,dt,c3.safeGet(dt)),dt=du;continue;}var dv=ds-1|0,df=dv;continue c;}default:var di=0;}if(!di)var dg=c0(c3,df,dh);}var c9=dg;break;}}var c6=c9;continue a;}}var dw=c6+1|0,c6=dw;continue;}return c6;}}dp(0);return 0;}function fG(dI){var dx=[0,0,0,0];function dG(dC,dD,dy){var dz=41!==dy?1:0,dA=dz?125!==dy?1:0:dz;if(dA){var dB=97===dy?2:1;if(114===dy)dx[3]=dx[3]+1|0;if(dC)dx[2]=dx[2]+dB|0;else dx[1]=dx[1]+dB|0;}return dD+1|0;}dH(dI,dG,function(dE,dF){return dE+1|0;});return dx[1];}function en(dJ,dM,dK){var dL=dJ.safeGet(dK);if((dL-48|0)<0||9<(dL-48|0))return dn(dM,0,dK);var dN=dL-48|0,dO=dK+1|0;for(;;){var dP=dJ.safeGet(dO);if(48<=dP){if(!(58<=dP)){var dS=dO+1|0,dR=(10*dN|0)+(dP-48|0)|0,dN=dR,dO=dS;continue;}var dQ=0;}else if(36===dP)if(0===dN){var dT=g(ae),dQ=1;}else{var dT=dn(dM,[0,bW(dN-1|0)],dO+1|0),dQ=1;}else var dQ=0;if(!dQ)var dT=dn(dM,0,dK);return dT;}}function ei(dU,dV){return dU?dV:a8(bY,dV);}function d9(dW,dX){return dW?dW[1]:dX;}function g3(f1,dZ,gb,d2,fL,gh,dY){var d0=a8(dZ,dY);function f2(d1){return dn(d2,d0,d1);}function fK(d7,gg,d3,ea){var d6=d3.getLen();function fH(f_,d4){var d5=d4;for(;;){if(d6<=d5)return a8(d7,d0);var d8=d3.safeGet(d5);if(37===d8){var ee=function(d$,d_){return caml_array_get(ea,d9(d$,d_));},ek=function(em,ef,eh,eb){var ec=eb;for(;;){var ed=d3.safeGet(ec)-32|0;if(!(ed<0||25<ed))switch(ed){case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 9:case 12:case 15:break;case 10:return en(d3,function(eg,el){var ej=[0,ee(eg,ef),eh];return ek(em,ei(eg,ef),ej,el);},ec+1|0);default:var eo=ec+1|0,ec=eo;continue;}var ep=d3.safeGet(ec);if(124<=ep)var eq=0;else switch(ep){case 78:case 88:case 100:case 105:case 111:case 117:case 120:var es=ee(em,ef),et=caml_format_int(er(ep,d3,d5,ec,eh),es),ev=eu(ei(em,ef),et,ec+1|0),eq=1;break;case 69:case 71:case 101:case 102:case 103:var ew=ee(em,ef),ex=caml_format_float(cw(d3,d5,ec,eh),ew),ev=eu(ei(em,ef),ex,ec+1|0),eq=1;break;case 76:case 108:case 110:var ey=d3.safeGet(ec+1|0)-88|0;if(ey<0||32<ey)var ez=1;else switch(ey){case 0:case 12:case 17:case 23:case 29:case 32:var eA=ec+1|0,eB=ep-108|0;if(eB<0||2<eB)var eC=0;else{switch(eB){case 1:var eC=0,eD=0;break;case 2:var eE=ee(em,ef),eF=caml_format_int(cw(d3,d5,eA,eh),eE),eD=1;break;default:var eG=ee(em,ef),eF=caml_format_int(cw(d3,d5,eA,eh),eG),eD=1;}if(eD){var eH=eF,eC=1;}}if(!eC){var eI=ee(em,ef),eH=caml_int64_format(cw(d3,d5,eA,eh),eI);}var ev=eu(ei(em,ef),eH,eA+1|0),eq=1,ez=0;break;default:var ez=1;}if(ez){var eJ=ee(em,ef),eK=caml_format_int(er(110,d3,d5,ec,eh),eJ),ev=eu(ei(em,ef),eK,ec+1|0),eq=1;}break;case 37:case 64:var ev=eu(ef,bq(1,ep),ec+1|0),eq=1;break;case 83:case 115:var eL=ee(em,ef);if(115===ep)var eM=eL;else{var eN=[0,0],eO=0,eP=eL.getLen()-1|0;if(!(eP<eO)){var eQ=eO;for(;;){var eR=eL.safeGet(eQ),eS=14<=eR?34===eR?1:92===eR?1:0:11<=eR?13<=eR?1:0:8<=eR?1:0,eT=eS?2:caml_is_printable(eR)?1:4;eN[1]=eN[1]+eT|0;var eU=eQ+1|0;if(eP!==eQ){var eQ=eU;continue;}break;}}if(eN[1]===eL.getLen())var eV=eL;else{var eW=caml_create_string(eN[1]);eN[1]=0;var eX=0,eY=eL.getLen()-1|0;if(!(eY<eX)){var eZ=eX;for(;;){var e0=eL.safeGet(eZ),e1=e0-34|0;if(e1<0||58<e1)if(-20<=e1)var e2=1;else{switch(e1+34|0){case 8:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],98);var e3=1;break;case 9:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],116);var e3=1;break;case 10:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],110);var e3=1;break;case 13:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],114);var e3=1;break;default:var e2=1,e3=0;}if(e3)var e2=0;}else var e2=(e1-1|0)<0||56<(e1-1|0)?(eW.safeSet(eN[1],92),eN[1]+=1,eW.safeSet(eN[1],e0),0):1;if(e2)if(caml_is_printable(e0))eW.safeSet(eN[1],e0);else{eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],48+(e0/100|0)|0);eN[1]+=1;eW.safeSet(eN[1],48+((e0/10|0)%10|0)|0);eN[1]+=1;eW.safeSet(eN[1],48+(e0%10|0)|0);}eN[1]+=1;var e4=eZ+1|0;if(eY!==eZ){var eZ=e4;continue;}break;}}var eV=eW;}var eM=aR(al,aR(eV,am));}if(ec===(d5+1|0))var e5=eM;else{var e6=cw(d3,d5,ec,eh);try {var e7=0,e8=1;for(;;){if(e6.getLen()<=e8)var e9=[0,0,e7];else{var e_=e6.safeGet(e8);if(49<=e_)if(58<=e_)var e$=0;else{var e9=[0,caml_int_of_string(br(e6,e8,(e6.getLen()-e8|0)-1|0)),e7],e$=1;}else{if(45===e_){var fb=e8+1|0,fa=1,e7=fa,e8=fb;continue;}var e$=0;}if(!e$){var fc=e8+1|0,e8=fc;continue;}}var fd=e9;break;}}catch(fe){if(fe[1]!==a)throw fe;var fd=b7(e6,0,115);}var ff=fd[1],fg=eM.getLen(),fh=0,fl=fd[2],fk=32;if(ff===fg&&0===fh){var fi=eM,fj=1;}else var fj=0;if(!fj)if(ff<=fg)var fi=br(eM,fh,fg);else{var fm=bq(ff,fk);if(fl)bs(eM,fh,fm,0,fg);else bs(eM,fh,fm,ff-fg|0,fg);var fi=fm;}var e5=fi;}var ev=eu(ei(em,ef),e5,ec+1|0),eq=1;break;case 67:case 99:var fn=ee(em,ef);if(99===ep)var fo=bq(1,fn);else{if(39===fn)var fp=au;else if(92===fn)var fp=av;else{if(14<=fn)var fq=0;else switch(fn){case 8:var fp=az,fq=1;break;case 9:var fp=ay,fq=1;break;case 10:var fp=ax,fq=1;break;case 13:var fp=aw,fq=1;break;default:var fq=0;}if(!fq)if(caml_is_printable(fn)){var fr=caml_create_string(1);fr.safeSet(0,fn);var fp=fr;}else{var fs=caml_create_string(4);fs.safeSet(0,92);fs.safeSet(1,48+(fn/100|0)|0);fs.safeSet(2,48+((fn/10|0)%10|0)|0);fs.safeSet(3,48+(fn%10|0)|0);var fp=fs;}}var fo=aR(aj,aR(fp,ak));}var ev=eu(ei(em,ef),fo,ec+1|0),eq=1;break;case 66:case 98:var fu=ec+1|0,ft=ee(em,ef)?aC:aB,ev=eu(ei(em,ef),ft,fu),eq=1;break;case 40:case 123:var fv=ee(em,ef),fw=cU(dr,ep,d3,ec+1|0);if(123===ep){var fx=bM(fv.getLen()),fB=function(fz,fy){bR(fx,fy);return fz+1|0;};dH(fv,function(fA,fD,fC){if(fA)bS(fx,ad);else bR(fx,37);return fB(fD,fC);},fB);var fE=bQ(fx),ev=eu(ei(em,ef),fE,fw),eq=1;}else{var fF=ei(em,ef),fI=bX(fG(fv),fF),ev=fK(function(fJ){return fH(fI,fw);},fF,fv,ea),eq=1;}break;case 33:a8(fL,d0);var ev=fH(ef,ec+1|0),eq=1;break;case 41:var ev=eu(ef,ap,ec+1|0),eq=1;break;case 44:var ev=eu(ef,ao,ec+1|0),eq=1;break;case 70:var fM=ee(em,ef);if(0===eh)var fN=an;else{var fO=cw(d3,d5,ec,eh);if(70===ep)fO.safeSet(fO.getLen()-1|0,103);var fN=fO;}var fP=caml_classify_float(fM);if(3===fP)var fQ=fM<0?ah:ag;else if(4<=fP)var fQ=ai;else{var fR=caml_format_float(fN,fM),fS=0,fT=fR.getLen();for(;;){if(fT<=fS)var fU=aR(fR,af);else{var fV=fR.safeGet(fS)-46|0,fW=fV<0||23<fV?55===fV?1:0:(fV-1|0)<0||21<(fV-1|0)?1:0;if(!fW){var fX=fS+1|0,fS=fX;continue;}var fU=fR;}var fQ=fU;break;}}var ev=eu(ei(em,ef),fQ,ec+1|0),eq=1;break;case 91:var ev=c0(d3,ec,ep),eq=1;break;case 97:var fY=ee(em,ef),fZ=a8(bY,d9(em,ef)),f0=ee(0,fZ),f4=ec+1|0,f3=ei(em,fZ);if(f1)f2(dn(fY,0,f0));else dn(fY,d0,f0);var ev=fH(f3,f4),eq=1;break;case 114:var ev=c0(d3,ec,ep),eq=1;break;case 116:var f5=ee(em,ef),f7=ec+1|0,f6=ei(em,ef);if(f1)f2(a8(f5,0));else a8(f5,d0);var ev=fH(f6,f7),eq=1;break;default:var eq=0;}if(!eq)var ev=c0(d3,ec,ep);return ev;}},ga=d5+1|0,f9=0;return en(d3,function(f$,f8){return ek(f$,f_,f9,f8);},ga);}dn(gb,d0,d8);var gc=d5+1|0,d5=gc;continue;}}function eu(gf,gd,ge){f2(gd);return fH(gf,ge);}return fH(gg,0);}var gi=dn(fK,gh,bW(0)),gj=fG(dY);if(gj<0||6<gj){var gw=function(gk,gq){if(gj<=gk){var gl=caml_make_vect(gj,0),go=function(gm,gn){return caml_array_set(gl,(gj-gm|0)-1|0,gn);},gp=0,gr=gq;for(;;){if(gr){var gs=gr[2],gt=gr[1];if(gs){go(gp,gt);var gu=gp+1|0,gp=gu,gr=gs;continue;}go(gp,gt);}return dn(gi,dY,gl);}}return function(gv){return gw(gk+1|0,[0,gv,gq]);};},gx=gw(0,0);}else switch(gj){case 1:var gx=function(gz){var gy=caml_make_vect(1,0);caml_array_set(gy,0,gz);return dn(gi,dY,gy);};break;case 2:var gx=function(gB,gC){var gA=caml_make_vect(2,0);caml_array_set(gA,0,gB);caml_array_set(gA,1,gC);return dn(gi,dY,gA);};break;case 3:var gx=function(gE,gF,gG){var gD=caml_make_vect(3,0);caml_array_set(gD,0,gE);caml_array_set(gD,1,gF);caml_array_set(gD,2,gG);return dn(gi,dY,gD);};break;case 4:var gx=function(gI,gJ,gK,gL){var gH=caml_make_vect(4,0);caml_array_set(gH,0,gI);caml_array_set(gH,1,gJ);caml_array_set(gH,2,gK);caml_array_set(gH,3,gL);return dn(gi,dY,gH);};break;case 5:var gx=function(gN,gO,gP,gQ,gR){var gM=caml_make_vect(5,0);caml_array_set(gM,0,gN);caml_array_set(gM,1,gO);caml_array_set(gM,2,gP);caml_array_set(gM,3,gQ);caml_array_set(gM,4,gR);return dn(gi,dY,gM);};break;case 6:var gx=function(gT,gU,gV,gW,gX,gY){var gS=caml_make_vect(6,0);caml_array_set(gS,0,gT);caml_array_set(gS,1,gU);caml_array_set(gS,2,gV);caml_array_set(gS,3,gW);caml_array_set(gS,4,gX);caml_array_set(gS,5,gY);return dn(gi,dY,gS);};break;default:var gx=dn(gi,dY,[0]);}return gx;}function hf(g0){function g2(gZ){return 0;}return g4(g3,0,function(g1){return g0;},a5,a1,bd,g2);}function hb(g5){return bM(2*g5.getLen()|0);}function g_(g8,g6){var g7=bQ(g6);g6[2]=0;return a8(g8,g7);}function he(g9){var ha=a8(g_,g9);return g4(g3,1,hb,bR,bS,function(g$){return 0;},ha);}function hg(hd){return dn(he,function(hc){return hc;},hd);}var hh=[0,0];function hv(hi,hj){var hk=hi[hj+1];if(caml_obj_is_block(hk)){if(caml_obj_tag(hk)===bP)return dn(hg,B,hk);if(caml_obj_tag(hk)===bO){var hl=caml_format_float(aF,hk),hm=0,hn=hl.getLen();for(;;){if(hn<=hm)var ho=aR(hl,aE);else{var hp=hl.safeGet(hm),hq=48<=hp?58<=hp?0:1:45===hp?1:0;if(hq){var hr=hm+1|0,hm=hr;continue;}var ho=hl;}return ho;}}return A;}return dn(hg,C,hk);}function hu(hs,ht){if(hs.length-1<=ht)return W;var hw=hu(hs,ht+1|0);return cU(hg,V,hv(hs,ht),hw);}function h1(hy){var hx=hh[1];for(;;){if(hx){var hD=hx[2],hz=hx[1];try {var hA=a8(hz,hy),hB=hA;}catch(hE){var hB=0;}if(!hB){var hx=hD;continue;}var hC=hB[1];}else if(hy[1]===aJ)var hC=L;else if(hy[1]===aH)var hC=K;else if(hy[1]===aI){var hF=hy[2],hG=hF[3],hC=g4(hg,d,hF[1],hF[2],hG,hG+5|0,J);}else if(hy[1]===c){var hH=hy[2],hI=hH[3],hC=g4(hg,d,hH[1],hH[2],hI,hI+6|0,I);}else if(hy[1]===aG){var hJ=hy[2],hK=hJ[3],hC=g4(hg,d,hJ[1],hJ[2],hK,hK+6|0,H);}else{var hL=hy.length-1,hO=hy[0+1][0+1];if(hL<0||2<hL){var hM=hu(hy,2),hN=cU(hg,G,hv(hy,1),hM);}else switch(hL){case 1:var hN=E;break;case 2:var hN=dn(hg,D,hv(hy,1));break;default:var hN=F;}var hC=aR(hO,hN);}return hC;}}function h2(hY){var hP=caml_convert_raw_backtrace(caml_get_exception_raw_backtrace(0));if(hP){var hQ=hP[1],hR=0,hS=hQ.length-1-1|0;if(!(hS<hR)){var hT=hR;for(;;){if(caml_notequal(caml_array_get(hQ,hT),U)){var hU=caml_array_get(hQ,hT),hV=0===hU[0]?hU[1]:hU[1],hW=hV?0===hT?R:Q:0===hT?P:O,hX=0===hU[0]?g4(hg,N,hW,hU[2],hU[3],hU[4],hU[5]):dn(hg,M,hW);cU(hf,hY,T,hX);}var hZ=hT+1|0;if(hS!==hT){var hT=hZ;continue;}break;}}var h0=0;}else var h0=dn(hf,hY,S);return h0;}32===bt;var h3=[0,x.slice(),0];function h_(h4){if(1073741823<h4||!(0<h4))var h5=0;else for(;;){h3[2]=(h3[2]+1|0)%55|0;var h6=caml_array_get(h3[1],h3[2]),h7=(caml_array_get(h3[1],(h3[2]+24|0)%55|0)+(h6^h6>>>25&31)|0)&1073741823;caml_array_set(h3[1],h3[2],h7);var h8=caml_mod(h7,h4);if(((1073741823-h4|0)+1|0)<(h7-h8|0))continue;var h9=h8,h5=1;break;}if(!h5)var h9=aK(z);return h9;}function ib(ia){var h$=[];caml_update_dummy(h$,[0,h$,h$]);return h$;}var ic=[0,r],id=[0,0],im=42;function ii(ie){var ig=ie[1];{if(3===ig[0]){var ih=ig[1],ij=ii(ih);if(ij!==ih)ie[1]=[3,ij];return ij;}return ie;}}function io(ik){return ii(ik);}var ip=[0,function(il){h1(il);caml_ml_output_char(aT,10);h2(aT);a0(0);return caml_sys_exit(2);}];function iP(ir,iq){try {var is=a8(ir,iq);}catch(it){return a8(ip[1],it);}return is;}function iE(iy,iu,iw){var iv=iu,ix=iw;for(;;)if(typeof iv==="number")return iz(iy,ix);else switch(iv[0]){case 1:a8(iv[1],iy);return iz(iy,ix);case 2:var iA=iv[1],iB=[0,iv[2],ix],iv=iA,ix=iB;continue;default:var iC=iv[1][1];return iC?(a8(iC[1],iy),iz(iy,ix)):iz(iy,ix);}}function iz(iF,iD){return iD?iE(iF,iD[1],iD[2]):0;}function iR(iG,iI){var iH=iG,iJ=iI;for(;;)if(typeof iH==="number")return iL(iJ);else switch(iH[0]){case 1:var iK=iH[1];if(iK[4]){iK[4]=0;iK[1][2]=iK[2];iK[2][1]=iK[1];}return iL(iJ);case 2:var iM=iH[1],iN=[0,iH[2],iJ],iH=iM,iJ=iN;continue;default:var iO=iH[2];id[1]=iH[1];iP(iO,0);return iL(iJ);}}function iL(iQ){return iQ?iR(iQ[1],iQ[2]):0;}function iV(iT,iS){var iU=1===iS[0]?iS[1][1]===ic?(iR(iT[4],0),1):0:0;return iE(iS,iT[2],0);}var iW=[0,0],iX=[0,0,0];function ji(i0,iY){var iZ=[0,iY],i1=ii(i0),i2=i1[1];switch(i2[0]){case 1:if(i2[1][1]===ic){var i3=0,i4=1;}else var i4=0;break;case 2:var i5=i2[1];i1[1]=iZ;var i6=id[1],i7=iW[1]?1:(iW[1]=1,0);iV(i5,iZ);if(i7){id[1]=i6;var i8=0;}else for(;;){if(0!==iX[1]){if(0===iX[1])throw [0,bN];iX[1]=iX[1]-1|0;var i9=iX[2],i_=i9[2];if(i_===i9)iX[2]=0;else i9[2]=i_[2];var i$=i_[1];iV(i$[1],i$[2]);continue;}iW[1]=0;id[1]=i6;var i8=0;break;}var i3=i8,i4=1;break;default:var i4=0;}if(!i4)var i3=aK(s);return i3;}function jg(ja,jb){return typeof ja==="number"?jb:typeof jb==="number"?ja:[2,ja,jb];}function jd(jc){if(typeof jc!=="number")switch(jc[0]){case 2:var je=jc[1],jf=jd(jc[2]);return jg(jd(je),jf);case 1:break;default:if(!jc[1][1])return 0;}return jc;}var jk=[0,function(jh){return 0;}],jj=ib(0),jn=[0,0];function jx(jr){var jl=1-(jj[2]===jj?1:0);if(jl){var jm=ib(0);jm[1][2]=jj[2];jj[2][1]=jm[1];jm[1]=jj[1];jj[1][2]=jm;jj[1]=jj;jj[2]=jj;jn[1]=0;var jo=jm[2];for(;;){var jp=jo!==jm?1:0;if(jp){if(jo[4])ji(jo[3],0);var jq=jo[2],jo=jq;continue;}return jp;}}return jl;}var jw=null,jv=undefined,ju=false,jt=Array;function jy(js){return js instanceof jt?0:[0,new MlWrappedString(js.toString())];}hh[1]=[0,jy,hh[1]];var jz=p.toString(),jA=this,jB=[0,o];this.HTMLElement===jv;var jC=2147483,jE=caml_js_get_console(0);jk[1]=function(jD){return 1===jD?(jA.setTimeout(caml_js_wrap_callback(jx),0),0):0;};function jG(jF){return jE.log(jF.toString());}ip[1]=function(jH){jG(n);jG(h1(jH));return h2(aT);};var jI=12,jJ=20,jK=Math.floor(jJ*Math.sqrt(3)/2+0.5),jL=caml_sys_random_seed(0),jM=0===jL.length-1?[0,0]:jL,jN=jM.length-1,jO=0,jP=54;if(!(jP<jO)){var jQ=jO;for(;;){caml_array_set(h3[1],jQ,jQ);var jR=jQ+1|0;if(jP!==jQ){var jQ=jR;continue;}break;}}var jS=[0,y],jT=0,jU=55,jV=caml_greaterequal(jU,jN)?jU:jN,jW=54+jV|0;if(!(jW<jT)){var jX=jT;for(;;){var jY=jX%55|0,jZ=jS[1],j0=aR(jZ,aS(caml_array_get(jM,caml_mod(jX,jN))));jS[1]=caml_md5_string(j0,0,j0.getLen());var j1=jS[1];caml_array_set(h3[1],jY,(caml_array_get(h3[1],jY)^(((j1.safeGet(0)+(j1.safeGet(1)<<8)|0)+(j1.safeGet(2)<<16)|0)+(j1.safeGet(3)<<24)|0))&1073741823);var j2=jX+1|0;if(jW!==jX){var jX=j2;continue;}break;}}h3[2]=0;function kc(kb,j3,j6,j8){var j4=j3<0?1:0;if(j4)var j5=j4;else{var j7=j6<0?1:0;if(j7)var j5=j7;else{var j9=j8<0?1:0;if(j9)var j5=j9;else{var j_=j3<jI?1:0;if(j_){var j$=j6<jI?1:0;if(j$){var ka=j8<jI?1:0,j5=ka?caml_array_get(caml_array_get(caml_array_get(kb,j3),j6),j8):ka;}else var j5=j$;}else var j5=j_;}}}return j5;}var kj=j.toString(),kp=i.toString(),km=h.toString();function kA(kg,kd,kf,ke,kh){kg.save();kg.translate((((kd-ke|0)+jI|0)-1|0)*jK,((jI-1|0)-kf|0)*jJ+(kd+ke|0)*jJ/2);a8(kh,kg);return kg.restore();}function k5(ki){ki.fillStyle=kj;ki.beginPath();ki.moveTo(jK,0);ki.lineTo(2*jK,jJ/2);ki.lineTo(jK,jJ);ki.lineTo(0,jJ/2);return ki.fill();}function k_(kk){kk.beginPath();kk.moveTo(0,jJ/2);kk.lineTo(jK,0);kk.lineTo(2*jK,jJ/2);return kk.stroke();}function k4(kl){kl.fillStyle=km;kl.beginPath();kl.moveTo(jK,jJ);kl.lineTo(jK,2*jJ);kl.lineTo(2*jK,1.5*jJ);kl.lineTo(2*jK,jJ/2);return kl.fill();}function k9(kn){kn.beginPath();kn.moveTo(jK,2*jJ);kn.lineTo(jK,jJ);kn.lineTo(2*jK,jJ/2);return kn.stroke();}function k3(ko){ko.fillStyle=kp;ko.beginPath();ko.moveTo(jK,jJ);ko.lineTo(jK,2*jJ);ko.lineTo(0,1.5*jJ);ko.lineTo(0,jJ/2);return ko.fill();}function k8(kq){kq.beginPath();kq.moveTo(jK,jJ);kq.lineTo(0,jJ/2);kq.lineTo(0,1.5*jJ);return kq.stroke();}function k6(kC,kz,kr){var ks=0,kt=jI-1|0,kG=kr[3],kF=kr[2],kB=kr[1];if(!(kt<ks)){var ku=ks;for(;;){var kv=[0,jI-1|0],kw=0,kx=jI-1|0;if(!(kx<kw)){var ky=kw;b:for(;;){for(;;){if(0<=kv[1]&&!caml_array_get(caml_array_get(caml_array_get(kz,ku),kv[1]),ky)){kv[1]+=-1;continue;}kA(kC,ku,kv[1],ky,kB);var kD=ky+1|0;if(kx!==ky){var ky=kD;continue b;}break;}break;}}var kE=ku+1|0;if(kt!==ku){var ku=kE;continue;}break;}}var kH=0,kI=jI-1|0;if(!(kI<kH)){var kJ=kH;for(;;){var kK=[0,jI-1|0],kL=0,kM=jI-1|0;if(!(kM<kL)){var kN=kL;b:for(;;){for(;;){if(0<=kK[1]&&!caml_array_get(caml_array_get(caml_array_get(kz,kK[1]),kJ),kN)){kK[1]+=-1;continue;}kA(kC,kK[1],kJ,kN,kF);var kO=kN+1|0;if(kM!==kN){var kN=kO;continue b;}break;}break;}}var kP=kJ+1|0;if(kI!==kJ){var kJ=kP;continue;}break;}}var kQ=0,kR=jI-1|0;if(!(kR<kQ)){var kS=kQ;for(;;){var kT=[0,jI-1|0],kU=0,kV=jI-1|0;if(!(kV<kU)){var kW=kU;b:for(;;){for(;;){if(0<=kT[1]&&!caml_array_get(caml_array_get(caml_array_get(kz,kS),kW),kT[1])){kT[1]+=-1;continue;}kA(kC,kS,kW,kT[1],kG);var kX=kW+1|0;if(kV!==kW){var kW=kX;continue b;}break;}break;}}var kY=kS+1|0;if(kR!==kS){var kS=kY;continue;}break;}}return 0;}function md(k0){var kZ=jA.document.createElement(q.toString());if(1-(kZ.getContext==jw?1:0)){kZ.width=caml_mul(jI*2|0,jK|0)+1|0;kZ.height=caml_mul(jI*2|0,jJ|0)+1|0;return kZ;}throw [0,jB];}function ln(k$,k1,k7){var k2=k1.getContext(jz);k2.setTransform(1,0,0,1,0,0);k2.clearRect(0,0,k1.width,k1.height);k2.setTransform(1,0,0,1,0.5,0.5);k2.globalCompositeOperation=l.toString();k6(k2,k7,[0,k5,k4,k3]);k2.globalCompositeOperation=k.toString();k6(k2,k7,[0,k_,k9,k8]);k2.beginPath();k2.moveTo(0,jI*1.5*jJ);k2.lineTo(jI*jK,jI*2*jJ);k2.lineTo(jI*2*jK,jI*1.5*jJ);k2.lineTo(jI*2*jK,jI*0.5*jJ);k2.stroke();return k$.drawImage(k1,0,0);}function lq(lp,lo,lh){function ls(lr){var la=[0,0],lb=0,lc=99;if(!(lc<lb)){var ld=lb;for(;;){var le=h_(jI),lf=h_(jI),lg=h_(jI);if(caml_array_get(caml_array_get(caml_array_get(lh,le),lf),lg)){if(kc(lh,le+1|0,lf,lg)||kc(lh,le,lf+1|0,lg)||kc(lh,le,lf,lg+1|0))var li=0;else{caml_array_set(caml_array_get(caml_array_get(lh,le),lf),lg,0);var lj=1,li=1;}if(!li)var lj=0;}else{if(kc(lh,le-1|0,lf,lg)&&kc(lh,le,lf-1|0,lg)&&kc(lh,le,lf,lg-1|0)){caml_array_set(caml_array_get(caml_array_get(lh,le),lf),lg,1);var lj=1,lk=1;}else var lk=0;if(!lk)var lj=0;}var ll=lj?lj:la[1];la[1]=ll;var lm=ld+1|0;if(lc!==ld){var ld=lm;continue;}break;}}if(la[1])ln(lp,lo,lh);return lq(lp,lo,lh);}var lt=[0,[2,[0,1,0,0,0]]],lu=[0,0],lC=0.2;function lz(lv,lB){var lw=jC<lv?[0,jC,lv-jC]:[0,lv,0],lx=lw[2],lA=lw[1],ly=lx==0?a8(ji,lt):a8(lz,lx);lu[1]=[0,jA.setTimeout(caml_js_wrap_callback(ly),lA*1e3)];return 0;}lz(lC,0);function lF(lE){var lD=lu[1];return lD?jA.clearTimeout(lD[1]):0;}var lG=io(lt)[1];switch(lG[0]){case 1:var lH=lG[1][1]===ic?(iP(lF,0),1):0;break;case 2:var lI=lG[1],lJ=[0,id[1],lF],lK=lI[4],lL=typeof lK==="number"?lJ:[2,lJ,lK];lI[4]=lL;var lH=1;break;default:var lH=0;}var lM=io(lt),lN=lM[1];switch(lN[0]){case 1:var lO=[0,lN];break;case 2:var lP=lN[1],lQ=[0,[2,[0,[0,[0,lM]],0,0,0]]],lS=id[1],ma=[1,function(lR){switch(lR[0]){case 0:var lT=lR[1];id[1]=lS;try {var lU=ls(lT),lV=lU;}catch(lW){var lV=[0,[1,lW]];}var lX=io(lQ),lY=io(lV),lZ=lX[1];{if(2===lZ[0]){var l0=lZ[1];if(lX===lY)var l1=0;else{var l2=lY[1];if(2===l2[0]){var l3=l2[1];lY[1]=[3,lX];l0[1]=l3[1];var l4=jg(l0[2],l3[2]),l5=l0[3]+l3[3]|0;if(im<l5){l0[3]=0;l0[2]=jd(l4);}else{l0[3]=l5;l0[2]=l4;}var l6=l3[4],l7=l0[4],l8=typeof l7==="number"?l6:typeof l6==="number"?l7:[2,l7,l6];l0[4]=l8;var l1=0;}else{lX[1]=l2;var l1=iV(l0,l2);}}return l1;}throw [0,c,t];}case 1:var l9=io(lQ),l_=l9[1];{if(2===l_[0]){var l$=l_[1];l9[1]=lR;return iV(l$,lR);}throw [0,c,u];}default:throw [0,c,w];}}],mb=lP[2],mc=typeof mb==="number"?ma:[2,ma,mb];lP[2]=mc;var lO=lQ;break;case 3:throw [0,c,v];default:var lO=ls(lN[1]);}return lO;}function mm(ml){var me=md(0),mf=md(0);jA.document.body.appendChild(me);var mg=me.getContext(jz);mg.globalCompositeOperation=m.toString();var mh=1,mk=bc(jI,function(mj){return bc(jI,function(mi){return caml_make_vect(jI,mh);});});ln(mg,mf,mk);lq(mg,mf,mk);return ju;}jA.onload=caml_js_wrap_callback(function(mn){if(mn){var mo=mm(mn);if(!(mo|0))mn.preventDefault();return mo;}var mp=event,mq=mm(mp);if(!(mq|0))mp.returnValue=mq;return mq;});a0(0);return;}());
