// This program was compiled from OCaml by js_of_ocaml 1.4
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (this.len == null) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_convert_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_convert_raw_backtrace' not implemented");
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_raw_backtrace' not implemented");
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
function caml_js_get_console () {
  var c = this.console?this.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_const_word_size () { return 32; }
function caml_raise_not_found () { caml_raise_constant(caml_global_data[7]); }
function caml_sys_getenv () { caml_raise_not_found (); }
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _hL_(_rB_,_rC_,_rD_,_rE_,_rF_,_rG_,_rH_)
     {return _rB_.length==6
              ?_rB_(_rC_,_rD_,_rE_,_rF_,_rG_,_rH_)
              :caml_call_gen(_rB_,[_rC_,_rD_,_rE_,_rF_,_rG_,_rH_]);}
    function _dC_(_rx_,_ry_,_rz_,_rA_)
     {return _rx_.length==3
              ?_rx_(_ry_,_rz_,_rA_)
              :caml_call_gen(_rx_,[_ry_,_rz_,_rA_]);}
    function _d7_(_ru_,_rv_,_rw_)
     {return _ru_.length==2?_ru_(_rv_,_rw_):caml_call_gen(_ru_,[_rv_,_rw_]);}
    function _bQ_(_rs_,_rt_)
     {return _rs_.length==1?_rs_(_rt_):caml_call_gen(_rs_,[_rt_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")],
     _e_=new MlString("File \"%s\", line %d, characters %d-%d: %s");
    caml_register_global(6,_c_);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _bq_=[0,new MlString("Out_of_memory")],
     _bp_=[0,new MlString("Match_failure")],
     _bo_=[0,new MlString("Stack_overflow")],
     _bn_=[0,new MlString("Undefined_recursive_module")],
     _bm_=new MlString("%.12g"),
     _bl_=new MlString("."),
     _bk_=new MlString("%d"),
     _bj_=new MlString("true"),
     _bi_=new MlString("false"),
     _bh_=new MlString("Pervasives.do_at_exit"),
     _bg_=new MlString("\\b"),
     _bf_=new MlString("\\t"),
     _be_=new MlString("\\n"),
     _bd_=new MlString("\\r"),
     _bc_=new MlString("\\\\"),
     _bb_=new MlString("\\'"),
     _ba_=new MlString("String.contains_from"),
     _a$_=new MlString("String.blit"),
     _a__=new MlString("String.sub"),
     _a9_=new MlString("Queue.Empty"),
     _a8_=new MlString("Buffer.add: cannot grow buffer"),
     _a7_=new MlString(""),
     _a6_=new MlString(""),
     _a5_=new MlString("%.12g"),
     _a4_=new MlString("\""),
     _a3_=new MlString("\""),
     _a2_=new MlString("'"),
     _a1_=new MlString("'"),
     _a0_=new MlString("nan"),
     _aZ_=new MlString("neg_infinity"),
     _aY_=new MlString("infinity"),
     _aX_=new MlString("."),
     _aW_=new MlString("printf: bad positional specification (0)."),
     _aV_=new MlString("%_"),
     _aU_=[0,new MlString("printf.ml"),143,8],
     _aT_=new MlString("'"),
     _aS_=new MlString("Printf: premature end of format string '"),
     _aR_=new MlString("'"),
     _aQ_=new MlString(" in format string '"),
     _aP_=new MlString(", at char number "),
     _aO_=new MlString("Printf: bad conversion %"),
     _aN_=new MlString("Sformat.index_of_int: negative argument "),
     _aM_=new MlString(""),
     _aL_=new MlString(", %s%s"),
     _aK_=[1,1],
     _aJ_=new MlString("%s\n"),
     _aI_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _aH_=new MlString("Raised at"),
     _aG_=new MlString("Re-raised at"),
     _aF_=new MlString("Raised by primitive operation at"),
     _aE_=new MlString("Called from"),
     _aD_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _aC_=new MlString("%s unknown location"),
     _aB_=new MlString("Out of memory"),
     _aA_=new MlString("Stack overflow"),
     _az_=new MlString("Pattern matching failed"),
     _ay_=new MlString("Assertion failed"),
     _ax_=new MlString("Undefined recursive module"),
     _aw_=new MlString("(%s%s)"),
     _av_=new MlString(""),
     _au_=new MlString(""),
     _at_=new MlString("(%s)"),
     _as_=new MlString("%d"),
     _ar_=new MlString("%S"),
     _aq_=new MlString("_"),
     _ap_=new MlString("OCAMLRUNPARAM"),
     _ao_=new MlString("CAMLRUNPARAM"),
     _an_=new MlString(""),
     _am_=[0,new MlString("src/core/lwt.ml"),814,20],
     _al_=[0,new MlString("src/core/lwt.ml"),816,8],
     _ak_=[0,new MlString("src/core/lwt.ml"),648,20],
     _aj_=[0,new MlString("src/core/lwt.ml"),651,8],
     _ai_=[0,new MlString("src/core/lwt.ml"),498,8],
     _ah_=[0,new MlString("src/core/lwt.ml"),487,9],
     _ag_=new MlString("Lwt.wakeup_result"),
     _af_=new MlString("Lwt.Canceled"),
     _ae_=new MlString("on"),
     _ad_=new MlString("\""),
     _ac_=new MlString(" name=\""),
     _ab_=new MlString("\""),
     _aa_=new MlString(" type=\""),
     _$_=new MlString("<"),
     ___=new MlString(">"),
     _Z_=new MlString(""),
     _Y_=new MlString("<input name=\"x\">"),
     _X_=new MlString("input"),
     _W_=new MlString("x"),
     _V_=new MlString("canvas"),
     _U_=new MlString("img"),
     _T_=new MlString("br"),
     _S_=new MlString("p"),
     _R_=new MlString("div"),
     _Q_=new MlString("label"),
     _P_=new MlString("input"),
     _O_=new MlString("select"),
     _N_=new MlString("option"),
     _M_=new MlString("mouseup"),
     _L_=new MlString("mousemove"),
     _K_=new MlString("2d"),
     _J_=new MlString("Dom_html.Canvas_not_available"),
     _I_=new MlString("Exception during Lwt.async: "),
     _H_=new MlString("lighter"),
     _G_=new MlString("copy"),
     _F_=new MlString("% 2.f"),
     _E_=new MlString(""),
     _D_=new MlString("controls"),
     _C_=new MlString("Click and drag mouse to rotate."),
     _B_=new MlString("Resume"),
     _A_=new MlString("Pause"),
     _z_=new MlString("Fixed position"),
     _y_=new MlString("Follow rotation"),
     _x_=new MlString("Reset orientation"),
     _w_=new MlString("Date:"),
     _v_=
      [0,
       new MlString("December solstice"),
       [0,new MlString("Equinox"),[0,new MlString("June solstice"),0]]],
     _u_=new MlString("Lighting"),
     _t_=new MlString("Clip"),
     _s_=new MlString("Frames per second: "),
     _r_=
      new
       MlString
       ("Credit: <a href='http://visibleearth.nasa.gov/'>Visual Earth</a>, Nasa"),
     _q_=[0,new MlString("planet.ml"),415,0],
     _p_=[0,new MlString("planet.ml"),416,0],
     _o_=[0,new MlString("planet.ml"),417,0],
     _n_=[0,new MlString("planet.ml"),418,0],
     _m_=new MlString("copy"),
     _l_=new MlString("checkbox"),
     _k_=new MlString("button"),
     v_j_=[254,0,0,1],
     _i_=new MlString("../planet/texture.jpg");
    function _h_(s_f_){throw [0,_a_,s_f_];}
    function _br_(s_g_){throw [0,_b_,s_g_];}
    function _by_(s1_bs_,s2_bu_)
     {var
       l1_bt_=s1_bs_.getLen(),
       l2_bv_=s2_bu_.getLen(),
       s_bw_=caml_create_string(l1_bt_+l2_bv_|0);
      caml_blit_string(s1_bs_,0,s_bw_,0,l1_bt_);
      caml_blit_string(s2_bu_,0,s_bw_,l1_bt_,l2_bv_);
      return s_bw_;}
    function string_of_int_bz_(n_bx_){return caml_format_int(_bk_,n_bx_);}
    var stderr_bA_=caml_ml_open_descriptor_out(2);
    function output_string_bI_(oc_bC_,s_bB_)
     {return caml_ml_output(oc_bC_,s_bB_,0,s_bB_.getLen());}
    function do_at_exit_bH_(param_bG_)
     {var param_bD_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_bD_)
         {var l_bE_=param_bD_[2];
          try {}catch(_bF_){}
          var param_bD_=l_bE_;
          continue;}
        return 0;}}
    caml_register_named_value(_bh_,do_at_exit_bH_);
    function _bM_(_bK_,_bJ_){return caml_ml_output_char(_bK_,_bJ_);}
    function _bX_(_bL_){return caml_ml_flush(_bL_);}
    function _bW_(f_bP_,a_bN_)
     {var l_bO_=a_bN_.length-1;
      if(0===l_bO_)return [0];
      var
       r_bR_=caml_make_vect(l_bO_,_bQ_(f_bP_,a_bN_[0+1])),
       _bS_=1,
       _bT_=l_bO_-1|0;
      if(!(_bT_<_bS_))
       {var i_bU_=_bS_;
        for(;;)
         {r_bR_[i_bU_+1]=_bQ_(f_bP_,a_bN_[i_bU_+1]);
          var _bV_=i_bU_+1|0;
          if(_bT_!==i_bU_){var i_bU_=_bV_;continue;}
          break;}}
      return r_bR_;}
    function _b__(n_bY_,c_b0_)
     {var s_bZ_=caml_create_string(n_bY_);
      caml_fill_string(s_bZ_,0,n_bY_,c_b0_);
      return s_bZ_;}
    function _b$_(s_b3_,ofs_b1_,len_b2_)
     {if(0<=ofs_b1_&&0<=len_b2_&&!((s_b3_.getLen()-len_b2_|0)<ofs_b1_))
       {var r_b4_=caml_create_string(len_b2_);
        caml_blit_string(s_b3_,ofs_b1_,r_b4_,0,len_b2_);
        return r_b4_;}
      return _br_(_a__);}
    function _ca_(s1_b7_,ofs1_b6_,s2_b9_,ofs2_b8_,len_b5_)
     {if
       (0<=
        len_b5_&&
        0<=
        ofs1_b6_&&
        !((s1_b7_.getLen()-len_b5_|0)<ofs1_b6_)&&
        0<=
        ofs2_b8_&&
        !((s2_b9_.getLen()-len_b5_|0)<ofs2_b8_))
       return caml_blit_string(s1_b7_,ofs1_b6_,s2_b9_,ofs2_b8_,len_b5_);
      return _br_(_a$_);}
    var
     _cb_=caml_sys_const_word_size(0),
     _cc_=caml_mul(_cb_/8|0,(1<<(_cb_-10|0))-1|0)-1|0,
     _cx_=252,
     _cw_=253,
     _cv_=[0,_a9_];
    function _cu_(n_cd_)
     {var
       n_ce_=1<=n_cd_?n_cd_:1,
       n_cf_=_cc_<n_ce_?_cc_:n_ce_,
       s_cg_=caml_create_string(n_cf_);
      return [0,s_cg_,0,n_cf_,s_cg_];}
    function _cy_(b_ch_){return _b$_(b_ch_[1],0,b_ch_[2]);}
    function _co_(b_ci_,more_ck_)
     {var new_len_cj_=[0,b_ci_[3]];
      for(;;)
       {if(new_len_cj_[1]<(b_ci_[2]+more_ck_|0))
         {new_len_cj_[1]=2*new_len_cj_[1]|0;continue;}
        if(_cc_<new_len_cj_[1])
         if((b_ci_[2]+more_ck_|0)<=_cc_)new_len_cj_[1]=_cc_;else _h_(_a8_);
        var new_buffer_cl_=caml_create_string(new_len_cj_[1]);
        _ca_(b_ci_[1],0,new_buffer_cl_,0,b_ci_[2]);
        b_ci_[1]=new_buffer_cl_;
        b_ci_[3]=new_len_cj_[1];
        return 0;}}
    function _cz_(b_cm_,c_cp_)
     {var pos_cn_=b_cm_[2];
      if(b_cm_[3]<=pos_cn_)_co_(b_cm_,1);
      b_cm_[1].safeSet(pos_cn_,c_cp_);
      b_cm_[2]=pos_cn_+1|0;
      return 0;}
    function _cA_(b_cs_,s_cq_)
     {var len_cr_=s_cq_.getLen(),new_position_ct_=b_cs_[2]+len_cr_|0;
      if(b_cs_[3]<new_position_ct_)_co_(b_cs_,len_cr_);
      _ca_(s_cq_,0,b_cs_[1],b_cs_[2],len_cr_);
      b_cs_[2]=new_position_ct_;
      return 0;}
    function index_of_int_cE_(i_cB_)
     {return 0<=i_cB_?i_cB_:_h_(_by_(_aN_,string_of_int_bz_(i_cB_)));}
    function add_int_index_cF_(i_cC_,idx_cD_)
     {return index_of_int_cE_(i_cC_+idx_cD_|0);}
    var _cG_=_bQ_(add_int_index_cF_,1);
    function _cN_(fmt_cH_){return _b$_(fmt_cH_,0,fmt_cH_.getLen());}
    function bad_conversion_cP_(sfmt_cI_,i_cJ_,c_cL_)
     {var
       _cK_=_by_(_aQ_,_by_(sfmt_cI_,_aR_)),
       _cM_=_by_(_aP_,_by_(string_of_int_bz_(i_cJ_),_cK_));
      return _br_(_by_(_aO_,_by_(_b__(1,c_cL_),_cM_)));}
    function bad_conversion_format_dI_(fmt_cO_,i_cR_,c_cQ_)
     {return bad_conversion_cP_(_cN_(fmt_cO_),i_cR_,c_cQ_);}
    function incomplete_format_dJ_(fmt_cS_)
     {return _br_(_by_(_aS_,_by_(_cN_(fmt_cS_),_aT_)));}
    function extract_format_de_(fmt_cT_,start_c1_,stop_c3_,widths_c5_)
     {function skip_positional_spec_c0_(start_cU_)
       {if
         ((fmt_cT_.safeGet(start_cU_)-48|0)<
          0||
          9<
          (fmt_cT_.safeGet(start_cU_)-48|0))
         return start_cU_;
        var i_cV_=start_cU_+1|0;
        for(;;)
         {var _cW_=fmt_cT_.safeGet(i_cV_);
          if(48<=_cW_)
           {if(!(58<=_cW_)){var _cY_=i_cV_+1|0,i_cV_=_cY_;continue;}
            var _cX_=0;}
          else
           if(36===_cW_){var _cZ_=i_cV_+1|0,_cX_=1;}else var _cX_=0;
          if(!_cX_)var _cZ_=start_cU_;
          return _cZ_;}}
      var
       start_c2_=skip_positional_spec_c0_(start_c1_+1|0),
       b_c4_=_cu_((stop_c3_-start_c2_|0)+10|0);
      _cz_(b_c4_,37);
      var l1_c6_=widths_c5_,l2_c7_=0;
      for(;;)
       {if(l1_c6_)
         {var
           l_c8_=l1_c6_[2],
           _c9_=[0,l1_c6_[1],l2_c7_],
           l1_c6_=l_c8_,
           l2_c7_=_c9_;
          continue;}
        var i_c__=start_c2_,widths_c$_=l2_c7_;
        for(;;)
         {if(i_c__<=stop_c3_)
           {var _da_=fmt_cT_.safeGet(i_c__);
            if(42===_da_)
             {if(widths_c$_)
               {var t_db_=widths_c$_[2];
                _cA_(b_c4_,string_of_int_bz_(widths_c$_[1]));
                var
                 i_dc_=skip_positional_spec_c0_(i_c__+1|0),
                 i_c__=i_dc_,
                 widths_c$_=t_db_;
                continue;}
              throw [0,_d_,_aU_];}
            _cz_(b_c4_,_da_);
            var _dd_=i_c__+1|0,i_c__=_dd_;
            continue;}
          return _cy_(b_c4_);}}}
    function extract_format_int_e__
     (conv_dk_,fmt_di_,start_dh_,stop_dg_,widths_df_)
     {var sfmt_dj_=extract_format_de_(fmt_di_,start_dh_,stop_dg_,widths_df_);
      if(78!==conv_dk_&&110!==conv_dk_)return sfmt_dj_;
      sfmt_dj_.safeSet(sfmt_dj_.getLen()-1|0,117);
      return sfmt_dj_;}
    function sub_format_dK_
     (incomplete_format_dr_,bad_conversion_format_dB_,conv_dG_,fmt_dl_,i_dF_)
     {var len_dm_=fmt_dl_.getLen();
      function sub_fmt_dD_(c_dn_,i_dA_)
       {var close_do_=40===c_dn_?41:125;
        function sub_dz_(j_dp_)
         {var j_dq_=j_dp_;
          for(;;)
           {if(len_dm_<=j_dq_)return _bQ_(incomplete_format_dr_,fmt_dl_);
            if(37===fmt_dl_.safeGet(j_dq_))
             {var _ds_=j_dq_+1|0;
              if(len_dm_<=_ds_)
               var _dt_=_bQ_(incomplete_format_dr_,fmt_dl_);
              else
               {var _du_=fmt_dl_.safeGet(_ds_),_dv_=_du_-40|0;
                if(_dv_<0||1<_dv_)
                 {var _dw_=_dv_-83|0;
                  if(_dw_<0||2<_dw_)
                   var _dx_=1;
                  else
                   switch(_dw_)
                    {case 1:var _dx_=1;break;
                     case 2:var _dy_=1,_dx_=0;break;
                     default:var _dy_=0,_dx_=0;}
                  if(_dx_){var _dt_=sub_dz_(_ds_+1|0),_dy_=2;}}
                else
                 var _dy_=0===_dv_?0:1;
                switch(_dy_)
                 {case 1:
                   var
                    _dt_=
                     _du_===close_do_
                      ?_ds_+1|0
                      :_dC_(bad_conversion_format_dB_,fmt_dl_,i_dA_,_du_);
                   break;
                  case 2:break;
                  default:var _dt_=sub_dz_(sub_fmt_dD_(_du_,_ds_+1|0)+1|0);}}
              return _dt_;}
            var _dE_=j_dq_+1|0,j_dq_=_dE_;
            continue;}}
        return sub_dz_(i_dA_);}
      return sub_fmt_dD_(conv_dG_,i_dF_);}
    function sub_format_for_printf_d__(conv_dH_)
     {return _dC_
              (sub_format_dK_,
               incomplete_format_dJ_,
               bad_conversion_format_dI_,
               conv_dH_);}
    function iter_on_format_args_eo_(fmt_dL_,add_conv_dW_,add_char_d6_)
     {var lim_dM_=fmt_dL_.getLen()-1|0;
      function scan_fmt_d8_(i_dN_)
       {var i_dO_=i_dN_;
        a:
        for(;;)
         {if(i_dO_<lim_dM_)
           {if(37===fmt_dL_.safeGet(i_dO_))
             {var skip_dP_=0,i_dQ_=i_dO_+1|0;
              for(;;)
               {if(lim_dM_<i_dQ_)
                 var _dR_=incomplete_format_dJ_(fmt_dL_);
                else
                 {var _dS_=fmt_dL_.safeGet(i_dQ_);
                  if(58<=_dS_)
                   {if(95===_dS_)
                     {var _dU_=i_dQ_+1|0,_dT_=1,skip_dP_=_dT_,i_dQ_=_dU_;
                      continue;}}
                  else
                   if(32<=_dS_)
                    switch(_dS_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _dV_=i_dQ_+1|0,i_dQ_=_dV_;continue;
                      case 10:
                       var _dX_=_dC_(add_conv_dW_,skip_dP_,i_dQ_,105),i_dQ_=_dX_;
                       continue;
                      default:var _dY_=i_dQ_+1|0,i_dQ_=_dY_;continue;}
                  var i_dZ_=i_dQ_;
                  c:
                  for(;;)
                   {if(lim_dM_<i_dZ_)
                     var _d0_=incomplete_format_dJ_(fmt_dL_);
                    else
                     {var _d1_=fmt_dL_.safeGet(i_dZ_);
                      if(126<=_d1_)
                       var _d2_=0;
                      else
                       switch(_d1_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,105),_d2_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,102),_d2_=1;break;
                         case 33:
                         case 37:
                         case 44:
                         case 64:var _d0_=i_dZ_+1|0,_d2_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,115),_d2_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,_d1_),_d2_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_d3_=i_dZ_+1|0;
                          if(lim_dM_<j_d3_)
                           {var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,105),_d2_=1;}
                          else
                           {var _d4_=fmt_dL_.safeGet(j_d3_)-88|0;
                            if(_d4_<0||32<_d4_)
                             var _d5_=1;
                            else
                             switch(_d4_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _d0_=
                                  _d7_
                                   (add_char_d6_,_dC_(add_conv_dW_,skip_dP_,i_dZ_,_d1_),105),
                                 _d2_=1,
                                 _d5_=0;
                                break;
                               default:var _d5_=1;}
                            if(_d5_)
                             {var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,105),_d2_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,99),_d2_=1;break;
                         case 66:
                         case 98:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,66),_d2_=1;break;
                         case 41:
                         case 125:
                          var _d0_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,_d1_),_d2_=1;
                          break;
                         case 40:
                          var
                           _d0_=scan_fmt_d8_(_dC_(add_conv_dW_,skip_dP_,i_dZ_,_d1_)),
                           _d2_=1;
                          break;
                         case 123:
                          var
                           i_d9_=_dC_(add_conv_dW_,skip_dP_,i_dZ_,_d1_),
                           j_d$_=_dC_(sub_format_for_printf_d__,_d1_,fmt_dL_,i_d9_),
                           i_ea_=i_d9_;
                          for(;;)
                           {if(i_ea_<(j_d$_-2|0))
                             {var
                               _eb_=_d7_(add_char_d6_,i_ea_,fmt_dL_.safeGet(i_ea_)),
                               i_ea_=_eb_;
                              continue;}
                            var _ec_=j_d$_-1|0,i_dZ_=_ec_;
                            continue c;}
                         default:var _d2_=0;}
                      if(!_d2_)
                       var _d0_=bad_conversion_format_dI_(fmt_dL_,i_dZ_,_d1_);}
                    var _dR_=_d0_;
                    break;}}
                var i_dO_=_dR_;
                continue a;}}
            var _ed_=i_dO_+1|0,i_dO_=_ed_;
            continue;}
          return i_dO_;}}
      scan_fmt_d8_(0);
      return 0;}
    function count_printing_arguments_of_format_gn_(fmt_ep_)
     {var ac_ee_=[0,0,0,0];
      function add_conv_en_(skip_ej_,i_ek_,c_ef_)
       {var _eg_=41!==c_ef_?1:0,_eh_=_eg_?125!==c_ef_?1:0:_eg_;
        if(_eh_)
         {var inc_ei_=97===c_ef_?2:1;
          if(114===c_ef_)ac_ee_[3]=ac_ee_[3]+1|0;
          if(skip_ej_)
           ac_ee_[2]=ac_ee_[2]+inc_ei_|0;
          else
           ac_ee_[1]=ac_ee_[1]+inc_ei_|0;}
        return i_ek_+1|0;}
      iter_on_format_args_eo_
       (fmt_ep_,add_conv_en_,function(i_el_,param_em_){return i_el_+1|0;});
      return ac_ee_[1];}
    function scan_positional_spec_e6_(fmt_eq_,got_spec_et_,i_er_)
     {var _es_=fmt_eq_.safeGet(i_er_);
      if((_es_-48|0)<0||9<(_es_-48|0))return _d7_(got_spec_et_,0,i_er_);
      var accu_eu_=_es_-48|0,j_ev_=i_er_+1|0;
      for(;;)
       {var _ew_=fmt_eq_.safeGet(j_ev_);
        if(48<=_ew_)
         {if(!(58<=_ew_))
           {var
             _ez_=j_ev_+1|0,
             _ey_=(10*accu_eu_|0)+(_ew_-48|0)|0,
             accu_eu_=_ey_,
             j_ev_=_ez_;
            continue;}
          var _ex_=0;}
        else
         if(36===_ew_)
          if(0===accu_eu_)
           {var _eA_=_h_(_aW_),_ex_=1;}
          else
           {var
             _eA_=
              _d7_(got_spec_et_,[0,index_of_int_cE_(accu_eu_-1|0)],j_ev_+1|0),
             _ex_=1;}
         else
          var _ex_=0;
        if(!_ex_)var _eA_=_d7_(got_spec_et_,0,i_er_);
        return _eA_;}}
    function next_index_e1_(spec_eB_,n_eC_)
     {return spec_eB_?n_eC_:_bQ_(_cG_,n_eC_);}
    function get_index_eQ_(spec_eD_,n_eE_){return spec_eD_?spec_eD_[1]:n_eE_;}
    function _hK_
     (to_s_gI_,get_out_eG_,outc_gU_,outs_eJ_,flush_gs_,k_g0_,fmt_eF_)
     {var out_eH_=_bQ_(get_out_eG_,fmt_eF_);
      function outs_gJ_(s_eI_){return _d7_(outs_eJ_,out_eH_,s_eI_);}
      function pr_gr_(k_eO_,n_gZ_,fmt_eK_,v_eT_)
       {var len_eN_=fmt_eK_.getLen();
        function doprn_go_(n_gR_,i_eL_)
         {var i_eM_=i_eL_;
          for(;;)
           {if(len_eN_<=i_eM_)return _bQ_(k_eO_,out_eH_);
            var _eP_=fmt_eK_.safeGet(i_eM_);
            if(37===_eP_)
             {var
               get_arg_eX_=
                function(spec_eS_,n_eR_)
                 {return caml_array_get(v_eT_,get_index_eQ_(spec_eS_,n_eR_));},
               scan_flags_e3_=
                function(spec_e5_,n_eY_,widths_e0_,i_eU_)
                 {var i_eV_=i_eU_;
                  for(;;)
                   {var _eW_=fmt_eK_.safeGet(i_eV_)-32|0;
                    if(!(_eW_<0||25<_eW_))
                     switch(_eW_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_e6_
                                (fmt_eK_,
                                 function(wspec_eZ_,i_e4_)
                                  {var _e2_=[0,get_arg_eX_(wspec_eZ_,n_eY_),widths_e0_];
                                   return scan_flags_e3_
                                           (spec_e5_,next_index_e1_(wspec_eZ_,n_eY_),_e2_,i_e4_);},
                                 i_eV_+1|0);
                       default:var _e7_=i_eV_+1|0,i_eV_=_e7_;continue;}
                    var _e8_=fmt_eK_.safeGet(i_eV_);
                    if(124<=_e8_)
                     var _e9_=0;
                    else
                     switch(_e8_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_e$_=get_arg_eX_(spec_e5_,n_eY_),
                         s_fa_=
                          caml_format_int
                           (extract_format_int_e__(_e8_,fmt_eK_,i_eM_,i_eV_,widths_e0_),
                            x_e$_),
                         _fc_=
                          cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_fa_,i_eV_+1|0),
                         _e9_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_fd_=get_arg_eX_(spec_e5_,n_eY_),
                         s_fe_=
                          caml_format_float
                           (extract_format_de_(fmt_eK_,i_eM_,i_eV_,widths_e0_),x_fd_),
                         _fc_=
                          cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_fe_,i_eV_+1|0),
                         _e9_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _ff_=fmt_eK_.safeGet(i_eV_+1|0)-88|0;
                        if(_ff_<0||32<_ff_)
                         var _fg_=1;
                        else
                         switch(_ff_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_fh_=i_eV_+1|0,_fi_=_e8_-108|0;
                            if(_fi_<0||2<_fi_)
                             var _fj_=0;
                            else
                             {switch(_fi_)
                               {case 1:var _fj_=0,_fk_=0;break;
                                case 2:
                                 var
                                  x_fl_=get_arg_eX_(spec_e5_,n_eY_),
                                  _fm_=
                                   caml_format_int
                                    (extract_format_de_(fmt_eK_,i_eM_,i_fh_,widths_e0_),x_fl_),
                                  _fk_=1;
                                 break;
                                default:
                                 var
                                  x_fn_=get_arg_eX_(spec_e5_,n_eY_),
                                  _fm_=
                                   caml_format_int
                                    (extract_format_de_(fmt_eK_,i_eM_,i_fh_,widths_e0_),x_fn_),
                                  _fk_=1;}
                              if(_fk_){var s_fo_=_fm_,_fj_=1;}}
                            if(!_fj_)
                             {var
                               x_fp_=get_arg_eX_(spec_e5_,n_eY_),
                               s_fo_=
                                caml_int64_format
                                 (extract_format_de_(fmt_eK_,i_eM_,i_fh_,widths_e0_),x_fp_);}
                            var
                             _fc_=
                              cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_fo_,i_fh_+1|0),
                             _e9_=1,
                             _fg_=0;
                            break;
                           default:var _fg_=1;}
                        if(_fg_)
                         {var
                           x_fq_=get_arg_eX_(spec_e5_,n_eY_),
                           s_fr_=
                            caml_format_int
                             (extract_format_int_e__(110,fmt_eK_,i_eM_,i_eV_,widths_e0_),
                              x_fq_),
                           _fc_=
                            cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_fr_,i_eV_+1|0),
                           _e9_=1;}
                        break;
                       case 37:
                       case 64:
                        var _fc_=cont_s_fb_(n_eY_,_b__(1,_e8_),i_eV_+1|0),_e9_=1;
                        break;
                       case 83:
                       case 115:
                        var x_fs_=get_arg_eX_(spec_e5_,n_eY_);
                        if(115===_e8_)
                         var x_ft_=x_fs_;
                        else
                         {var n_fu_=[0,0],_fv_=0,_fw_=x_fs_.getLen()-1|0;
                          if(!(_fw_<_fv_))
                           {var i_fx_=_fv_;
                            for(;;)
                             {var
                               _fy_=x_fs_.safeGet(i_fx_),
                               _fz_=
                                14<=_fy_
                                 ?34===_fy_?1:92===_fy_?1:0
                                 :11<=_fy_?13<=_fy_?1:0:8<=_fy_?1:0,
                               _fA_=_fz_?2:caml_is_printable(_fy_)?1:4;
                              n_fu_[1]=n_fu_[1]+_fA_|0;
                              var _fB_=i_fx_+1|0;
                              if(_fw_!==i_fx_){var i_fx_=_fB_;continue;}
                              break;}}
                          if(n_fu_[1]===x_fs_.getLen())
                           var _fC_=x_fs_;
                          else
                           {var s__fD_=caml_create_string(n_fu_[1]);
                            n_fu_[1]=0;
                            var _fE_=0,_fF_=x_fs_.getLen()-1|0;
                            if(!(_fF_<_fE_))
                             {var i_fG_=_fE_;
                              for(;;)
                               {var _fH_=x_fs_.safeGet(i_fG_),_fI_=_fH_-34|0;
                                if(_fI_<0||58<_fI_)
                                 if(-20<=_fI_)
                                  var _fJ_=1;
                                 else
                                  {switch(_fI_+34|0)
                                    {case 8:
                                      s__fD_.safeSet(n_fu_[1],92);
                                      n_fu_[1]+=1;
                                      s__fD_.safeSet(n_fu_[1],98);
                                      var _fK_=1;
                                      break;
                                     case 9:
                                      s__fD_.safeSet(n_fu_[1],92);
                                      n_fu_[1]+=1;
                                      s__fD_.safeSet(n_fu_[1],116);
                                      var _fK_=1;
                                      break;
                                     case 10:
                                      s__fD_.safeSet(n_fu_[1],92);
                                      n_fu_[1]+=1;
                                      s__fD_.safeSet(n_fu_[1],110);
                                      var _fK_=1;
                                      break;
                                     case 13:
                                      s__fD_.safeSet(n_fu_[1],92);
                                      n_fu_[1]+=1;
                                      s__fD_.safeSet(n_fu_[1],114);
                                      var _fK_=1;
                                      break;
                                     default:var _fJ_=1,_fK_=0;}
                                   if(_fK_)var _fJ_=0;}
                                else
                                 var
                                  _fJ_=
                                   (_fI_-1|0)<0||56<(_fI_-1|0)
                                    ?(s__fD_.safeSet(n_fu_[1],92),
                                      n_fu_[1]+=
                                      1,
                                      s__fD_.safeSet(n_fu_[1],_fH_),
                                      0)
                                    :1;
                                if(_fJ_)
                                 if(caml_is_printable(_fH_))
                                  s__fD_.safeSet(n_fu_[1],_fH_);
                                 else
                                  {s__fD_.safeSet(n_fu_[1],92);
                                   n_fu_[1]+=1;
                                   s__fD_.safeSet(n_fu_[1],48+(_fH_/100|0)|0);
                                   n_fu_[1]+=1;
                                   s__fD_.safeSet(n_fu_[1],48+((_fH_/10|0)%10|0)|0);
                                   n_fu_[1]+=1;
                                   s__fD_.safeSet(n_fu_[1],48+(_fH_%10|0)|0);}
                                n_fu_[1]+=1;
                                var _fL_=i_fG_+1|0;
                                if(_fF_!==i_fG_){var i_fG_=_fL_;continue;}
                                break;}}
                            var _fC_=s__fD_;}
                          var x_ft_=_by_(_a3_,_by_(_fC_,_a4_));}
                        if(i_eV_===(i_eM_+1|0))
                         var s_fM_=x_ft_;
                        else
                         {var
                           _fN_=
                            extract_format_de_(fmt_eK_,i_eM_,i_eV_,widths_e0_);
                          try
                           {var neg_fO_=0,i_fP_=1;
                            for(;;)
                             {if(_fN_.getLen()<=i_fP_)
                               var _fQ_=[0,0,neg_fO_];
                              else
                               {var _fR_=_fN_.safeGet(i_fP_);
                                if(49<=_fR_)
                                 if(58<=_fR_)
                                  var _fS_=0;
                                 else
                                  {var
                                    _fQ_=
                                     [0,
                                      caml_int_of_string
                                       (_b$_(_fN_,i_fP_,(_fN_.getLen()-i_fP_|0)-1|0)),
                                      neg_fO_],
                                    _fS_=1;}
                                else
                                 {if(45===_fR_)
                                   {var _fU_=i_fP_+1|0,_fT_=1,neg_fO_=_fT_,i_fP_=_fU_;
                                    continue;}
                                  var _fS_=0;}
                                if(!_fS_){var _fV_=i_fP_+1|0,i_fP_=_fV_;continue;}}
                              var match_fW_=_fQ_;
                              break;}}
                          catch(_fX_)
                           {if(_fX_[1]!==_a_)throw _fX_;
                            var match_fW_=bad_conversion_cP_(_fN_,0,115);}
                          var
                           p_fY_=match_fW_[1],
                           _fZ_=x_ft_.getLen(),
                           _f0_=0,
                           neg_f4_=match_fW_[2],
                           _f3_=32;
                          if(p_fY_===_fZ_&&0===_f0_)
                           {var _f1_=x_ft_,_f2_=1;}
                          else
                           var _f2_=0;
                          if(!_f2_)
                           if(p_fY_<=_fZ_)
                            var _f1_=_b$_(x_ft_,_f0_,_fZ_);
                           else
                            {var res_f5_=_b__(p_fY_,_f3_);
                             if(neg_f4_)
                              _ca_(x_ft_,_f0_,res_f5_,0,_fZ_);
                             else
                              _ca_(x_ft_,_f0_,res_f5_,p_fY_-_fZ_|0,_fZ_);
                             var _f1_=res_f5_;}
                          var s_fM_=_f1_;}
                        var
                         _fc_=
                          cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_fM_,i_eV_+1|0),
                         _e9_=1;
                        break;
                       case 67:
                       case 99:
                        var x_f6_=get_arg_eX_(spec_e5_,n_eY_);
                        if(99===_e8_)
                         var s_f7_=_b__(1,x_f6_);
                        else
                         {if(39===x_f6_)
                           var _f8_=_bb_;
                          else
                           if(92===x_f6_)
                            var _f8_=_bc_;
                           else
                            {if(14<=x_f6_)
                              var _f9_=0;
                             else
                              switch(x_f6_)
                               {case 8:var _f8_=_bg_,_f9_=1;break;
                                case 9:var _f8_=_bf_,_f9_=1;break;
                                case 10:var _f8_=_be_,_f9_=1;break;
                                case 13:var _f8_=_bd_,_f9_=1;break;
                                default:var _f9_=0;}
                             if(!_f9_)
                              if(caml_is_printable(x_f6_))
                               {var s_f__=caml_create_string(1);
                                s_f__.safeSet(0,x_f6_);
                                var _f8_=s_f__;}
                              else
                               {var s_f$_=caml_create_string(4);
                                s_f$_.safeSet(0,92);
                                s_f$_.safeSet(1,48+(x_f6_/100|0)|0);
                                s_f$_.safeSet(2,48+((x_f6_/10|0)%10|0)|0);
                                s_f$_.safeSet(3,48+(x_f6_%10|0)|0);
                                var _f8_=s_f$_;}}
                          var s_f7_=_by_(_a1_,_by_(_f8_,_a2_));}
                        var
                         _fc_=
                          cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_f7_,i_eV_+1|0),
                         _e9_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _gb_=i_eV_+1|0,
                         _ga_=get_arg_eX_(spec_e5_,n_eY_)?_bj_:_bi_,
                         _fc_=cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),_ga_,_gb_),
                         _e9_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_gc_=get_arg_eX_(spec_e5_,n_eY_),
                         i_gd_=_dC_(sub_format_for_printf_d__,_e8_,fmt_eK_,i_eV_+1|0);
                        if(123===_e8_)
                         {var
                           b_ge_=_cu_(xf_gc_.getLen()),
                           add_char_gi_=
                            function(i_gg_,c_gf_){_cz_(b_ge_,c_gf_);return i_gg_+1|0;};
                          iter_on_format_args_eo_
                           (xf_gc_,
                            function(skip_gh_,i_gk_,c_gj_)
                             {if(skip_gh_)_cA_(b_ge_,_aV_);else _cz_(b_ge_,37);
                              return add_char_gi_(i_gk_,c_gj_);},
                            add_char_gi_);
                          var
                           _gl_=_cy_(b_ge_),
                           _fc_=cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),_gl_,i_gd_),
                           _e9_=1;}
                        else
                         {var
                           _gm_=next_index_e1_(spec_e5_,n_eY_),
                           m_gp_=
                            add_int_index_cF_
                             (count_printing_arguments_of_format_gn_(xf_gc_),_gm_),
                           _fc_=
                            pr_gr_
                             (function(param_gq_){return doprn_go_(m_gp_,i_gd_);},
                              _gm_,
                              xf_gc_,
                              v_eT_),
                           _e9_=1;}
                        break;
                       case 33:
                        _bQ_(flush_gs_,out_eH_);
                        var _fc_=doprn_go_(n_eY_,i_eV_+1|0),_e9_=1;
                        break;
                       case 41:
                        var _fc_=cont_s_fb_(n_eY_,_a7_,i_eV_+1|0),_e9_=1;break;
                       case 44:
                        var _fc_=cont_s_fb_(n_eY_,_a6_,i_eV_+1|0),_e9_=1;break;
                       case 70:
                        var x_gt_=get_arg_eX_(spec_e5_,n_eY_);
                        if(0===widths_e0_)
                         var _gu_=_a5_;
                        else
                         {var
                           sfmt_gv_=
                            extract_format_de_(fmt_eK_,i_eM_,i_eV_,widths_e0_);
                          if(70===_e8_)sfmt_gv_.safeSet(sfmt_gv_.getLen()-1|0,103);
                          var _gu_=sfmt_gv_;}
                        var _gw_=caml_classify_float(x_gt_);
                        if(3===_gw_)
                         var s_gx_=x_gt_<0?_aZ_:_aY_;
                        else
                         if(4<=_gw_)
                          var s_gx_=_a0_;
                         else
                          {var
                            _gy_=caml_format_float(_gu_,x_gt_),
                            i_gz_=0,
                            l_gA_=_gy_.getLen();
                           for(;;)
                            {if(l_gA_<=i_gz_)
                              var _gB_=_by_(_gy_,_aX_);
                             else
                              {var
                                _gC_=_gy_.safeGet(i_gz_)-46|0,
                                _gD_=
                                 _gC_<0||23<_gC_
                                  ?55===_gC_?1:0
                                  :(_gC_-1|0)<0||21<(_gC_-1|0)?1:0;
                               if(!_gD_){var _gE_=i_gz_+1|0,i_gz_=_gE_;continue;}
                               var _gB_=_gy_;}
                             var s_gx_=_gB_;
                             break;}}
                        var
                         _fc_=
                          cont_s_fb_(next_index_e1_(spec_e5_,n_eY_),s_gx_,i_eV_+1|0),
                         _e9_=1;
                        break;
                       case 91:
                        var
                         _fc_=bad_conversion_format_dI_(fmt_eK_,i_eV_,_e8_),
                         _e9_=1;
                        break;
                       case 97:
                        var
                         printer_gF_=get_arg_eX_(spec_e5_,n_eY_),
                         n_gG_=_bQ_(_cG_,get_index_eQ_(spec_e5_,n_eY_)),
                         arg_gH_=get_arg_eX_(0,n_gG_),
                         _gL_=i_eV_+1|0,
                         _gK_=next_index_e1_(spec_e5_,n_gG_);
                        if(to_s_gI_)
                         outs_gJ_(_d7_(printer_gF_,0,arg_gH_));
                        else
                         _d7_(printer_gF_,out_eH_,arg_gH_);
                        var _fc_=doprn_go_(_gK_,_gL_),_e9_=1;
                        break;
                       case 114:
                        var
                         _fc_=bad_conversion_format_dI_(fmt_eK_,i_eV_,_e8_),
                         _e9_=1;
                        break;
                       case 116:
                        var
                         printer_gM_=get_arg_eX_(spec_e5_,n_eY_),
                         _gO_=i_eV_+1|0,
                         _gN_=next_index_e1_(spec_e5_,n_eY_);
                        if(to_s_gI_)
                         outs_gJ_(_bQ_(printer_gM_,0));
                        else
                         _bQ_(printer_gM_,out_eH_);
                        var _fc_=doprn_go_(_gN_,_gO_),_e9_=1;
                        break;
                       default:var _e9_=0;}
                    if(!_e9_)
                     var _fc_=bad_conversion_format_dI_(fmt_eK_,i_eV_,_e8_);
                    return _fc_;}},
               _gT_=i_eM_+1|0,
               _gQ_=0;
              return scan_positional_spec_e6_
                      (fmt_eK_,
                       function(spec_gS_,i_gP_)
                        {return scan_flags_e3_(spec_gS_,n_gR_,_gQ_,i_gP_);},
                       _gT_);}
            _d7_(outc_gU_,out_eH_,_eP_);
            var _gV_=i_eM_+1|0,i_eM_=_gV_;
            continue;}}
        function cont_s_fb_(n_gY_,s_gW_,i_gX_)
         {outs_gJ_(s_gW_);return doprn_go_(n_gY_,i_gX_);}
        return doprn_go_(n_gZ_,0);}
      var
       kpr_g1_=_d7_(pr_gr_,k_g0_,index_of_int_cE_(0)),
       _g2_=count_printing_arguments_of_format_gn_(fmt_eF_);
      if(_g2_<0||6<_g2_)
       {var
         loop_hd_=
          function(i_g3_,args_g9_)
           {if(_g2_<=i_g3_)
             {var
               a_g4_=caml_make_vect(_g2_,0),
               _g7_=
                function(i_g5_,arg_g6_)
                 {return caml_array_set(a_g4_,(_g2_-i_g5_|0)-1|0,arg_g6_);},
               i_g8_=0,
               param_g__=args_g9_;
              for(;;)
               {if(param_g__)
                 {var _g$_=param_g__[2],_ha_=param_g__[1];
                  if(_g$_)
                   {_g7_(i_g8_,_ha_);
                    var _hb_=i_g8_+1|0,i_g8_=_hb_,param_g__=_g$_;
                    continue;}
                  _g7_(i_g8_,_ha_);}
                return _d7_(kpr_g1_,fmt_eF_,a_g4_);}}
            return function(x_hc_)
             {return loop_hd_(i_g3_+1|0,[0,x_hc_,args_g9_]);};},
         _he_=loop_hd_(0,0);}
      else
       switch(_g2_)
        {case 1:
          var
           _he_=
            function(x_hg_)
             {var a_hf_=caml_make_vect(1,0);
              caml_array_set(a_hf_,0,x_hg_);
              return _d7_(kpr_g1_,fmt_eF_,a_hf_);};
          break;
         case 2:
          var
           _he_=
            function(x_hi_,y_hj_)
             {var a_hh_=caml_make_vect(2,0);
              caml_array_set(a_hh_,0,x_hi_);
              caml_array_set(a_hh_,1,y_hj_);
              return _d7_(kpr_g1_,fmt_eF_,a_hh_);};
          break;
         case 3:
          var
           _he_=
            function(x_hl_,y_hm_,z_hn_)
             {var a_hk_=caml_make_vect(3,0);
              caml_array_set(a_hk_,0,x_hl_);
              caml_array_set(a_hk_,1,y_hm_);
              caml_array_set(a_hk_,2,z_hn_);
              return _d7_(kpr_g1_,fmt_eF_,a_hk_);};
          break;
         case 4:
          var
           _he_=
            function(x_hp_,y_hq_,z_hr_,t_hs_)
             {var a_ho_=caml_make_vect(4,0);
              caml_array_set(a_ho_,0,x_hp_);
              caml_array_set(a_ho_,1,y_hq_);
              caml_array_set(a_ho_,2,z_hr_);
              caml_array_set(a_ho_,3,t_hs_);
              return _d7_(kpr_g1_,fmt_eF_,a_ho_);};
          break;
         case 5:
          var
           _he_=
            function(x_hu_,y_hv_,z_hw_,t_hx_,u_hy_)
             {var a_ht_=caml_make_vect(5,0);
              caml_array_set(a_ht_,0,x_hu_);
              caml_array_set(a_ht_,1,y_hv_);
              caml_array_set(a_ht_,2,z_hw_);
              caml_array_set(a_ht_,3,t_hx_);
              caml_array_set(a_ht_,4,u_hy_);
              return _d7_(kpr_g1_,fmt_eF_,a_ht_);};
          break;
         case 6:
          var
           _he_=
            function(x_hA_,y_hB_,z_hC_,t_hD_,u_hE_,v_hF_)
             {var a_hz_=caml_make_vect(6,0);
              caml_array_set(a_hz_,0,x_hA_);
              caml_array_set(a_hz_,1,y_hB_);
              caml_array_set(a_hz_,2,z_hC_);
              caml_array_set(a_hz_,3,t_hD_);
              caml_array_set(a_hz_,4,u_hE_);
              caml_array_set(a_hz_,5,v_hF_);
              return _d7_(kpr_g1_,fmt_eF_,a_hz_);};
          break;
         default:var _he_=_d7_(kpr_g1_,fmt_eF_,[0]);}
      return _he_;}
    function _hY_(oc_hH_)
     {function _hJ_(_hG_){return 0;}
      return _hL_
              (_hK_,
               0,
               function(param_hI_){return oc_hH_;},
               _bM_,
               output_string_bI_,
               _bX_,
               _hJ_);}
    function _hU_(fmt_hM_){return _cu_(2*fmt_hM_.getLen()|0);}
    function _hR_(k_hP_,b_hN_)
     {var s_hO_=_cy_(b_hN_);b_hN_[2]=0;return _bQ_(k_hP_,s_hO_);}
    function _hX_(k_hQ_)
     {var _hT_=_bQ_(_hR_,k_hQ_);
      return _hL_(_hK_,1,_hU_,_cz_,_cA_,function(_hS_){return 0;},_hT_);}
    function _hZ_(fmt_hW_)
     {return _d7_(_hX_,function(s_hV_){return s_hV_;},fmt_hW_);}
    var _h0_=[0,0];
    function _ic_(x_h1_,i_h2_)
     {var f_h3_=x_h1_[i_h2_+1];
      if(caml_obj_is_block(f_h3_))
       {if(caml_obj_tag(f_h3_)===_cx_)return _d7_(_hZ_,_ar_,f_h3_);
        if(caml_obj_tag(f_h3_)===_cw_)
         {var _h4_=caml_format_float(_bm_,f_h3_),i_h5_=0,l_h6_=_h4_.getLen();
          for(;;)
           {if(l_h6_<=i_h5_)
             var _h7_=_by_(_h4_,_bl_);
            else
             {var
               _h8_=_h4_.safeGet(i_h5_),
               _h9_=48<=_h8_?58<=_h8_?0:1:45===_h8_?1:0;
              if(_h9_){var _h__=i_h5_+1|0,i_h5_=_h__;continue;}
              var _h7_=_h4_;}
            return _h7_;}}
        return _aq_;}
      return _d7_(_hZ_,_as_,f_h3_);}
    function _ib_(x_h$_,i_ia_)
     {if(x_h$_.length-1<=i_ia_)return _aM_;
      var _id_=_ib_(x_h$_,i_ia_+1|0);
      return _dC_(_hZ_,_aL_,_ic_(x_h$_,i_ia_),_id_);}
    function _iI_(x_if_)
     {var param_ie_=_h0_[1];
      for(;;)
       {if(param_ie_)
         {var tl_ik_=param_ie_[2],hd_ig_=param_ie_[1];
          try {var _ih_=_bQ_(hd_ig_,x_if_),_ii_=_ih_;}catch(_il_){var _ii_=0;}
          if(!_ii_){var param_ie_=tl_ik_;continue;}
          var _ij_=_ii_[1];}
        else
         if(x_if_[1]===_bq_)
          var _ij_=_aB_;
         else
          if(x_if_[1]===_bo_)
           var _ij_=_aA_;
          else
           if(x_if_[1]===_bp_)
            {var
              match_im_=x_if_[2],
              char_in_=match_im_[3],
              _ij_=
               _hL_
                (_hZ_,
                 _e_,
                 match_im_[1],
                 match_im_[2],
                 char_in_,
                 char_in_+5|0,
                 _az_);}
           else
            if(x_if_[1]===_d_)
             {var
               match_io_=x_if_[2],
               char_ip_=match_io_[3],
               _ij_=
                _hL_
                 (_hZ_,
                  _e_,
                  match_io_[1],
                  match_io_[2],
                  char_ip_,
                  char_ip_+6|0,
                  _ay_);}
            else
             if(x_if_[1]===_bn_)
              {var
                match_iq_=x_if_[2],
                char_ir_=match_iq_[3],
                _ij_=
                 _hL_
                  (_hZ_,
                   _e_,
                   match_iq_[1],
                   match_iq_[2],
                   char_ir_,
                   char_ir_+6|0,
                   _ax_);}
             else
              {var _is_=x_if_.length-1,constructor_iv_=x_if_[0+1][0+1];
               if(_is_<0||2<_is_)
                {var
                  _it_=_ib_(x_if_,2),
                  _iu_=_dC_(_hZ_,_aw_,_ic_(x_if_,1),_it_);}
               else
                switch(_is_)
                 {case 1:var _iu_=_au_;break;
                  case 2:var _iu_=_d7_(_hZ_,_at_,_ic_(x_if_,1));break;
                  default:var _iu_=_av_;}
               var _ij_=_by_(constructor_iv_,_iu_);}
        return _ij_;}}
    function _iJ_(outchan_iF_)
     {var
       _iw_=
        caml_convert_raw_backtrace(caml_get_exception_raw_backtrace(0));
      if(_iw_)
       {var a_ix_=_iw_[1],_iy_=0,_iz_=a_ix_.length-1-1|0;
        if(!(_iz_<_iy_))
         {var i_iA_=_iy_;
          for(;;)
           {if(caml_notequal(caml_array_get(a_ix_,i_iA_),_aK_))
             {var
               _iB_=caml_array_get(a_ix_,i_iA_),
               is_raise_iC_=0===_iB_[0]?_iB_[1]:_iB_[1],
               info_iD_=is_raise_iC_?0===i_iA_?_aH_:_aG_:0===i_iA_?_aF_:_aE_,
               _iE_=
                0===_iB_[0]
                 ?_hL_(_hZ_,_aD_,info_iD_,_iB_[2],_iB_[3],_iB_[4],_iB_[5])
                 :_d7_(_hZ_,_aC_,info_iD_);
              _dC_(_hY_,outchan_iF_,_aJ_,_iE_);}
            var _iG_=i_iA_+1|0;
            if(_iz_!==i_iA_){var i_iA_=_iG_;continue;}
            break;}}
        var _iH_=0;}
      else
       var _iH_=_d7_(_hY_,outchan_iF_,_aI_);
      return _iH_;}
    32===_cb_;
    try
     {var _iK_=caml_sys_getenv(_ap_),params_iL_=_iK_;}
    catch(_iM_)
     {if(_iM_[1]!==_c_)throw _iM_;
      try
       {var _iN_=caml_sys_getenv(_ao_),_iO_=_iN_;}
      catch(_iP_){if(_iP_[1]!==_c_)throw _iP_;var _iO_=_an_;}
      var params_iL_=_iO_;}
    var _iQ_=0,l_iR_=params_iL_.getLen(),_iU_=82;
    if(0<=_iQ_&&!(l_iR_<_iQ_))
     try
      {var i_iT_=_iQ_;
       for(;;)
        {if(l_iR_<=i_iT_)throw [0,_c_];
         if(params_iL_.safeGet(i_iT_)!==_iU_)
          {var _iV_=i_iT_+1|0,i_iT_=_iV_;continue;}
         var _iS_=1;
         break;}}
     catch(_iW_){if(_iW_[1]!==_c_)throw _iW_;var _iS_=1;}
    else
     var _iS_=0;
    if(!_iS_)_br_(_ba_);
    function _iZ_(param_iY_)
     {var seq_iX_=[];
      caml_update_dummy(seq_iX_,[0,seq_iX_,seq_iX_]);
      return seq_iX_;}
    var Canceled_i0_=[0,_af_],current_data_i1_=[0,0],max_removed_i9_=42;
    function repr_rec_i5_(t_i2_)
     {var _i3_=t_i2_[1];
      {if(3===_i3_[0])
        {var t__i4_=_i3_[1],t___i6_=repr_rec_i5_(t__i4_);
         if(t___i6_!==t__i4_)t_i2_[1]=[3,t___i6_];
         return t___i6_;}
       return t_i2_;}}
    function repr_i__(t_i7_){return repr_rec_i5_(t_i7_);}
    var
     async_exception_hook_i$_=
      [0,
       function(exn_i8_)
        {_iI_(exn_i8_);
         caml_ml_output_char(stderr_bA_,10);
         _iJ_(stderr_bA_);
         do_at_exit_bH_(0);
         return caml_sys_exit(2);}];
    function call_unsafe_jz_(f_jb_,x_ja_)
     {try
       {var _jc_=_bQ_(f_jb_,x_ja_);}
      catch(_jd_){return _bQ_(async_exception_hook_i$_[1],_jd_);}
      return _jc_;}
    function run_waiters_rec_jo_(state_ji_,ws_je_,rem_jg_)
     {var ws_jf_=ws_je_,rem_jh_=rem_jg_;
      for(;;)
       if(typeof ws_jf_==="number")
        return run_waiters_rec_next_jj_(state_ji_,rem_jh_);
       else
        switch(ws_jf_[0])
         {case 1:
           _bQ_(ws_jf_[1],state_ji_);
           return run_waiters_rec_next_jj_(state_ji_,rem_jh_);
          case 2:
           var
            ws1_jk_=ws_jf_[1],
            _jl_=[0,ws_jf_[2],rem_jh_],
            ws_jf_=ws1_jk_,
            rem_jh_=_jl_;
           continue;
          default:
           var _jm_=ws_jf_[1][1];
           return _jm_
                   ?(_bQ_(_jm_[1],state_ji_),
                     run_waiters_rec_next_jj_(state_ji_,rem_jh_))
                   :run_waiters_rec_next_jj_(state_ji_,rem_jh_);}}
    function run_waiters_rec_next_jj_(state_jp_,rem_jn_)
     {return rem_jn_?run_waiters_rec_jo_(state_jp_,rem_jn_[1],rem_jn_[2]):0;}
    function run_cancel_handlers_rec_jB_(chs_jq_,rem_js_)
     {var chs_jr_=chs_jq_,rem_jt_=rem_js_;
      for(;;)
       if(typeof chs_jr_==="number")
        return run_cancel_handlers_rec_next_jv_(rem_jt_);
       else
        switch(chs_jr_[0])
         {case 1:
           var n_ju_=chs_jr_[1];
           if(n_ju_[4]){n_ju_[4]=0;n_ju_[1][2]=n_ju_[2];n_ju_[2][1]=n_ju_[1];}
           return run_cancel_handlers_rec_next_jv_(rem_jt_);
          case 2:
           var
            chs1_jw_=chs_jr_[1],
            _jx_=[0,chs_jr_[2],rem_jt_],
            chs_jr_=chs1_jw_,
            rem_jt_=_jx_;
           continue;
          default:
           var f_jy_=chs_jr_[2];
           current_data_i1_[1]=chs_jr_[1];
           call_unsafe_jz_(f_jy_,0);
           return run_cancel_handlers_rec_next_jv_(rem_jt_);}}
    function run_cancel_handlers_rec_next_jv_(rem_jA_)
     {return rem_jA_?run_cancel_handlers_rec_jB_(rem_jA_[1],rem_jA_[2]):0;}
    function unsafe_run_waiters_jF_(sleeper_jD_,state_jC_)
     {var
       _jE_=
        1===state_jC_[0]
         ?state_jC_[1][1]===Canceled_i0_
           ?(run_cancel_handlers_rec_jB_(sleeper_jD_[4],0),1)
           :0
         :0;
      
      return run_waiters_rec_jo_(state_jC_,sleeper_jD_[2],0);}
    var wakening_jG_=[0,0],_jH_=[0,0,0];
    function wakeup_kB_(t_jK_,v_jI_)
     {var _jJ_=[0,v_jI_],t_jL_=repr_rec_i5_(t_jK_),_jM_=t_jL_[1];
      switch(_jM_[0])
       {case 1:
         if(_jM_[1][1]===Canceled_i0_){var _jN_=0,_jO_=1;}else var _jO_=0;
         break;
        case 2:
         var sleeper_jP_=_jM_[1];
         t_jL_[1]=_jJ_;
         var
          snapshot_jQ_=current_data_i1_[1],
          already_wakening_jR_=wakening_jG_[1]?1:(wakening_jG_[1]=1,0);
         unsafe_run_waiters_jF_(sleeper_jP_,_jJ_);
         if(already_wakening_jR_)
          {current_data_i1_[1]=snapshot_jQ_;var _jS_=0;}
         else
          for(;;)
           {if(0!==_jH_[1])
             {if(0===_jH_[1])throw [0,_cv_];
              _jH_[1]=_jH_[1]-1|0;
              var tail_jT_=_jH_[2],head_jU_=tail_jT_[2];
              if(head_jU_===tail_jT_)_jH_[2]=0;else tail_jT_[2]=head_jU_[2];
              var _jV_=head_jU_[1];
              unsafe_run_waiters_jF_(_jV_[1],_jV_[2]);
              continue;}
            wakening_jG_[1]=0;
            current_data_i1_[1]=snapshot_jQ_;
            var _jS_=0;
            break;}
         var _jN_=_jS_,_jO_=1;
         break;
        default:var _jO_=0;}
      if(!_jO_)var _jN_=_br_(_ag_);
      return _jN_;}
    function append_j2_(l1_jW_,l2_jX_)
     {return typeof l1_jW_==="number"
              ?l2_jX_
              :typeof l2_jX_==="number"?l1_jW_:[2,l1_jW_,l2_jX_];}
    function cleanup_jZ_(ws_jY_)
     {if(typeof ws_jY_!=="number")
       switch(ws_jY_[0])
        {case 2:
          var l1_j0_=ws_jY_[1],_j1_=cleanup_jZ_(ws_jY_[2]);
          return append_j2_(cleanup_jZ_(l1_j0_),_j1_);
         case 1:break;
         default:if(!ws_jY_[1][1])return 0;}
      return ws_jY_;}
    function task_kC_(param_j4_)
     {var _j3_=[0,[2,[0,1,0,0,0]]];return [0,_j3_,_j3_];}
    function add_immutable_waiter_kz_(sleeper_j7_,waiter_j5_)
     {var
       _j6_=[1,waiter_j5_],
       _j8_=sleeper_j7_[2],
       _j9_=typeof _j8_==="number"?_j6_:[2,_j6_,_j8_];
      sleeper_j7_[2]=_j9_;
      return 0;}
    function bind_kD_(t_j__,f_kf_)
     {var t_j$_=repr_i__(t_j__),_ka_=t_j$_[1];
      switch(_ka_[0])
       {case 1:return [0,_ka_];
        case 2:
         var
          _kb_=[0,[2,[0,[0,[0,t_j$_]],0,0,0]]],
          sleeper_ky_=_ka_[1],
          data_kd_=current_data_i1_[1];
         add_immutable_waiter_kz_
          (sleeper_ky_,
           function(state_kc_)
            {switch(state_kc_[0])
              {case 0:
                var v_ke_=state_kc_[1];
                current_data_i1_[1]=data_kd_;
                try
                 {var _kg_=_bQ_(f_kf_,v_ke_),_kh_=_kg_;}
                catch(_ki_){var _kh_=[0,[1,_ki_]];}
                var
                 t1_kj_=repr_i__(_kb_),
                 t2_kk_=repr_i__(_kh_),
                 _kl_=t1_kj_[1];
                {if(2===_kl_[0])
                  {var sleeper1_km_=_kl_[1];
                   if(t1_kj_===t2_kk_)
                    var _kn_=0;
                   else
                    {var _ko_=t2_kk_[1];
                     if(2===_ko_[0])
                      {var sleeper2_kp_=_ko_[1];
                       t2_kk_[1]=[3,t1_kj_];
                       sleeper1_km_[1]=sleeper2_kp_[1];
                       var
                        waiters_kq_=append_j2_(sleeper1_km_[2],sleeper2_kp_[2]),
                        removed_kr_=sleeper1_km_[3]+sleeper2_kp_[3]|0;
                       if(max_removed_i9_<removed_kr_)
                        {sleeper1_km_[3]=0;
                         sleeper1_km_[2]=cleanup_jZ_(waiters_kq_);}
                       else
                        {sleeper1_km_[3]=removed_kr_;sleeper1_km_[2]=waiters_kq_;}
                       var
                        _ks_=sleeper2_kp_[4],
                        _kt_=sleeper1_km_[4],
                        _ku_=
                         typeof _kt_==="number"
                          ?_ks_
                          :typeof _ks_==="number"?_kt_:[2,_kt_,_ks_];
                       sleeper1_km_[4]=_ku_;
                       var _kn_=0;}
                     else
                      {t1_kj_[1]=_ko_;
                       var _kn_=unsafe_run_waiters_jF_(sleeper1_km_,_ko_);}}
                   return _kn_;}
                 throw [0,_d_,_ah_];}
               case 1:
                var t_kv_=repr_i__(_kb_),_kw_=t_kv_[1];
                {if(2===_kw_[0])
                  {var sleeper_kx_=_kw_[1];
                   t_kv_[1]=state_kc_;
                   return unsafe_run_waiters_jF_(sleeper_kx_,state_kc_);}
                 throw [0,_d_,_ai_];}
               default:throw [0,_d_,_ak_];}});
         return _kb_;
        case 3:throw [0,_d_,_aj_];
        default:return _bQ_(f_kf_,_ka_[1]);}}
    var
     pause_hook_kF_=[0,function(_kA_){return 0;}],
     _kE_=_iZ_(0),
     _kI_=[0,0],
     null_kN_=null,
     undefined_kO_=undefined,
     _true_kP_=true,
     _false_kQ_=false,
     array_constructor_kR_=Array,
     date_constr_kS_=Date;
    function _kU_(param_kM_)
     {var _kG_=1-(_kE_[2]===_kE_?1:0);
      if(_kG_)
       {var tmp_kH_=_iZ_(0);
        tmp_kH_[1][2]=_kE_[2];
        _kE_[2][1]=tmp_kH_[1];
        tmp_kH_[1]=_kE_[1];
        _kE_[1][2]=tmp_kH_;
        _kE_[1]=_kE_;
        _kE_[2]=_kE_;
        _kI_[1]=0;
        var curr_kJ_=tmp_kH_[2];
        for(;;)
         {var _kK_=curr_kJ_!==tmp_kH_?1:0;
          if(_kK_)
           {if(curr_kJ_[4])wakeup_kB_(curr_kJ_[3],0);
            var _kL_=curr_kJ_[2],curr_kJ_=_kL_;
            continue;}
          return _kK_;}}
      return _kG_;}
    function _kV_(e_kT_)
     {return e_kT_ instanceof array_constructor_kR_
              ?0
              :[0,new MlWrappedString(e_kT_.toString())];}
    _h0_[1]=[0,_kV_,_h0_[1]];
    function _kX_(_kW_){return _kW_;}
    function _li_(p_kY_,n_kZ_){p_kY_.appendChild(n_kZ_);return 0;}
    function _lj_(f_k1_)
     {return _kX_
              (caml_js_wrap_callback
                (function(e_k0_)
                  {if(e_k0_)
                    {var res_k2_=_bQ_(f_k1_,e_k0_);
                     if(!(res_k2_|0))e_k0_.preventDefault();
                     return res_k2_;}
                   var _k3_=event,res_k4_=_bQ_(f_k1_,_k3_);
                   if(!(res_k4_|0))_k3_.returnValue=res_k4_;
                   return res_k4_;}));}
    function _lk_(s_k5_){return s_k5_.toString();}
    function _ll_(e_k6_,typ_k7_,h_k__,capt_lf_)
     {if(e_k6_.addEventListener===undefined_kO_)
       {var
         ev_k8_=_ae_.toString().concat(typ_k7_),
         callback_ld_=
          function(e_k9_)
           {var _lc_=[0,h_k__,e_k9_,[0]];
            return _bQ_
                    (function(_lb_,_la_,_k$_)
                      {return caml_js_call(_lb_,_la_,_k$_);},
                     _lc_);};
        e_k6_.attachEvent(ev_k8_,callback_ld_);
        return function(param_le_)
         {return e_k6_.detachEvent(ev_k8_,callback_ld_);};}
      e_k6_.addEventListener(typ_k7_,h_k__,capt_lf_);
      return function(param_lg_)
       {return e_k6_.removeEventListener(typ_k7_,h_k__,capt_lf_);};}
    function _lm_(id_lh_){return _bQ_(id_lh_,0);}
    var
     mouseup_ln_=_lk_(_M_),
     mousemove_lp_=_lk_(_L_),
     _2d__lo_=_K_.toString(),
     window_lq_=this,
     document_lr_=window_lq_.document;
    function opt_iter_lz_(x_ls_,f_lt_){return x_ls_?_bQ_(f_lt_,x_ls_[1]):0;}
    function createElement_lw_(doc_lv_,name_lu_)
     {return doc_lv_.createElement(name_lu_.toString());}
    function unsafeCreateElement_lA_(doc_ly_,name_lx_)
     {return createElement_lw_(doc_ly_,name_lx_);}
    var createElementSyntax_lB_=[0,785140586];
    function unsafeCreateElementEx_lU_(_type_lC_,name_lD_,doc_lF_,elt_lE_)
     {for(;;)
       {if(0===_type_lC_&&0===name_lD_)
         return createElement_lw_(doc_lF_,elt_lE_);
        var _lG_=createElementSyntax_lB_[1];
        if(785140586===_lG_)
         {try
           {var
             el_lH_=document_lr_.createElement(_Y_.toString()),
             _lI_=_X_.toString(),
             _lJ_=el_lH_.tagName.toLowerCase()===_lI_?1:0,
             _lK_=_lJ_?el_lH_.name===_W_.toString()?1:0:_lJ_,
             _lL_=_lK_;}
          catch(_lN_){var _lL_=0;}
          var _lM_=_lL_?982028505:-1003883683;
          createElementSyntax_lB_[1]=_lM_;
          continue;}
        if(982028505<=_lG_)
         {var a_lO_=new array_constructor_kR_();
          a_lO_.push(_$_.toString(),elt_lE_.toString());
          opt_iter_lz_
           (_type_lC_,
            function(t_lP_)
             {a_lO_.push
               (_aa_.toString(),caml_js_html_escape(t_lP_),_ab_.toString());
              return 0;});
          opt_iter_lz_
           (name_lD_,
            function(n_lQ_)
             {a_lO_.push
               (_ac_.toString(),caml_js_html_escape(n_lQ_),_ad_.toString());
              return 0;});
          a_lO_.push(___.toString());
          return doc_lF_.createElement(a_lO_.join(_Z_.toString()));}
        var res_lR_=createElement_lw_(doc_lF_,elt_lE_);
        opt_iter_lz_(_type_lC_,function(t_lS_){return res_lR_.type=t_lS_;});
        opt_iter_lz_(name_lD_,function(n_lT_){return res_lR_.name=n_lT_;});
        return res_lR_;}}
    function createInput_l0_(_type_lX_,name_lW_,doc_lV_)
     {return unsafeCreateElementEx_lU_(_type_lX_,name_lW_,doc_lV_,_P_);}
    function createLabel_l1_(doc_lY_)
     {return unsafeCreateElement_lA_(doc_lY_,_Q_);}
    function createDiv_l2_(doc_lZ_)
     {return unsafeCreateElement_lA_(doc_lZ_,_R_);}
    var Canvas_not_available_l3_=[0,_J_];
    this.HTMLElement===undefined_kO_;
    var overflow_limit_l4_=2147483,_l6_=caml_js_get_console(0);
    pause_hook_kF_[1]=
    function(param_l5_)
     {return 1===param_l5_
              ?(window_lq_.setTimeout(caml_js_wrap_callback(_kU_),0),0)
              :0;};
    function _l8_(s_l7_){return _l6_.log(s_l7_.toString());}
    async_exception_hook_i$_[1]=
    function(exn_l9_){_l8_(_I_);_l8_(_iI_(exn_l9_));return _iJ_(stderr_bA_);};
    var
     width_l__=600,
     pi_l$_=4*Math.atan(1),
     obliquity_ma_=23.5*pi_l$_/180,
     gamma_mb_=2,
     dark_mc_=Math.pow(0.2,gamma_mb_),
     button_type_md_=_k_.toString();
    function toggle_button_m2_(txt1_mf_,txt2_mh_,action_ml_)
     {var
       state_me_=[0,0],
       txt1_mg_=txt1_mf_.toString(),
       txt2_mj_=txt2_mh_.toString(),
       b_mi_=createInput_l0_([0,button_type_md_],0,document_lr_);
      b_mi_.value=txt1_mg_;
      b_mi_.onclick=
      _lj_
       (function(param_mm_)
         {state_me_[1]=1-state_me_[1];
          var _mk_=state_me_[1]?txt2_mj_:txt1_mg_;
          b_mi_.value=_mk_;
          _bQ_(action_ml_,state_me_[1]);
          return _true_kP_;});
      return b_mi_;}
    function checkbox_m3_(txt_ms_,checked_mo_,action_mp_)
     {var b_mn_=createInput_l0_([0,_l_.toString()],0,document_lr_);
      b_mn_.checked=!!checked_mo_;
      b_mn_.onclick=
      _lj_
       (function(param_mq_)
         {_bQ_(action_mp_,b_mn_.checked|0);return _true_kP_;});
      var lab_mr_=createLabel_l1_(document_lr_);
      _li_(lab_mr_,b_mn_);
      _li_(lab_mr_,document_lr_.createTextNode(txt_ms_.toString()));
      return lab_mr_;}
    function vertex_mU_(x_mv_,y_mu_,z_mt_){return [254,x_mv_,y_mu_,z_mt_];}
    function vect_m4_(param_mx_,_mw_)
     {return [254,
              _mw_[1]-param_mx_[1],
              _mw_[2]-param_mx_[2],
              _mw_[3]-param_mx_[3]];}
    function matrix_vect_mul_mO_(m_mC_,param_my_)
     {var
       z_mz_=param_my_[3],
       y_mA_=param_my_[2],
       x_mB_=param_my_[1],
       r3_mD_=m_mC_[3],
       r2_mE_=m_mC_[2],
       r1_mF_=m_mC_[1];
      return [254,
              x_mB_*r1_mF_[1]+y_mA_*r1_mF_[2]+z_mz_*r1_mF_[3],
              x_mB_*r2_mE_[1]+y_mA_*r2_mE_[2]+z_mz_*r2_mE_[3],
              x_mB_*r3_mD_[1]+y_mA_*r3_mD_[2]+z_mz_*r3_mD_[3]];}
    function matrix_transp_mK_(m_mG_)
     {var r3_mH_=m_mG_[3],r2_mI_=m_mG_[2],r1_mJ_=m_mG_[1];
      return [0,
              [254,r1_mJ_[1],r2_mI_[1],r3_mH_[1]],
              [254,r1_mJ_[2],r2_mI_[2],r3_mH_[2]],
              [254,r1_mJ_[3],r2_mI_[3],r3_mH_[3]]];}
    function matrix_mul_m5_(m_mN_,m__mL_)
     {var
       m__mM_=matrix_transp_mK_(m__mL_),
       _mP_=matrix_vect_mul_mO_(m__mM_,m_mN_[3]),
       _mQ_=matrix_vect_mul_mO_(m__mM_,m_mN_[2]);
      return [0,matrix_vect_mul_mO_(m__mM_,m_mN_[1]),_mQ_,_mP_];}
    function xz_rotation_m6_(phi_mR_)
     {var
       cos_phi_mS_=Math.cos(phi_mR_),
       sin_phi_mT_=Math.sin(phi_mR_),
       _mV_=vertex_mU_(-sin_phi_mT_,0,cos_phi_mS_),
       _mW_=vertex_mU_(0,1,0);
      return [0,vertex_mU_(cos_phi_mS_,0,sin_phi_mT_),_mW_,_mV_];}
    function xy_rotation_m7_(phi_mX_)
     {var
       cos_phi_mY_=Math.cos(phi_mX_),
       sin_phi_mZ_=Math.sin(phi_mX_),
       _m0_=vertex_mU_(0,0,1),
       _m1_=vertex_mU_(-sin_phi_mZ_,cos_phi_mY_,0);
      return [0,vertex_mU_(cos_phi_mY_,sin_phi_mZ_,0),_m1_,_m0_];}
    var matrix_identity_m8_=xz_rotation_m6_(0);
    function face_nh_(v1_m$_,v2_m__,v3_m9_){return [0,v1_m$_,v2_m__,v3_m9_];}
    function create_canvas_ni_(w_nb_,h_nc_)
     {var c_na_=unsafeCreateElement_lA_(document_lr_,_V_);
      if(1-(c_na_.getContext==null_kN_?1:0))
       {c_na_.width=w_nb_;c_na_.height=h_nc_;return c_na_;}
      throw [0,Canvas_not_available_l3_];}
    function min_nj_(u_nd_,v_ne_){return u_nd_<v_ne_?u_nd_:v_ne_;}
    function max_nk_(u_nf_,v_ng_){return u_nf_<v_ng_?v_ng_:u_nf_;}
    var
     _nl_=8,
     _nm_=12,
     t_delta_nn_=pi_l$_/_nl_,
     n_no_=_nl_*_nm_|0,
     vertices_np_=caml_make_vect(n_no_+2|0,vertex_mU_(0,0,0)),
     faces_nq_=caml_make_vect(n_no_*2|0,face_nh_(0,0,0)),
     south_nr_=n_no_+1|0;
    caml_array_set(vertices_np_,n_no_,vertex_mU_(0,-1,0));
    caml_array_set(vertices_np_,south_nr_,vertex_mU_(0,1,0));
    var
     _ns_=0,
     _nt_=_nm_-1|0,
     p_delta_ny_=2*pi_l$_/_nm_,
     t_offset_nA_=(pi_l$_-t_delta_nn_)/2;
    if(!(_nt_<_ns_))
     {var i_nu_=_ns_;
      for(;;)
       {var _nv_=0,_nw_=_nl_-1|0;
        if(!(_nw_<_nv_))
         {var j_nx_=_nv_;
          for(;;)
           {var
             phi_nz_=i_nu_*p_delta_ny_,
             theta_nB_=j_nx_*t_delta_nn_-t_offset_nA_,
             k_nC_=(i_nu_*_nl_|0)+j_nx_|0;
            caml_array_set
             (vertices_np_,
              k_nC_,
              vertex_mU_
               (Math.cos(phi_nz_)*Math.cos(theta_nB_),
                Math.sin(theta_nB_),
                Math.sin(phi_nz_)*Math.cos(theta_nB_)));
            if(0===j_nx_)
             {caml_array_set
               (faces_nq_,
                2*k_nC_|0,
                face_nh_(n_no_,k_nC_,caml_mod(k_nC_+_nl_|0,n_no_)));
              caml_array_set
               (faces_nq_,
                (2*k_nC_|0)+1|0,
                face_nh_
                 (south_nr_,
                  caml_mod((k_nC_+(2*_nl_|0)|0)-1|0,n_no_),
                  (k_nC_+_nl_|0)-1|0));}
            else
             {caml_array_set
               (faces_nq_,
                2*k_nC_|0,
                face_nh_(k_nC_,caml_mod(k_nC_+_nl_|0,n_no_),k_nC_-1|0));
              caml_array_set
               (faces_nq_,
                (2*k_nC_|0)+1|0,
                face_nh_
                 (k_nC_-1|0,
                  caml_mod(k_nC_+_nl_|0,n_no_),
                  caml_mod((k_nC_+_nl_|0)-1|0,n_no_)));}
            var _nD_=j_nx_+1|0;
            if(_nw_!==j_nx_){var j_nx_=_nD_;continue;}
            break;}}
        var _nE_=i_nu_+1|0;
        if(_nt_!==i_nu_){var i_nu_=_nE_;continue;}
        break;}}
    var texture_rn_=_i_.toString();
    window_lq_.onload=
    _lj_
     (function(param_rr_)
       {function _re_(texture_nF_)
         {var
           w_nG_=texture_nF_.width,
           h_nH_=texture_nF_.height,
           canvas_nI_=create_canvas_ni_(w_nG_,h_nH_),
           ctx_nJ_=canvas_nI_.getContext(_2d__lo_),
           _nK_=h_nH_/8|0,
           _nL_=w_nG_/8|0,
           img_nM_=ctx_nJ_.getImageData(0,0,_nL_,_nK_),
           data_nN_=img_nM_.data,
           inv_gamma_n3_=1/gamma_mb_;
          function update_shadow_n7_(obliquity_nO_)
           {var
             _nP_=0,
             _nQ_=_nK_-1|0,
             cos_obl_nX_=Math.cos(obliquity_nO_),
             sin_obl_nW_=-Math.sin(obliquity_nO_);
            if(!(_nQ_<_nP_))
             {var j_nR_=_nP_;
              for(;;)
               {var _nS_=0,_nT_=(_nL_/2|0)-1|0;
                if(!(_nT_<_nS_))
                 {var i_nU_=_nS_;
                  for(;;)
                   {var
                     theta_nV_=(j_nR_/_nK_-0.5)*pi_l$_,
                     _nY_=
                      Math.cos(i_nU_/_nL_*2*pi_l$_)*
                      Math.cos(theta_nV_)*
                      cos_obl_nX_+
                      Math.sin(theta_nV_)*
                      sin_obl_nW_,
                     k_n1_=4*(i_nU_+j_nR_*_nL_)|0,
                     k__n0_=4*(_nL_-i_nU_+j_nR_*_nL_-1)|0,
                     c_nZ_=0<_nY_?dark_mc_:dark_mc_-_nY_*(1-dark_mc_)*1.2,
                     c_n2_=c_nZ_<=1?c_nZ_:1,
                     c_n4_=255-(255.99*Math.pow(c_n2_,inv_gamma_n3_)|0)|0;
                    data_nN_[k_n1_+3|0]=c_n4_;
                    data_nN_[k__n0_+3|0]=c_n4_;
                    var _n5_=i_nU_+1|0;
                    if(_nT_!==i_nU_){var i_nU_=_n5_;continue;}
                    break;}}
                var _n6_=j_nR_+1|0;
                if(_nQ_!==j_nR_){var j_nR_=_n6_;continue;}
                break;}}
            ctx_nJ_.putImageData(img_nM_,0,0);
            ctx_nJ_.globalCompositeOperation=_m_.toString();
            ctx_nJ_.save();
            ctx_nJ_.scale(8*(_nL_+2|0)/_nL_,8*(_nK_+2|0)/_nK_);
            ctx_nJ_.translate(-1,-1);
            ctx_nJ_.drawImage(canvas_nI_,0,0);
            return ctx_nJ_.restore();}
          update_shadow_n7_(obliquity_ma_);
          var
           w_n8_=texture_nF_.width,
           canvas__n9_=create_canvas_ni_(w_n8_,texture_nF_.height),
           ctx__n__=canvas__n9_.getContext(_2d__lo_),
           no_lighting_n$_=[0,0],
           canvas_oa_=create_canvas_ni_(width_l__,width_l__),
           canvas__ob_=create_canvas_ni_(width_l__,width_l__);
          _li_(document_lr_.body,canvas_oa_);
          var
           ctx_oc_=canvas_oa_.getContext(_2d__lo_),
           ctx__od_=canvas__ob_.getContext(_2d__lo_),
           r_oe_=width_l__/2,
           tw_of_=texture_nF_.width,
           th_og_=texture_nF_.height,
           uv_ok_=
            _bW_
             (function(v_oh_)
               {var
                 u_oi_=
                  (tw_of_-
                   Math.atan2(v_oh_[3],v_oh_[1])*
                   ((tw_of_/2-0.99)/pi_l$_)|
                   0)%
                  tw_of_,
                 v_oj_=th_og_/2+Math.asin(v_oh_[2])*((th_og_-0.99)/pi_l$_)|0;
                if(0<=u_oi_)
                 {if(u_oi_<tw_of_)
                   {if(0<=v_oj_)
                     {if(v_oj_<th_og_)return [0,u_oi_,v_oj_];throw [0,_d_,_n_];}
                    throw [0,_d_,_o_];}
                  throw [0,_d_,_p_];}
                throw [0,_d_,_q_];},
              vertices_np_),
           normals_pa_=
            _bW_
             (function(param_ol_)
               {var
                 v1_om_=caml_array_get(vertices_np_,param_ol_[1]),
                 v2_oo_=caml_array_get(vertices_np_,param_ol_[2]),
                 _on_=
                  vect_m4_(v1_om_,caml_array_get(vertices_np_,param_ol_[3])),
                 _op_=vect_m4_(v1_om_,v2_oo_),
                 z2_oq_=_on_[3],
                 y2_or_=_on_[2],
                 x2_os_=_on_[1],
                 z1_ot_=_op_[3],
                 y1_ou_=_op_[2],
                 x1_ov_=_op_[1];
                return [254,
                        y1_ou_*z2_oq_-y2_or_*z1_ot_,
                        z1_ot_*x2_os_-z2_oq_*x1_ov_,
                        x1_ov_*y2_or_-x2_os_*y1_ou_];},
              faces_nq_),
           paused_pb_=[0,0],
           follow_pc_=[0,0],
           lighting_pd_=[0,1],
           clipped_pe_=[0,1],
           obl_pf_=[0,obliquity_ma_],
           face_info_pg_=
            _bW_
             (function(f_ow_)
               {var
                 match_ox_=caml_array_get(uv_ok_,f_ow_[1]),
                 v1_oy_=match_ox_[2],
                 u1_oz_=match_ox_[1],
                 match_oA_=caml_array_get(uv_ok_,f_ow_[2]),
                 v2_oB_=match_oA_[2],
                 u2_oC_=match_oA_[1],
                 match_oD_=caml_array_get(uv_ok_,f_ow_[3]),
                 v3_oE_=match_oD_[2],
                 u3_oF_=match_oD_[1],
                 mid_oG_=tw_of_/2;
                if(u1_oz_==0)
                 {if(mid_oG_<u2_oC_||mid_oG_<u3_oF_)
                   var _oH_=1;
                  else
                   {var _oI_=0,_oH_=0;}
                  if(_oH_){var u1_oJ_=tw_of_-2,_oI_=1;}}
                else
                 var _oI_=0;
                if(!_oI_)var u1_oJ_=u1_oz_;
                if(u2_oC_==0)
                 {if(mid_oG_<u1_oJ_||mid_oG_<u3_oF_)
                   var _oK_=1;
                  else
                   {var _oL_=0,_oK_=0;}
                  if(_oK_){var u2_oM_=tw_of_-2,_oL_=1;}}
                else
                 var _oL_=0;
                if(!_oL_)var u2_oM_=u2_oC_;
                if(u3_oF_==0)
                 {if(mid_oG_<u2_oM_||mid_oG_<u1_oJ_)
                   var _oN_=1;
                  else
                   {var _oO_=0,_oN_=0;}
                  if(_oN_){var u3_oP_=tw_of_-2,_oO_=1;}}
                else
                 var _oO_=0;
                if(!_oO_)var u3_oP_=u3_oF_;
                var mth_oQ_=th_og_-2;
                if(v1_oy_==0||mth_oQ_<=v1_oy_)
                 var _oR_=0;
                else
                 {var u1_oS_=u1_oJ_,_oR_=1;}
                if(!_oR_)var u1_oS_=(u2_oM_+u3_oP_)/2;
                if(v2_oB_==0||mth_oQ_<=v2_oB_)
                 var _oT_=0;
                else
                 {var u2_oU_=u2_oM_,_oT_=1;}
                if(!_oT_)var u2_oU_=(u1_oS_+u3_oP_)/2;
                if(v3_oE_==0||mth_oQ_<=v3_oE_)
                 var _oV_=0;
                else
                 {var u3_oW_=u3_oP_,_oV_=1;}
                if(!_oV_)var u3_oW_=(u2_oU_+u1_oS_)/2;
                var
                 u1_oX_=max_nk_(1,u1_oS_),
                 u2_oY_=max_nk_(1,u2_oU_),
                 u3_oZ_=max_nk_(1,u3_oW_),
                 v1_o0_=max_nk_(1,v1_oy_),
                 v2_o1_=max_nk_(1,v2_oB_),
                 v3_o2_=max_nk_(1,v3_oE_),
                 du2_o3_=u2_oY_-u1_oX_,
                 du3_o4_=u3_oZ_-u1_oX_,
                 dv2_o5_=v2_o1_-v1_o0_,
                 dv3_o6_=v3_o2_-v1_o0_,
                 su_o7_=dv2_o5_*du3_o4_-dv3_o6_*du2_o3_,
                 sv_o8_=du2_o3_*dv3_o6_-du3_o4_*dv2_o5_,
                 u_o9_=max_nk_(0,min_nj_(u1_oX_,min_nj_(u2_oY_,u3_oZ_))-4),
                 v_o__=max_nk_(0,min_nj_(v1_o0_,min_nj_(v2_o1_,v3_o2_))-4),
                 u__o$_=
                  min_nj_(tw_of_,max_nk_(u1_oX_,max_nk_(u2_oY_,u3_oZ_))+4);
                return [0,
                        u1_oX_,
                        v1_o0_,
                        du2_o3_/su_o7_,
                        dv2_o5_/sv_o8_,
                        du3_o4_/su_o7_,
                        dv3_o6_/sv_o8_,
                        u_o9_,
                        v_o__,
                        u__o$_-u_o9_,
                        min_nj_(th_og_,max_nk_(v1_o0_,max_nk_(v2_o1_,v3_o2_))+4)-
                        v_o__];},
              faces_nq_),
           m_obliq_ph_=[0,xy_rotation_m7_(-obliquity_ma_)],
           m_pi_=[0,matrix_identity_m8_],
           phi_rot_pj_=[0,0],
           rateText_pk_=document_lr_.createTextNode(_E_.toString()),
           ctrl_pl_=createDiv_l2_(document_lr_);
          ctrl_pl_.className=_D_.toString();
          var d_pm_=createDiv_l2_(document_lr_);
          _li_(d_pm_,document_lr_.createTextNode(_C_.toString()));
          _li_(ctrl_pl_,d_pm_);
          var form_pn_=createDiv_l2_(document_lr_);
          function br_pq_(param_po_)
           {return unsafeCreateElement_lA_(document_lr_,_T_);}
          _li_
           (form_pn_,
            toggle_button_m2_
             (_A_,_B_,function(p_pp_){paused_pb_[1]=p_pp_;return 0;}));
          _li_(form_pn_,br_pq_(0));
          _li_
           (form_pn_,
            toggle_button_m2_
             (_y_,_z_,function(f_pr_){follow_pc_[1]=f_pr_;return 0;}));
          _li_(form_pn_,br_pq_(0));
          var b_ps_=createInput_l0_([0,button_type_md_],0,document_lr_);
          b_ps_.value=_x_.toString();
          b_ps_.onclick=
          _lj_
           (function(param_pt_)
             {m_pi_[1]=matrix_identity_m8_;
              phi_rot_pj_[1]=0;
              m_obliq_ph_[1]=xy_rotation_m7_(-obl_pf_[1]);
              return _true_kP_;});
          _li_(form_pn_,b_ps_);
          _li_(form_pn_,br_pq_(0));
          var lab_pu_=createLabel_l1_(document_lr_);
          _li_(lab_pu_,document_lr_.createTextNode(_w_.toString()));
          var
           _pv_=unsafeCreateElementEx_lU_(0,0,document_lr_,_O_),
           param_pw_=_v_;
          for(;;)
           {if(param_pw_)
             {var
               l_pz_=param_pw_[2],
               a_py_=param_pw_[1],
               _px_=unsafeCreateElement_lA_(document_lr_,_N_);
              _li_(_px_,document_lr_.createTextNode(a_py_.toString()));
              _pv_.add(_px_,null_kN_);
              var param_pw_=l_pz_;
              continue;}
            _pv_.onchange=
            _lj_
             (function(param_pC_)
               {var
                 _pA_=_pv_.selectedIndex,
                 o_pB_=0===_pA_?obliquity_ma_:1===_pA_?0:-obliquity_ma_;
                update_shadow_n7_(o_pB_);
                obl_pf_[1]=o_pB_;
                return _true_kP_;});
            _li_(lab_pu_,_pv_);
            _li_(form_pn_,lab_pu_);
            _li_(ctrl_pl_,form_pn_);
            var form_pD_=createDiv_l2_(document_lr_);
            _li_
             (form_pD_,
              checkbox_m3_
               (_u_,1,function(l_pE_){lighting_pd_[1]=l_pE_;return 0;}));
            _li_(form_pD_,br_pq_(0));
            _li_
             (form_pD_,
              checkbox_m3_
               (_t_,1,function(l_pF_){clipped_pe_[1]=l_pF_;return 0;}));
            _li_(form_pD_,br_pq_(0));
            _li_(form_pD_,document_lr_.createTextNode(_s_.toString()));
            _li_(form_pD_,rateText_pk_);
            _li_(ctrl_pl_,form_pD_);
            _li_(document_lr_.body,ctrl_pl_);
            var _pG_=unsafeCreateElement_lA_(document_lr_,_S_);
            _pG_.innerHTML=_r_.toString();
            _li_(document_lr_.body,_pG_);
            var mx_pH_=[0,0],my_pI_=[0,0];
            canvas_oa_.onmousedown=
            _lj_
             (function(ev_pJ_)
               {mx_pH_[1]=ev_pJ_.clientX;
                my_pI_[1]=ev_pJ_.clientY;
                var
                 c2_pW_=[0,null_kN_],
                 c1_pX_=
                  _ll_
                   (document_lr_,
                    mousemove_lp_,
                    _lj_
                     (function(ev_pK_)
                       {var
                         x_pL_=ev_pK_.clientX,
                         y_pM_=ev_pK_.clientY,
                         dx_pN_=x_pL_-mx_pH_[1]|0,
                         dy_pO_=y_pM_-my_pI_[1]|0;
                        if(0!==dy_pO_)
                         {var
                           _pP_=2*dy_pO_/width_l__,
                           cos_phi_pQ_=Math.cos(_pP_),
                           sin_phi_pR_=Math.sin(_pP_),
                           _pS_=m_pi_[1],
                           _pT_=vertex_mU_(0,-sin_phi_pR_,cos_phi_pQ_),
                           _pU_=vertex_mU_(0,cos_phi_pQ_,sin_phi_pR_);
                          m_pi_[1]=
                          matrix_mul_m5_([0,vertex_mU_(1,0,0),_pU_,_pT_],_pS_);}
                        if(0!==dx_pN_)
                         {var _pV_=m_pi_[1];
                          m_pi_[1]=
                          matrix_mul_m5_(xz_rotation_m6_(2*dx_pN_/width_l__),_pV_);}
                        mx_pH_[1]=x_pL_;
                        my_pI_[1]=y_pM_;
                        return _true_kP_;}),
                    _true_kP_);
                c2_pW_[1]=
                _kX_
                 (_ll_
                   (document_lr_,
                    mouseup_ln_,
                    _lj_
                     (function(param_pZ_)
                       {_lm_(c1_pX_);
                        var _pY_=c2_pW_[1];
                        if(_pY_!=null_kN_)_lm_(_pY_);
                        return _true_kP_;}),
                    _true_kP_));
                return _false_kQ_;});
            var
             ti_p0_=[0,new date_constr_kS_().getTime()],
             fps_p1_=[0,0],
             loop_qQ_=
              function(t_qK_,phi_p2_)
               {var rotation_p3_=xz_rotation_m6_(phi_p2_-phi_rot_pj_[1]);
                if(lighting_pd_[1])
                 {no_lighting_n$_[1]=0;
                  ctx__n__.drawImage(texture_nF_,0,0);
                  var
                   i_p4_=
                    (2*pi_l$_-phi_p2_%(2*pi_l$_))*w_n8_/2/pi_l$_%w_n8_|0;
                  ctx__n__.drawImage(canvas_nI_,i_p4_,0);
                  ctx__n__.drawImage(canvas_nI_,i_p4_-w_n8_,0);}
                else
                 if(!no_lighting_n$_[1])
                  {ctx__n__.drawImage(texture_nF_,0,0);no_lighting_n$_[1]=1;}
                var
                 _p5_=matrix_mul_m5_(m_obliq_ph_[1],rotation_p3_),
                 m_p6_=matrix_mul_m5_(m_pi_[1],_p5_),
                 _p8_=
                  _bW_
                   (function(v_p7_){return matrix_vect_mul_mO_(m_p6_,v_p7_);},
                    vertices_np_),
                 _p9_=matrix_vect_mul_mO_(matrix_transp_mK_(m_p6_),v_j_);
                ctx__od_.clearRect(0,0,width_l__,width_l__);
                ctx__od_.save();
                if(clipped_pe_[1])
                 {ctx__od_.beginPath();
                  ctx__od_.arc(r_oe_,r_oe_,r_oe_*0.95,0,-2*pi_l$_,_true_kP_);
                  ctx__od_.clip();}
                ctx__od_.setTransform(r_oe_-2,0,0,r_oe_-2,r_oe_,r_oe_);
                ctx__od_.globalCompositeOperation=_H_.toString();
                var _p__=0,_p$_=faces_nq_.length-1-1|0;
                if(!(_p$_<_p__))
                 {var i_qa_=_p__;
                  for(;;)
                   {var
                     _qb_=faces_nq_[i_qa_+1],
                     match_qc_=caml_array_get(_p8_,_qb_[1]),
                     y1_qd_=match_qc_[2],
                     x1_qe_=match_qc_[1],
                     match_qf_=caml_array_get(_p8_,_qb_[2]),
                     y2_qg_=match_qf_[2],
                     x2_qh_=match_qf_[1],
                     match_qi_=caml_array_get(_p8_,_qb_[3]),
                     y3_qj_=match_qi_[2],
                     x3_qk_=match_qi_[1],
                     _ql_=caml_array_get(normals_pa_,i_qa_);
                    if(0<=_ql_[1]*_p9_[1]+_ql_[2]*_p9_[2]+_ql_[3]*_p9_[3])
                     {ctx__od_.beginPath();
                      ctx__od_.moveTo(x1_qe_,y1_qd_);
                      ctx__od_.lineTo(x2_qh_,y2_qg_);
                      ctx__od_.lineTo(x3_qk_,y3_qj_);
                      ctx__od_.closePath();
                      ctx__od_.save();
                      ctx__od_.clip();
                      var
                       match_qm_=caml_array_get(face_info_pg_,i_qa_),
                       dv_qn_=match_qm_[10],
                       du_qo_=match_qm_[9],
                       v_qp_=match_qm_[8],
                       u_qq_=match_qm_[7],
                       dv3_qr_=match_qm_[6],
                       du3_qs_=match_qm_[5],
                       dv2_qt_=match_qm_[4],
                       du2_qu_=match_qm_[3],
                       v1_qv_=match_qm_[2],
                       u1_qw_=match_qm_[1],
                       dx2_qx_=x2_qh_-x1_qe_,
                       dx3_qy_=x3_qk_-x1_qe_,
                       dy2_qz_=y2_qg_-y1_qd_,
                       dy3_qA_=y3_qj_-y1_qd_,
                       a_qB_=dx2_qx_*dv3_qr_-dx3_qy_*dv2_qt_,
                       b_qC_=dx2_qx_*du3_qs_-dx3_qy_*du2_qu_,
                       d_qD_=dy2_qz_*dv3_qr_-dy3_qA_*dv2_qt_,
                       e_qE_=dy2_qz_*du3_qs_-dy3_qA_*du2_qu_;
                      ctx__od_.transform
                       (a_qB_,
                        d_qD_,
                        b_qC_,
                        e_qE_,
                        x1_qe_-a_qB_*u1_qw_-b_qC_*v1_qv_,
                        y1_qd_-d_qD_*u1_qw_-e_qE_*v1_qv_);
                      ctx__od_.drawImage
                       (canvas__n9_,
                        u_qq_,
                        v_qp_,
                        du_qo_,
                        dv_qn_,
                        u_qq_,
                        v_qp_,
                        du_qo_,
                        dv_qn_);
                      ctx__od_.restore();}
                    var _qF_=i_qa_+1|0;
                    if(_p$_!==i_qa_){var i_qa_=_qF_;continue;}
                    break;}}
                ctx__od_.restore();
                ctx_oc_.globalCompositeOperation=_G_.toString();
                ctx_oc_.drawImage(canvas__ob_,0,0);
                try {ctx_oc_.getImageData(0,0,1,1);}catch(_rc_){}
                var
                 t__qG_=new date_constr_kS_().getTime(),
                 hz_qH_=1e3/(t__qG_-ti_p0_[1]),
                 _qI_=fps_p1_[1]==0?hz_qH_:0.9*fps_p1_[1]+0.1*hz_qH_;
                fps_p1_[1]=_qI_;
                rateText_pk_.data=_d7_(_hZ_,_F_,fps_p1_[1]).toString();
                ti_p0_[1]=t__qG_;
                function _qT_(param_qR_)
                 {var
                   t__qJ_=new date_constr_kS_().getTime(),
                   dt_qL_=t__qJ_-t_qK_,
                   dt_qM_=dt_qL_<0?0:1e3<dt_qL_?0:dt_qL_,
                   angle_qN_=2*pi_l$_*dt_qM_/1e3/10,
                   _qO_=
                    paused_pb_[1]
                     ?0
                     :follow_pc_[1]?(phi_rot_pj_[1]=phi_rot_pj_[1]+angle_qN_,1):0;
                  
                  var _qP_=paused_pb_[1]?phi_p2_:phi_p2_+angle_qN_;
                  return loop_qQ_(t__qJ_,_qP_);}
                var
                 match_qS_=task_kC_(0),
                 t_qU_=match_qS_[1],
                 id_qV_=[0,0],
                 _q4_=0.01,
                 w_qZ_=match_qS_[2];
                function wait_q1_(d_qW_,param_q3_)
                 {var
                   match_qX_=
                    overflow_limit_l4_<d_qW_
                     ?[0,overflow_limit_l4_,d_qW_-overflow_limit_l4_]
                     :[0,d_qW_,0],
                   remain_qY_=match_qX_[2],
                   step_q2_=match_qX_[1],
                   cb_q0_=
                    remain_qY_==0
                     ?_bQ_(wakeup_kB_,w_qZ_)
                     :_bQ_(wait_q1_,remain_qY_);
                  id_qV_[1]=
                  [0,
                   window_lq_.setTimeout
                    (caml_js_wrap_callback(cb_q0_),step_q2_*1e3)];
                  return 0;}
                wait_q1_(_q4_,0);
                function _q7_(param_q6_)
                 {var _q5_=id_qV_[1];
                  return _q5_?window_lq_.clearTimeout(_q5_[1]):0;}
                var _q8_=repr_i__(t_qU_)[1];
                switch(_q8_[0])
                 {case 1:
                   var
                    _q9_=
                     _q8_[1][1]===Canceled_i0_?(call_unsafe_jz_(_q7_,0),1):0;
                   break;
                  case 2:
                   var
                    sleeper_q__=_q8_[1],
                    handler_q$_=[0,current_data_i1_[1],_q7_],
                    _ra_=sleeper_q__[4],
                    _rb_=typeof _ra_==="number"?handler_q$_:[2,handler_q$_,_ra_];
                   sleeper_q__[4]=_rb_;
                   var _q9_=1;
                   break;
                  default:var _q9_=0;}
                
                return bind_kD_(t_qU_,_qT_);};
            return loop_qQ_(new date_constr_kS_().getTime(),0);}}
        var _rd_=unsafeCreateElement_lA_(document_lr_,_U_);
        function _rh_(param_rf_){return [0,[0,_rd_]];}
        var match_rg_=task_kC_(0),w_rj_=match_rg_[2],t_rk_=match_rg_[1];
        function cont_rl_(x_ri_){return wakeup_kB_(w_rj_,x_ri_);}
        _rd_.onload=_lj_(function(param_rm_){cont_rl_(0);return _false_kQ_;});
        _rd_.src=texture_rn_;
        var _ro_=repr_i__(bind_kD_(bind_kD_(t_rk_,_rh_),_re_))[1];
        switch(_ro_[0])
         {case 1:throw _ro_[1];
          case 2:
           var sleeper_rq_=_ro_[1];
           add_immutable_waiter_kz_
            (sleeper_rq_,
             function(param_rp_)
              {switch(param_rp_[0])
                {case 0:return 0;
                 case 1:return _bQ_(async_exception_hook_i$_[1],param_rp_[1]);
                 default:throw [0,_d_,_am_];}});
           break;
          case 3:throw [0,_d_,_al_];
          default:}
        return _false_kQ_;});
    do_at_exit_bH_(0);
    return;}
  ());
