// This program was compiled from OCaml by js_of_ocaml 1.4
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (this.len == null) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_convert_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_convert_raw_backtrace' not implemented");
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_float_of_string(s) {
  var res;
  s = s.getFullBytes();
  res = +s;
  if ((s.length > 0) && (res === res)) return res;
  s = s.replace(/_/g,"");
  res = +s;
  if (((s.length > 0) && (res === res)) || /^[+-]?nan$/i.test(s)) return res;
  caml_failwith("float_of_string");
}
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_raw_backtrace' not implemented");
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_from_byte_string (s) {return s.getFullBytes();}
function caml_js_get_console () {
  var c = this.console?this.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
function caml_js_on_ie () {
  var ua = this.navigator?this.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_to_byte_string (s) {return new MlString (s);}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_const_word_size () { return 32; }
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _jH_(_wv_,_ww_,_wx_,_wy_,_wz_,_wA_,_wB_)
     {return _wv_.length==6
              ?_wv_(_ww_,_wx_,_wy_,_wz_,_wA_,_wB_)
              :caml_call_gen(_wv_,[_ww_,_wx_,_wy_,_wz_,_wA_,_wB_]);}
    function _fy_(_wr_,_ws_,_wt_,_wu_)
     {return _wr_.length==3
              ?_wr_(_ws_,_wt_,_wu_)
              :caml_call_gen(_wr_,[_ws_,_wt_,_wu_]);}
    function _f3_(_wo_,_wp_,_wq_)
     {return _wo_.length==2?_wo_(_wp_,_wq_):caml_call_gen(_wo_,[_wp_,_wq_]);}
    function _c6_(_wm_,_wn_)
     {return _wm_.length==1?_wm_(_wn_):caml_call_gen(_wm_,[_wn_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")],
     _e_=new MlString("File \"%s\", line %d, characters %d-%d: %s"),
     _f_=new MlString("monkey.model"),
     _g_=new MlString("canvas");
    caml_register_global(6,_c_);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _cD_=[0,new MlString("Out_of_memory")],
     _cC_=[0,new MlString("Match_failure")],
     _cB_=[0,new MlString("Stack_overflow")],
     _cA_=[0,new MlString("Undefined_recursive_module")],
     _cz_=new MlString("%.12g"),
     _cy_=new MlString("."),
     _cx_=new MlString("%d"),
     _cw_=new MlString("true"),
     _cv_=new MlString("false"),
     _cu_=new MlString("Pervasives.do_at_exit"),
     _ct_=new MlString("\\b"),
     _cs_=new MlString("\\t"),
     _cr_=new MlString("\\n"),
     _cq_=new MlString("\\r"),
     _cp_=new MlString("\\\\"),
     _co_=new MlString("\\'"),
     _cn_=new MlString(""),
     _cm_=new MlString("String.blit"),
     _cl_=new MlString("String.sub"),
     _ck_=new MlString("Queue.Empty"),
     _cj_=new MlString("Buffer.add: cannot grow buffer"),
     _ci_=new MlString(""),
     _ch_=new MlString(""),
     _cg_=new MlString("%.12g"),
     _cf_=new MlString("\""),
     _ce_=new MlString("\""),
     _cd_=new MlString("'"),
     _cc_=new MlString("'"),
     _cb_=new MlString("nan"),
     _ca_=new MlString("neg_infinity"),
     _b$_=new MlString("infinity"),
     _b__=new MlString("."),
     _b9_=new MlString("printf: bad positional specification (0)."),
     _b8_=new MlString("%_"),
     _b7_=[0,new MlString("printf.ml"),143,8],
     _b6_=new MlString("'"),
     _b5_=new MlString("Printf: premature end of format string '"),
     _b4_=new MlString("'"),
     _b3_=new MlString(" in format string '"),
     _b2_=new MlString(", at char number "),
     _b1_=new MlString("Printf: bad conversion %"),
     _b0_=new MlString("Sformat.index_of_int: negative argument "),
     _bZ_=new MlString(""),
     _bY_=new MlString(", %s%s"),
     _bX_=[1,1],
     _bW_=new MlString("%s\n"),
     _bV_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _bU_=new MlString("Raised at"),
     _bT_=new MlString("Re-raised at"),
     _bS_=new MlString("Raised by primitive operation at"),
     _bR_=new MlString("Called from"),
     _bQ_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _bP_=new MlString("%s unknown location"),
     _bO_=new MlString("Out of memory"),
     _bN_=new MlString("Stack overflow"),
     _bM_=new MlString("Pattern matching failed"),
     _bL_=new MlString("Assertion failed"),
     _bK_=new MlString("Undefined recursive module"),
     _bJ_=new MlString("(%s%s)"),
     _bI_=new MlString(""),
     _bH_=new MlString(""),
     _bG_=new MlString("(%s)"),
     _bF_=new MlString("%d"),
     _bE_=new MlString("%S"),
     _bD_=new MlString("_"),
     _bC_=[0,new MlString("src/core/lwt.ml"),692,20],
     _bB_=[0,new MlString("src/core/lwt.ml"),695,8],
     _bA_=[0,new MlString("src/core/lwt.ml"),670,20],
     _bz_=[0,new MlString("src/core/lwt.ml"),673,8],
     _by_=[0,new MlString("src/core/lwt.ml"),648,20],
     _bx_=[0,new MlString("src/core/lwt.ml"),651,8],
     _bw_=[0,new MlString("src/core/lwt.ml"),498,8],
     _bv_=[0,new MlString("src/core/lwt.ml"),487,9],
     _bu_=new MlString("Lwt.wakeup_result"),
     _bt_=new MlString("Lwt.Canceled"),
     state_return_unit_bs_=[0,0],
     _br_=new MlString("script"),
     _bq_=new MlString("canvas"),
     _bp_=new MlString("browser can't read file: unimplemented"),
     _bo_=new MlString("utf8"),
     _bn_=[0,new MlString("file.ml"),132,15],
     _bm_=new MlString("string"),
     _bl_=new MlString("can't retrieve file name: not implemented"),
     _bk_=new MlString("Exception during Lwt.async: "),
     _bj_=new MlString("\\$&"),
     _bi_=new MlString("$$$$"),
     _bh_=new MlString("g"),
     _bg_=new MlString("g"),
     _bf_=new MlString("[$]"),
     _be_=new MlString("[\\][()\\\\|+*.?{}^$]"),
     _bd_=[0,new MlString(""),0],
     _bc_=new MlString(""),
     _bb_=new MlString(""),
     _ba_=new MlString("#"),
     _a$_=new MlString(""),
     _a__=new MlString("?"),
     _a9_=new MlString(""),
     _a8_=new MlString("/"),
     _a7_=new MlString("/"),
     _a6_=new MlString(":"),
     _a5_=new MlString(""),
     _a4_=new MlString("http://"),
     _a3_=new MlString(""),
     _a2_=new MlString("#"),
     _a1_=new MlString(""),
     _a0_=new MlString("?"),
     _aZ_=new MlString(""),
     _aY_=new MlString("/"),
     _aX_=new MlString("/"),
     _aW_=new MlString(":"),
     _aV_=new MlString(""),
     _aU_=new MlString("https://"),
     _aT_=new MlString(""),
     _aS_=new MlString("#"),
     _aR_=new MlString(""),
     _aQ_=new MlString("?"),
     _aP_=new MlString(""),
     _aO_=new MlString("/"),
     _aN_=new MlString("file://"),
     _aM_=new MlString(""),
     _aL_=new MlString(""),
     _aK_=new MlString(""),
     _aJ_=new MlString(""),
     _aI_=new MlString(""),
     _aH_=new MlString(""),
     _aG_=new MlString("="),
     _aF_=new MlString("&"),
     _aE_=new MlString("file"),
     _aD_=new MlString("file:"),
     _aC_=new MlString("http"),
     _aB_=new MlString("http:"),
     _aA_=new MlString("https"),
     _az_=new MlString("https:"),
     _ay_=new MlString(" "),
     _ax_=new MlString("%2B"),
     _aw_=new MlString("Url.Local_exn"),
     _av_=new MlString("+"),
     _au_=new MlString("g"),
     _at_=new MlString("\\+"),
     _as_=new MlString("Url.Not_an_http_protocol"),
     _ar_=
      new
       MlString
       ("^([Hh][Tt][Tt][Pp][Ss]?)://([0-9a-zA-Z.-]+|\\[[0-9a-zA-Z.-]+\\]|\\[[0-9A-Fa-f:.]+\\])?(:([0-9]+))?/([^\\?#]*)(\\?([^#]*))?(#(.*))?$"),
     _aq_=
      new MlString("^([Ff][Ii][Ll][Ee])://([^\\?#]*)(\\?([^#]*))?(#(.*))?$"),
     _ap_=new MlString(""),
     _ao_=new MlString("POST"),
     _an_=new MlString("multipart/form-data; boundary="),
     _am_=new MlString("POST"),
     _al_=
      [0,
       new MlString("POST"),
       [0,new MlString("application/x-www-form-urlencoded")],
       126925477],
     _ak_=[0,new MlString("POST"),0,126925477],
     _aj_=new MlString("GET"),
     _ai_=new MlString("?"),
     _ah_=new MlString("Content-type"),
     _ag_=new MlString("="),
     _af_=new MlString("="),
     _ae_=new MlString("&"),
     _ad_=new MlString("Content-Type: application/octet-stream\r\n"),
     _ac_=new MlString("\"\r\n"),
     _ab_=new MlString("\"; filename=\""),
     _aa_=new MlString("Content-Disposition: form-data; name=\""),
     _$_=new MlString("\r\n"),
     ___=new MlString("\r\n"),
     _Z_=new MlString("\r\n"),
     _Y_=new MlString("--"),
     _X_=new MlString("\r\n"),
     _W_=new MlString("\"\r\n\r\n"),
     _V_=new MlString("Content-Disposition: form-data; name=\""),
     _U_=new MlString("--\r\n"),
     _T_=new MlString("--"),
     _S_=new MlString("js_of_ocaml-------------------"),
     _R_=new MlString("Msxml2.XMLHTTP"),
     _Q_=new MlString("Msxml3.XMLHTTP"),
     _P_=new MlString("Microsoft.XMLHTTP"),
     _O_=[0,new MlString("xmlHttpRequest.ml"),80,2],
     _N_=new MlString("XmlHttpRequest.Wrong_headers"),
     _M_=new MlString("webgl"),
     _L_=new MlString("experimental-webgl"),
     _K_=new MlString("uncaught exception: %s"),
     _J_=new MlString("%.1f"),
     _I_=new MlString("loading"),
     _H_=new MlString("fps"),
     _G_=new MlString("fragment-shader"),
     _F_=new MlString("vertex-shader"),
     _E_=new MlString("program loaded"),
     _D_=new MlString("u_proj"),
     _C_=new MlString("u_lightPos"),
     _B_=new MlString("u_ambientLight"),
     _A_=new MlString("a_position"),
     _z_=new MlString("a_normal"),
     _y_=new MlString("ready"),
     _x_=new MlString("\n"),
     _w_=[0,1,[0,2,[0,3,[0,4,0]]]],
     _v_=new MlString("f"),
     _u_=new MlString("v"),
     _t_=new MlString("vn"),
     _s_=[0,1,[0,2,0]],
     _r_=new MlString("can't find script element %s"),
     _q_=new MlString("Unable to link the shader program."),
     _p_=new MlString("An error occurred compiling the shaders: \n%s\n%s"),
     _o_=new MlString("can't initialise webgl context"),
     _n_=new MlString("can't find canvas element %s"),
     _m_=new MlString("WebGL error"),
     _l_=new MlString("(v|vn|f)\\ ([^\\ ]+)\\ ([^\\ ]+)\\ ([^\\ ]+)"),
     _k_=new MlString("([0-9]+)//([0-9]+)");
    function _j_(s_h_){throw [0,_a_,s_h_];}
    function _cE_(s_i_){throw [0,_b_,s_i_];}
    function _cP_(s1_cF_,s2_cH_)
     {var
       l1_cG_=s1_cF_.getLen(),
       l2_cI_=s2_cH_.getLen(),
       s_cJ_=caml_create_string(l1_cG_+l2_cI_|0);
      caml_blit_string(s1_cF_,0,s_cJ_,0,l1_cG_);
      caml_blit_string(s2_cH_,0,s_cJ_,l1_cG_,l2_cI_);
      return s_cJ_;}
    function string_of_int_cQ_(n_cK_){return caml_format_int(_cx_,n_cK_);}
    function _cM_(l1_cL_,l2_cN_)
     {if(l1_cL_)
       {var hd_cO_=l1_cL_[1];return [0,hd_cO_,_cM_(l1_cL_[2],l2_cN_)];}
      return l2_cN_;}
    var stderr_cR_=caml_ml_open_descriptor_out(2);
    function output_string_cZ_(oc_cT_,s_cS_)
     {return caml_ml_output(oc_cT_,s_cS_,0,s_cS_.getLen());}
    function do_at_exit_cY_(param_cX_)
     {var param_cU_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_cU_)
         {var l_cV_=param_cU_[2];
          try {}catch(_cW_){}
          var param_cU_=l_cV_;
          continue;}
        return 0;}}
    caml_register_named_value(_cu_,do_at_exit_cY_);
    function _c3_(_c1_,_c0_){return caml_ml_output_char(_c1_,_c0_);}
    function _dn_(_c2_){return caml_ml_flush(_c2_);}
    function _dm_(l_c4_,f_c5_)
     {if(0===l_c4_)return [0];
      var res_c7_=caml_make_vect(l_c4_,_c6_(f_c5_,0)),_c8_=1,_c9_=l_c4_-1|0;
      if(!(_c9_<_c8_))
       {var i_c__=_c8_;
        for(;;)
         {res_c7_[i_c__+1]=_c6_(f_c5_,i_c__);
          var _c$_=i_c__+1|0;
          if(_c9_!==i_c__){var i_c__=_c$_;continue;}
          break;}}
      return res_c7_;}
    function _do_(l_da_)
     {if(l_da_)
       {var accu_db_=0,param_dc_=l_da_,tl_di_=l_da_[2],hd_df_=l_da_[1];
        for(;;)
         {if(param_dc_)
           {var
             t_de_=param_dc_[2],
             _dd_=accu_db_+1|0,
             accu_db_=_dd_,
             param_dc_=t_de_;
            continue;}
          var a_dg_=caml_make_vect(accu_db_,hd_df_),i_dh_=1,param_dj_=tl_di_;
          for(;;)
           {if(param_dj_)
             {var tl_dk_=param_dj_[2];
              a_dg_[i_dh_+1]=param_dj_[1];
              var _dl_=i_dh_+1|0,i_dh_=_dl_,param_dj_=tl_dk_;
              continue;}
            return a_dg_;}}}
      return [0];}
    function _dD_(l_dp_)
     {var l1_dq_=l_dp_,l2_dr_=0;
      for(;;)
       {if(l1_dq_)
         {var
           l_ds_=l1_dq_[2],
           _dt_=[0,l1_dq_[1],l2_dr_],
           l1_dq_=l_ds_,
           l2_dr_=_dt_;
          continue;}
        return l2_dr_;}}
    function _dx_(f_dv_,param_du_)
     {if(param_du_)
       {var l_dw_=param_du_[2],r_dy_=_c6_(f_dv_,param_du_[1]);
        return [0,r_dy_,_dx_(f_dv_,l_dw_)];}
      return 0;}
    function _dE_(f_dB_,param_dz_)
     {var param_dA_=param_dz_;
      for(;;)
       {if(param_dA_)
         {var l_dC_=param_dA_[2];
          _c6_(f_dB_,param_dA_[1]);
          var param_dA_=l_dC_;
          continue;}
        return 0;}}
    function _d1_(n_dF_,c_dH_)
     {var s_dG_=caml_create_string(n_dF_);
      caml_fill_string(s_dG_,0,n_dF_,c_dH_);
      return s_dG_;}
    function _d2_(s_dK_,ofs_dI_,len_dJ_)
     {if(0<=ofs_dI_&&0<=len_dJ_&&!((s_dK_.getLen()-len_dJ_|0)<ofs_dI_))
       {var r_dL_=caml_create_string(len_dJ_);
        caml_blit_string(s_dK_,ofs_dI_,r_dL_,0,len_dJ_);
        return r_dL_;}
      return _cE_(_cl_);}
    function _d3_(s1_dO_,ofs1_dN_,s2_dQ_,ofs2_dP_,len_dM_)
     {if
       (0<=
        len_dM_&&
        0<=
        ofs1_dN_&&
        !((s1_dO_.getLen()-len_dM_|0)<ofs1_dN_)&&
        0<=
        ofs2_dP_&&
        !((s2_dQ_.getLen()-len_dM_|0)<ofs2_dP_))
       return caml_blit_string(s1_dO_,ofs1_dN_,s2_dQ_,ofs2_dP_,len_dM_);
      return _cE_(_cm_);}
    function _d4_(sep_dX_,l_dR_)
     {if(l_dR_)
       {var hd_dS_=l_dR_[1],num_dT_=[0,0],len_dU_=[0,0],tl_dW_=l_dR_[2];
        _dE_
         (function(s_dV_)
           {num_dT_[1]+=1;len_dU_[1]=len_dU_[1]+s_dV_.getLen()|0;return 0;},
          l_dR_);
        var
         r_dY_=
          caml_create_string
           (len_dU_[1]+caml_mul(sep_dX_.getLen(),num_dT_[1]-1|0)|0);
        caml_blit_string(hd_dS_,0,r_dY_,0,hd_dS_.getLen());
        var pos_dZ_=[0,hd_dS_.getLen()];
        _dE_
         (function(s_d0_)
           {caml_blit_string(sep_dX_,0,r_dY_,pos_dZ_[1],sep_dX_.getLen());
            pos_dZ_[1]=pos_dZ_[1]+sep_dX_.getLen()|0;
            caml_blit_string(s_d0_,0,r_dY_,pos_dZ_[1],s_d0_.getLen());
            pos_dZ_[1]=pos_dZ_[1]+s_d0_.getLen()|0;
            return 0;},
          tl_dW_);
        return r_dY_;}
      return _cn_;}
    var
     _d5_=caml_sys_const_word_size(0),
     _d6_=caml_mul(_d5_/8|0,(1<<(_d5_-10|0))-1|0)-1|0,
     _ed_=252,
     _ec_=253,
     _d9_=[0,_ck_];
    function _eb_(param_d7_){return [0,0,0];}
    function _ee_(q_d8_)
     {if(0===q_d8_[1])throw [0,_d9_];
      q_d8_[1]=q_d8_[1]-1|0;
      var tail_d__=q_d8_[2],head_d$_=tail_d__[2];
      if(head_d$_===tail_d__)q_d8_[2]=0;else tail_d__[2]=head_d$_[2];
      return head_d$_[1];}
    function _ef_(q_ea_){return q_ea_[1];}
    function _ex_(n_eg_)
     {var
       n_eh_=1<=n_eg_?n_eg_:1,
       n_ei_=_d6_<n_eh_?_d6_:n_eh_,
       s_ej_=caml_create_string(n_ei_);
      return [0,s_ej_,0,n_ei_,s_ej_];}
    function _ey_(b_ek_){return _d2_(b_ek_[1],0,b_ek_[2]);}
    function _er_(b_el_,more_en_)
     {var new_len_em_=[0,b_el_[3]];
      for(;;)
       {if(new_len_em_[1]<(b_el_[2]+more_en_|0))
         {new_len_em_[1]=2*new_len_em_[1]|0;continue;}
        if(_d6_<new_len_em_[1])
         if((b_el_[2]+more_en_|0)<=_d6_)new_len_em_[1]=_d6_;else _j_(_cj_);
        var new_buffer_eo_=caml_create_string(new_len_em_[1]);
        _d3_(b_el_[1],0,new_buffer_eo_,0,b_el_[2]);
        b_el_[1]=new_buffer_eo_;
        b_el_[3]=new_len_em_[1];
        return 0;}}
    function _ez_(b_ep_,c_es_)
     {var pos_eq_=b_ep_[2];
      if(b_ep_[3]<=pos_eq_)_er_(b_ep_,1);
      b_ep_[1].safeSet(pos_eq_,c_es_);
      b_ep_[2]=pos_eq_+1|0;
      return 0;}
    function _eA_(b_ev_,s_et_)
     {var len_eu_=s_et_.getLen(),new_position_ew_=b_ev_[2]+len_eu_|0;
      if(b_ev_[3]<new_position_ew_)_er_(b_ev_,len_eu_);
      _d3_(s_et_,0,b_ev_[1],b_ev_[2],len_eu_);
      b_ev_[2]=new_position_ew_;
      return 0;}
    function index_of_int_eE_(i_eB_)
     {return 0<=i_eB_?i_eB_:_j_(_cP_(_b0_,string_of_int_cQ_(i_eB_)));}
    function add_int_index_eF_(i_eC_,idx_eD_)
     {return index_of_int_eE_(i_eC_+idx_eD_|0);}
    var _eG_=_c6_(add_int_index_eF_,1);
    function _eN_(fmt_eH_){return _d2_(fmt_eH_,0,fmt_eH_.getLen());}
    function bad_conversion_eP_(sfmt_eI_,i_eJ_,c_eL_)
     {var
       _eK_=_cP_(_b3_,_cP_(sfmt_eI_,_b4_)),
       _eM_=_cP_(_b2_,_cP_(string_of_int_cQ_(i_eJ_),_eK_));
      return _cE_(_cP_(_b1_,_cP_(_d1_(1,c_eL_),_eM_)));}
    function bad_conversion_format_fE_(fmt_eO_,i_eR_,c_eQ_)
     {return bad_conversion_eP_(_eN_(fmt_eO_),i_eR_,c_eQ_);}
    function incomplete_format_fF_(fmt_eS_)
     {return _cE_(_cP_(_b5_,_cP_(_eN_(fmt_eS_),_b6_)));}
    function extract_format_fa_(fmt_eT_,start_e1_,stop_e3_,widths_e5_)
     {function skip_positional_spec_e0_(start_eU_)
       {if
         ((fmt_eT_.safeGet(start_eU_)-48|0)<
          0||
          9<
          (fmt_eT_.safeGet(start_eU_)-48|0))
         return start_eU_;
        var i_eV_=start_eU_+1|0;
        for(;;)
         {var _eW_=fmt_eT_.safeGet(i_eV_);
          if(48<=_eW_)
           {if(!(58<=_eW_)){var _eY_=i_eV_+1|0,i_eV_=_eY_;continue;}
            var _eX_=0;}
          else
           if(36===_eW_){var _eZ_=i_eV_+1|0,_eX_=1;}else var _eX_=0;
          if(!_eX_)var _eZ_=start_eU_;
          return _eZ_;}}
      var
       start_e2_=skip_positional_spec_e0_(start_e1_+1|0),
       b_e4_=_ex_((stop_e3_-start_e2_|0)+10|0);
      _ez_(b_e4_,37);
      var i_e6_=start_e2_,widths_e7_=_dD_(widths_e5_);
      for(;;)
       {if(i_e6_<=stop_e3_)
         {var _e8_=fmt_eT_.safeGet(i_e6_);
          if(42===_e8_)
           {if(widths_e7_)
             {var t_e9_=widths_e7_[2];
              _eA_(b_e4_,string_of_int_cQ_(widths_e7_[1]));
              var
               i_e__=skip_positional_spec_e0_(i_e6_+1|0),
               i_e6_=i_e__,
               widths_e7_=t_e9_;
              continue;}
            throw [0,_d_,_b7_];}
          _ez_(b_e4_,_e8_);
          var _e$_=i_e6_+1|0,i_e6_=_e$_;
          continue;}
        return _ey_(b_e4_);}}
    function extract_format_int_g6_
     (conv_fg_,fmt_fe_,start_fd_,stop_fc_,widths_fb_)
     {var sfmt_ff_=extract_format_fa_(fmt_fe_,start_fd_,stop_fc_,widths_fb_);
      if(78!==conv_fg_&&110!==conv_fg_)return sfmt_ff_;
      sfmt_ff_.safeSet(sfmt_ff_.getLen()-1|0,117);
      return sfmt_ff_;}
    function sub_format_fG_
     (incomplete_format_fn_,bad_conversion_format_fx_,conv_fC_,fmt_fh_,i_fB_)
     {var len_fi_=fmt_fh_.getLen();
      function sub_fmt_fz_(c_fj_,i_fw_)
       {var close_fk_=40===c_fj_?41:125;
        function sub_fv_(j_fl_)
         {var j_fm_=j_fl_;
          for(;;)
           {if(len_fi_<=j_fm_)return _c6_(incomplete_format_fn_,fmt_fh_);
            if(37===fmt_fh_.safeGet(j_fm_))
             {var _fo_=j_fm_+1|0;
              if(len_fi_<=_fo_)
               var _fp_=_c6_(incomplete_format_fn_,fmt_fh_);
              else
               {var _fq_=fmt_fh_.safeGet(_fo_),_fr_=_fq_-40|0;
                if(_fr_<0||1<_fr_)
                 {var _fs_=_fr_-83|0;
                  if(_fs_<0||2<_fs_)
                   var _ft_=1;
                  else
                   switch(_fs_)
                    {case 1:var _ft_=1;break;
                     case 2:var _fu_=1,_ft_=0;break;
                     default:var _fu_=0,_ft_=0;}
                  if(_ft_){var _fp_=sub_fv_(_fo_+1|0),_fu_=2;}}
                else
                 var _fu_=0===_fr_?0:1;
                switch(_fu_)
                 {case 1:
                   var
                    _fp_=
                     _fq_===close_fk_
                      ?_fo_+1|0
                      :_fy_(bad_conversion_format_fx_,fmt_fh_,i_fw_,_fq_);
                   break;
                  case 2:break;
                  default:var _fp_=sub_fv_(sub_fmt_fz_(_fq_,_fo_+1|0)+1|0);}}
              return _fp_;}
            var _fA_=j_fm_+1|0,j_fm_=_fA_;
            continue;}}
        return sub_fv_(i_fw_);}
      return sub_fmt_fz_(conv_fC_,i_fB_);}
    function sub_format_for_printf_f6_(conv_fD_)
     {return _fy_
              (sub_format_fG_,
               incomplete_format_fF_,
               bad_conversion_format_fE_,
               conv_fD_);}
    function iter_on_format_args_gk_(fmt_fH_,add_conv_fS_,add_char_f2_)
     {var lim_fI_=fmt_fH_.getLen()-1|0;
      function scan_fmt_f4_(i_fJ_)
       {var i_fK_=i_fJ_;
        a:
        for(;;)
         {if(i_fK_<lim_fI_)
           {if(37===fmt_fH_.safeGet(i_fK_))
             {var skip_fL_=0,i_fM_=i_fK_+1|0;
              for(;;)
               {if(lim_fI_<i_fM_)
                 var _fN_=incomplete_format_fF_(fmt_fH_);
                else
                 {var _fO_=fmt_fH_.safeGet(i_fM_);
                  if(58<=_fO_)
                   {if(95===_fO_)
                     {var _fQ_=i_fM_+1|0,_fP_=1,skip_fL_=_fP_,i_fM_=_fQ_;
                      continue;}}
                  else
                   if(32<=_fO_)
                    switch(_fO_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _fR_=i_fM_+1|0,i_fM_=_fR_;continue;
                      case 10:
                       var _fT_=_fy_(add_conv_fS_,skip_fL_,i_fM_,105),i_fM_=_fT_;
                       continue;
                      default:var _fU_=i_fM_+1|0,i_fM_=_fU_;continue;}
                  var i_fV_=i_fM_;
                  c:
                  for(;;)
                   {if(lim_fI_<i_fV_)
                     var _fW_=incomplete_format_fF_(fmt_fH_);
                    else
                     {var _fX_=fmt_fH_.safeGet(i_fV_);
                      if(126<=_fX_)
                       var _fY_=0;
                      else
                       switch(_fX_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,105),_fY_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,102),_fY_=1;break;
                         case 33:
                         case 37:
                         case 44:
                         case 64:var _fW_=i_fV_+1|0,_fY_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,115),_fY_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,_fX_),_fY_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_fZ_=i_fV_+1|0;
                          if(lim_fI_<j_fZ_)
                           {var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,105),_fY_=1;}
                          else
                           {var _f0_=fmt_fH_.safeGet(j_fZ_)-88|0;
                            if(_f0_<0||32<_f0_)
                             var _f1_=1;
                            else
                             switch(_f0_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _fW_=
                                  _f3_
                                   (add_char_f2_,_fy_(add_conv_fS_,skip_fL_,i_fV_,_fX_),105),
                                 _fY_=1,
                                 _f1_=0;
                                break;
                               default:var _f1_=1;}
                            if(_f1_)
                             {var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,105),_fY_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,99),_fY_=1;break;
                         case 66:
                         case 98:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,66),_fY_=1;break;
                         case 41:
                         case 125:
                          var _fW_=_fy_(add_conv_fS_,skip_fL_,i_fV_,_fX_),_fY_=1;
                          break;
                         case 40:
                          var
                           _fW_=scan_fmt_f4_(_fy_(add_conv_fS_,skip_fL_,i_fV_,_fX_)),
                           _fY_=1;
                          break;
                         case 123:
                          var
                           i_f5_=_fy_(add_conv_fS_,skip_fL_,i_fV_,_fX_),
                           j_f7_=_fy_(sub_format_for_printf_f6_,_fX_,fmt_fH_,i_f5_),
                           i_f8_=i_f5_;
                          for(;;)
                           {if(i_f8_<(j_f7_-2|0))
                             {var
                               _f9_=_f3_(add_char_f2_,i_f8_,fmt_fH_.safeGet(i_f8_)),
                               i_f8_=_f9_;
                              continue;}
                            var _f__=j_f7_-1|0,i_fV_=_f__;
                            continue c;}
                         default:var _fY_=0;}
                      if(!_fY_)
                       var _fW_=bad_conversion_format_fE_(fmt_fH_,i_fV_,_fX_);}
                    var _fN_=_fW_;
                    break;}}
                var i_fK_=_fN_;
                continue a;}}
            var _f$_=i_fK_+1|0,i_fK_=_f$_;
            continue;}
          return i_fK_;}}
      scan_fmt_f4_(0);
      return 0;}
    function count_printing_arguments_of_format_ij_(fmt_gl_)
     {var ac_ga_=[0,0,0,0];
      function add_conv_gj_(skip_gf_,i_gg_,c_gb_)
       {var _gc_=41!==c_gb_?1:0,_gd_=_gc_?125!==c_gb_?1:0:_gc_;
        if(_gd_)
         {var inc_ge_=97===c_gb_?2:1;
          if(114===c_gb_)ac_ga_[3]=ac_ga_[3]+1|0;
          if(skip_gf_)
           ac_ga_[2]=ac_ga_[2]+inc_ge_|0;
          else
           ac_ga_[1]=ac_ga_[1]+inc_ge_|0;}
        return i_gg_+1|0;}
      iter_on_format_args_gk_
       (fmt_gl_,add_conv_gj_,function(i_gh_,param_gi_){return i_gh_+1|0;});
      return ac_ga_[1];}
    function scan_positional_spec_g2_(fmt_gm_,got_spec_gp_,i_gn_)
     {var _go_=fmt_gm_.safeGet(i_gn_);
      if((_go_-48|0)<0||9<(_go_-48|0))return _f3_(got_spec_gp_,0,i_gn_);
      var accu_gq_=_go_-48|0,j_gr_=i_gn_+1|0;
      for(;;)
       {var _gs_=fmt_gm_.safeGet(j_gr_);
        if(48<=_gs_)
         {if(!(58<=_gs_))
           {var
             _gv_=j_gr_+1|0,
             _gu_=(10*accu_gq_|0)+(_gs_-48|0)|0,
             accu_gq_=_gu_,
             j_gr_=_gv_;
            continue;}
          var _gt_=0;}
        else
         if(36===_gs_)
          if(0===accu_gq_)
           {var _gw_=_j_(_b9_),_gt_=1;}
          else
           {var
             _gw_=
              _f3_(got_spec_gp_,[0,index_of_int_eE_(accu_gq_-1|0)],j_gr_+1|0),
             _gt_=1;}
         else
          var _gt_=0;
        if(!_gt_)var _gw_=_f3_(got_spec_gp_,0,i_gn_);
        return _gw_;}}
    function next_index_gX_(spec_gx_,n_gy_)
     {return spec_gx_?n_gy_:_c6_(_eG_,n_gy_);}
    function get_index_gM_(spec_gz_,n_gA_){return spec_gz_?spec_gz_[1]:n_gA_;}
    function _jG_
     (to_s_iE_,get_out_gC_,outc_iQ_,outs_gF_,flush_io_,k_iW_,fmt_gB_)
     {var out_gD_=_c6_(get_out_gC_,fmt_gB_);
      function outs_iF_(s_gE_){return _f3_(outs_gF_,out_gD_,s_gE_);}
      function pr_in_(k_gK_,n_iV_,fmt_gG_,v_gP_)
       {var len_gJ_=fmt_gG_.getLen();
        function doprn_ik_(n_iN_,i_gH_)
         {var i_gI_=i_gH_;
          for(;;)
           {if(len_gJ_<=i_gI_)return _c6_(k_gK_,out_gD_);
            var _gL_=fmt_gG_.safeGet(i_gI_);
            if(37===_gL_)
             {var
               get_arg_gT_=
                function(spec_gO_,n_gN_)
                 {return caml_array_get(v_gP_,get_index_gM_(spec_gO_,n_gN_));},
               scan_flags_gZ_=
                function(spec_g1_,n_gU_,widths_gW_,i_gQ_)
                 {var i_gR_=i_gQ_;
                  for(;;)
                   {var _gS_=fmt_gG_.safeGet(i_gR_)-32|0;
                    if(!(_gS_<0||25<_gS_))
                     switch(_gS_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_g2_
                                (fmt_gG_,
                                 function(wspec_gV_,i_g0_)
                                  {var _gY_=[0,get_arg_gT_(wspec_gV_,n_gU_),widths_gW_];
                                   return scan_flags_gZ_
                                           (spec_g1_,next_index_gX_(wspec_gV_,n_gU_),_gY_,i_g0_);},
                                 i_gR_+1|0);
                       default:var _g3_=i_gR_+1|0,i_gR_=_g3_;continue;}
                    var _g4_=fmt_gG_.safeGet(i_gR_);
                    if(124<=_g4_)
                     var _g5_=0;
                    else
                     switch(_g4_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_g7_=get_arg_gT_(spec_g1_,n_gU_),
                         s_g8_=
                          caml_format_int
                           (extract_format_int_g6_(_g4_,fmt_gG_,i_gI_,i_gR_,widths_gW_),
                            x_g7_),
                         _g__=
                          cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_g8_,i_gR_+1|0),
                         _g5_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_g$_=get_arg_gT_(spec_g1_,n_gU_),
                         s_ha_=
                          caml_format_float
                           (extract_format_fa_(fmt_gG_,i_gI_,i_gR_,widths_gW_),x_g$_),
                         _g__=
                          cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_ha_,i_gR_+1|0),
                         _g5_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _hb_=fmt_gG_.safeGet(i_gR_+1|0)-88|0;
                        if(_hb_<0||32<_hb_)
                         var _hc_=1;
                        else
                         switch(_hb_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_hd_=i_gR_+1|0,_he_=_g4_-108|0;
                            if(_he_<0||2<_he_)
                             var _hf_=0;
                            else
                             {switch(_he_)
                               {case 1:var _hf_=0,_hg_=0;break;
                                case 2:
                                 var
                                  x_hh_=get_arg_gT_(spec_g1_,n_gU_),
                                  _hi_=
                                   caml_format_int
                                    (extract_format_fa_(fmt_gG_,i_gI_,i_hd_,widths_gW_),x_hh_),
                                  _hg_=1;
                                 break;
                                default:
                                 var
                                  x_hj_=get_arg_gT_(spec_g1_,n_gU_),
                                  _hi_=
                                   caml_format_int
                                    (extract_format_fa_(fmt_gG_,i_gI_,i_hd_,widths_gW_),x_hj_),
                                  _hg_=1;}
                              if(_hg_){var s_hk_=_hi_,_hf_=1;}}
                            if(!_hf_)
                             {var
                               x_hl_=get_arg_gT_(spec_g1_,n_gU_),
                               s_hk_=
                                caml_int64_format
                                 (extract_format_fa_(fmt_gG_,i_gI_,i_hd_,widths_gW_),x_hl_);}
                            var
                             _g__=
                              cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_hk_,i_hd_+1|0),
                             _g5_=1,
                             _hc_=0;
                            break;
                           default:var _hc_=1;}
                        if(_hc_)
                         {var
                           x_hm_=get_arg_gT_(spec_g1_,n_gU_),
                           s_hn_=
                            caml_format_int
                             (extract_format_int_g6_(110,fmt_gG_,i_gI_,i_gR_,widths_gW_),
                              x_hm_),
                           _g__=
                            cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_hn_,i_gR_+1|0),
                           _g5_=1;}
                        break;
                       case 37:
                       case 64:
                        var _g__=cont_s_g9_(n_gU_,_d1_(1,_g4_),i_gR_+1|0),_g5_=1;
                        break;
                       case 83:
                       case 115:
                        var x_ho_=get_arg_gT_(spec_g1_,n_gU_);
                        if(115===_g4_)
                         var x_hp_=x_ho_;
                        else
                         {var n_hq_=[0,0],_hr_=0,_hs_=x_ho_.getLen()-1|0;
                          if(!(_hs_<_hr_))
                           {var i_ht_=_hr_;
                            for(;;)
                             {var
                               _hu_=x_ho_.safeGet(i_ht_),
                               _hv_=
                                14<=_hu_
                                 ?34===_hu_?1:92===_hu_?1:0
                                 :11<=_hu_?13<=_hu_?1:0:8<=_hu_?1:0,
                               _hw_=_hv_?2:caml_is_printable(_hu_)?1:4;
                              n_hq_[1]=n_hq_[1]+_hw_|0;
                              var _hx_=i_ht_+1|0;
                              if(_hs_!==i_ht_){var i_ht_=_hx_;continue;}
                              break;}}
                          if(n_hq_[1]===x_ho_.getLen())
                           var _hy_=x_ho_;
                          else
                           {var s__hz_=caml_create_string(n_hq_[1]);
                            n_hq_[1]=0;
                            var _hA_=0,_hB_=x_ho_.getLen()-1|0;
                            if(!(_hB_<_hA_))
                             {var i_hC_=_hA_;
                              for(;;)
                               {var _hD_=x_ho_.safeGet(i_hC_),_hE_=_hD_-34|0;
                                if(_hE_<0||58<_hE_)
                                 if(-20<=_hE_)
                                  var _hF_=1;
                                 else
                                  {switch(_hE_+34|0)
                                    {case 8:
                                      s__hz_.safeSet(n_hq_[1],92);
                                      n_hq_[1]+=1;
                                      s__hz_.safeSet(n_hq_[1],98);
                                      var _hG_=1;
                                      break;
                                     case 9:
                                      s__hz_.safeSet(n_hq_[1],92);
                                      n_hq_[1]+=1;
                                      s__hz_.safeSet(n_hq_[1],116);
                                      var _hG_=1;
                                      break;
                                     case 10:
                                      s__hz_.safeSet(n_hq_[1],92);
                                      n_hq_[1]+=1;
                                      s__hz_.safeSet(n_hq_[1],110);
                                      var _hG_=1;
                                      break;
                                     case 13:
                                      s__hz_.safeSet(n_hq_[1],92);
                                      n_hq_[1]+=1;
                                      s__hz_.safeSet(n_hq_[1],114);
                                      var _hG_=1;
                                      break;
                                     default:var _hF_=1,_hG_=0;}
                                   if(_hG_)var _hF_=0;}
                                else
                                 var
                                  _hF_=
                                   (_hE_-1|0)<0||56<(_hE_-1|0)
                                    ?(s__hz_.safeSet(n_hq_[1],92),
                                      n_hq_[1]+=
                                      1,
                                      s__hz_.safeSet(n_hq_[1],_hD_),
                                      0)
                                    :1;
                                if(_hF_)
                                 if(caml_is_printable(_hD_))
                                  s__hz_.safeSet(n_hq_[1],_hD_);
                                 else
                                  {s__hz_.safeSet(n_hq_[1],92);
                                   n_hq_[1]+=1;
                                   s__hz_.safeSet(n_hq_[1],48+(_hD_/100|0)|0);
                                   n_hq_[1]+=1;
                                   s__hz_.safeSet(n_hq_[1],48+((_hD_/10|0)%10|0)|0);
                                   n_hq_[1]+=1;
                                   s__hz_.safeSet(n_hq_[1],48+(_hD_%10|0)|0);}
                                n_hq_[1]+=1;
                                var _hH_=i_hC_+1|0;
                                if(_hB_!==i_hC_){var i_hC_=_hH_;continue;}
                                break;}}
                            var _hy_=s__hz_;}
                          var x_hp_=_cP_(_ce_,_cP_(_hy_,_cf_));}
                        if(i_gR_===(i_gI_+1|0))
                         var s_hI_=x_hp_;
                        else
                         {var
                           _hJ_=
                            extract_format_fa_(fmt_gG_,i_gI_,i_gR_,widths_gW_);
                          try
                           {var neg_hK_=0,i_hL_=1;
                            for(;;)
                             {if(_hJ_.getLen()<=i_hL_)
                               var _hM_=[0,0,neg_hK_];
                              else
                               {var _hN_=_hJ_.safeGet(i_hL_);
                                if(49<=_hN_)
                                 if(58<=_hN_)
                                  var _hO_=0;
                                 else
                                  {var
                                    _hM_=
                                     [0,
                                      caml_int_of_string
                                       (_d2_(_hJ_,i_hL_,(_hJ_.getLen()-i_hL_|0)-1|0)),
                                      neg_hK_],
                                    _hO_=1;}
                                else
                                 {if(45===_hN_)
                                   {var _hQ_=i_hL_+1|0,_hP_=1,neg_hK_=_hP_,i_hL_=_hQ_;
                                    continue;}
                                  var _hO_=0;}
                                if(!_hO_){var _hR_=i_hL_+1|0,i_hL_=_hR_;continue;}}
                              var match_hS_=_hM_;
                              break;}}
                          catch(_hT_)
                           {if(_hT_[1]!==_a_)throw _hT_;
                            var match_hS_=bad_conversion_eP_(_hJ_,0,115);}
                          var
                           p_hU_=match_hS_[1],
                           _hV_=x_hp_.getLen(),
                           _hW_=0,
                           neg_h0_=match_hS_[2],
                           _hZ_=32;
                          if(p_hU_===_hV_&&0===_hW_)
                           {var _hX_=x_hp_,_hY_=1;}
                          else
                           var _hY_=0;
                          if(!_hY_)
                           if(p_hU_<=_hV_)
                            var _hX_=_d2_(x_hp_,_hW_,_hV_);
                           else
                            {var res_h1_=_d1_(p_hU_,_hZ_);
                             if(neg_h0_)
                              _d3_(x_hp_,_hW_,res_h1_,0,_hV_);
                             else
                              _d3_(x_hp_,_hW_,res_h1_,p_hU_-_hV_|0,_hV_);
                             var _hX_=res_h1_;}
                          var s_hI_=_hX_;}
                        var
                         _g__=
                          cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_hI_,i_gR_+1|0),
                         _g5_=1;
                        break;
                       case 67:
                       case 99:
                        var x_h2_=get_arg_gT_(spec_g1_,n_gU_);
                        if(99===_g4_)
                         var s_h3_=_d1_(1,x_h2_);
                        else
                         {if(39===x_h2_)
                           var _h4_=_co_;
                          else
                           if(92===x_h2_)
                            var _h4_=_cp_;
                           else
                            {if(14<=x_h2_)
                              var _h5_=0;
                             else
                              switch(x_h2_)
                               {case 8:var _h4_=_ct_,_h5_=1;break;
                                case 9:var _h4_=_cs_,_h5_=1;break;
                                case 10:var _h4_=_cr_,_h5_=1;break;
                                case 13:var _h4_=_cq_,_h5_=1;break;
                                default:var _h5_=0;}
                             if(!_h5_)
                              if(caml_is_printable(x_h2_))
                               {var s_h6_=caml_create_string(1);
                                s_h6_.safeSet(0,x_h2_);
                                var _h4_=s_h6_;}
                              else
                               {var s_h7_=caml_create_string(4);
                                s_h7_.safeSet(0,92);
                                s_h7_.safeSet(1,48+(x_h2_/100|0)|0);
                                s_h7_.safeSet(2,48+((x_h2_/10|0)%10|0)|0);
                                s_h7_.safeSet(3,48+(x_h2_%10|0)|0);
                                var _h4_=s_h7_;}}
                          var s_h3_=_cP_(_cc_,_cP_(_h4_,_cd_));}
                        var
                         _g__=
                          cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_h3_,i_gR_+1|0),
                         _g5_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _h9_=i_gR_+1|0,
                         _h8_=get_arg_gT_(spec_g1_,n_gU_)?_cw_:_cv_,
                         _g__=cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),_h8_,_h9_),
                         _g5_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_h__=get_arg_gT_(spec_g1_,n_gU_),
                         i_h$_=_fy_(sub_format_for_printf_f6_,_g4_,fmt_gG_,i_gR_+1|0);
                        if(123===_g4_)
                         {var
                           b_ia_=_ex_(xf_h__.getLen()),
                           add_char_ie_=
                            function(i_ic_,c_ib_){_ez_(b_ia_,c_ib_);return i_ic_+1|0;};
                          iter_on_format_args_gk_
                           (xf_h__,
                            function(skip_id_,i_ig_,c_if_)
                             {if(skip_id_)_eA_(b_ia_,_b8_);else _ez_(b_ia_,37);
                              return add_char_ie_(i_ig_,c_if_);},
                            add_char_ie_);
                          var
                           _ih_=_ey_(b_ia_),
                           _g__=cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),_ih_,i_h$_),
                           _g5_=1;}
                        else
                         {var
                           _ii_=next_index_gX_(spec_g1_,n_gU_),
                           m_il_=
                            add_int_index_eF_
                             (count_printing_arguments_of_format_ij_(xf_h__),_ii_),
                           _g__=
                            pr_in_
                             (function(param_im_){return doprn_ik_(m_il_,i_h$_);},
                              _ii_,
                              xf_h__,
                              v_gP_),
                           _g5_=1;}
                        break;
                       case 33:
                        _c6_(flush_io_,out_gD_);
                        var _g__=doprn_ik_(n_gU_,i_gR_+1|0),_g5_=1;
                        break;
                       case 41:
                        var _g__=cont_s_g9_(n_gU_,_ci_,i_gR_+1|0),_g5_=1;break;
                       case 44:
                        var _g__=cont_s_g9_(n_gU_,_ch_,i_gR_+1|0),_g5_=1;break;
                       case 70:
                        var x_ip_=get_arg_gT_(spec_g1_,n_gU_);
                        if(0===widths_gW_)
                         var _iq_=_cg_;
                        else
                         {var
                           sfmt_ir_=
                            extract_format_fa_(fmt_gG_,i_gI_,i_gR_,widths_gW_);
                          if(70===_g4_)sfmt_ir_.safeSet(sfmt_ir_.getLen()-1|0,103);
                          var _iq_=sfmt_ir_;}
                        var _is_=caml_classify_float(x_ip_);
                        if(3===_is_)
                         var s_it_=x_ip_<0?_ca_:_b$_;
                        else
                         if(4<=_is_)
                          var s_it_=_cb_;
                         else
                          {var
                            _iu_=caml_format_float(_iq_,x_ip_),
                            i_iv_=0,
                            l_iw_=_iu_.getLen();
                           for(;;)
                            {if(l_iw_<=i_iv_)
                              var _ix_=_cP_(_iu_,_b__);
                             else
                              {var
                                _iy_=_iu_.safeGet(i_iv_)-46|0,
                                _iz_=
                                 _iy_<0||23<_iy_
                                  ?55===_iy_?1:0
                                  :(_iy_-1|0)<0||21<(_iy_-1|0)?1:0;
                               if(!_iz_){var _iA_=i_iv_+1|0,i_iv_=_iA_;continue;}
                               var _ix_=_iu_;}
                             var s_it_=_ix_;
                             break;}}
                        var
                         _g__=
                          cont_s_g9_(next_index_gX_(spec_g1_,n_gU_),s_it_,i_gR_+1|0),
                         _g5_=1;
                        break;
                       case 91:
                        var
                         _g__=bad_conversion_format_fE_(fmt_gG_,i_gR_,_g4_),
                         _g5_=1;
                        break;
                       case 97:
                        var
                         printer_iB_=get_arg_gT_(spec_g1_,n_gU_),
                         n_iC_=_c6_(_eG_,get_index_gM_(spec_g1_,n_gU_)),
                         arg_iD_=get_arg_gT_(0,n_iC_),
                         _iH_=i_gR_+1|0,
                         _iG_=next_index_gX_(spec_g1_,n_iC_);
                        if(to_s_iE_)
                         outs_iF_(_f3_(printer_iB_,0,arg_iD_));
                        else
                         _f3_(printer_iB_,out_gD_,arg_iD_);
                        var _g__=doprn_ik_(_iG_,_iH_),_g5_=1;
                        break;
                       case 114:
                        var
                         _g__=bad_conversion_format_fE_(fmt_gG_,i_gR_,_g4_),
                         _g5_=1;
                        break;
                       case 116:
                        var
                         printer_iI_=get_arg_gT_(spec_g1_,n_gU_),
                         _iK_=i_gR_+1|0,
                         _iJ_=next_index_gX_(spec_g1_,n_gU_);
                        if(to_s_iE_)
                         outs_iF_(_c6_(printer_iI_,0));
                        else
                         _c6_(printer_iI_,out_gD_);
                        var _g__=doprn_ik_(_iJ_,_iK_),_g5_=1;
                        break;
                       default:var _g5_=0;}
                    if(!_g5_)
                     var _g__=bad_conversion_format_fE_(fmt_gG_,i_gR_,_g4_);
                    return _g__;}},
               _iP_=i_gI_+1|0,
               _iM_=0;
              return scan_positional_spec_g2_
                      (fmt_gG_,
                       function(spec_iO_,i_iL_)
                        {return scan_flags_gZ_(spec_iO_,n_iN_,_iM_,i_iL_);},
                       _iP_);}
            _f3_(outc_iQ_,out_gD_,_gL_);
            var _iR_=i_gI_+1|0,i_gI_=_iR_;
            continue;}}
        function cont_s_g9_(n_iU_,s_iS_,i_iT_)
         {outs_iF_(s_iS_);return doprn_ik_(n_iU_,i_iT_);}
        return doprn_ik_(n_iV_,0);}
      var
       kpr_iX_=_f3_(pr_in_,k_iW_,index_of_int_eE_(0)),
       _iY_=count_printing_arguments_of_format_ij_(fmt_gB_);
      if(_iY_<0||6<_iY_)
       {var
         loop_i$_=
          function(i_iZ_,args_i5_)
           {if(_iY_<=i_iZ_)
             {var
               a_i0_=caml_make_vect(_iY_,0),
               _i3_=
                function(i_i1_,arg_i2_)
                 {return caml_array_set(a_i0_,(_iY_-i_i1_|0)-1|0,arg_i2_);},
               i_i4_=0,
               param_i6_=args_i5_;
              for(;;)
               {if(param_i6_)
                 {var _i7_=param_i6_[2],_i8_=param_i6_[1];
                  if(_i7_)
                   {_i3_(i_i4_,_i8_);
                    var _i9_=i_i4_+1|0,i_i4_=_i9_,param_i6_=_i7_;
                    continue;}
                  _i3_(i_i4_,_i8_);}
                return _f3_(kpr_iX_,fmt_gB_,a_i0_);}}
            return function(x_i__)
             {return loop_i$_(i_iZ_+1|0,[0,x_i__,args_i5_]);};},
         _ja_=loop_i$_(0,0);}
      else
       switch(_iY_)
        {case 1:
          var
           _ja_=
            function(x_jc_)
             {var a_jb_=caml_make_vect(1,0);
              caml_array_set(a_jb_,0,x_jc_);
              return _f3_(kpr_iX_,fmt_gB_,a_jb_);};
          break;
         case 2:
          var
           _ja_=
            function(x_je_,y_jf_)
             {var a_jd_=caml_make_vect(2,0);
              caml_array_set(a_jd_,0,x_je_);
              caml_array_set(a_jd_,1,y_jf_);
              return _f3_(kpr_iX_,fmt_gB_,a_jd_);};
          break;
         case 3:
          var
           _ja_=
            function(x_jh_,y_ji_,z_jj_)
             {var a_jg_=caml_make_vect(3,0);
              caml_array_set(a_jg_,0,x_jh_);
              caml_array_set(a_jg_,1,y_ji_);
              caml_array_set(a_jg_,2,z_jj_);
              return _f3_(kpr_iX_,fmt_gB_,a_jg_);};
          break;
         case 4:
          var
           _ja_=
            function(x_jl_,y_jm_,z_jn_,t_jo_)
             {var a_jk_=caml_make_vect(4,0);
              caml_array_set(a_jk_,0,x_jl_);
              caml_array_set(a_jk_,1,y_jm_);
              caml_array_set(a_jk_,2,z_jn_);
              caml_array_set(a_jk_,3,t_jo_);
              return _f3_(kpr_iX_,fmt_gB_,a_jk_);};
          break;
         case 5:
          var
           _ja_=
            function(x_jq_,y_jr_,z_js_,t_jt_,u_ju_)
             {var a_jp_=caml_make_vect(5,0);
              caml_array_set(a_jp_,0,x_jq_);
              caml_array_set(a_jp_,1,y_jr_);
              caml_array_set(a_jp_,2,z_js_);
              caml_array_set(a_jp_,3,t_jt_);
              caml_array_set(a_jp_,4,u_ju_);
              return _f3_(kpr_iX_,fmt_gB_,a_jp_);};
          break;
         case 6:
          var
           _ja_=
            function(x_jw_,y_jx_,z_jy_,t_jz_,u_jA_,v_jB_)
             {var a_jv_=caml_make_vect(6,0);
              caml_array_set(a_jv_,0,x_jw_);
              caml_array_set(a_jv_,1,y_jx_);
              caml_array_set(a_jv_,2,z_jy_);
              caml_array_set(a_jv_,3,t_jz_);
              caml_array_set(a_jv_,4,u_jA_);
              caml_array_set(a_jv_,5,v_jB_);
              return _f3_(kpr_iX_,fmt_gB_,a_jv_);};
          break;
         default:var _ja_=_f3_(kpr_iX_,fmt_gB_,[0]);}
      return _ja_;}
    function _jU_(oc_jD_)
     {function _jF_(_jC_){return 0;}
      return _jH_
              (_jG_,
               0,
               function(param_jE_){return oc_jD_;},
               _c3_,
               output_string_cZ_,
               _dn_,
               _jF_);}
    function _jQ_(fmt_jI_){return _ex_(2*fmt_jI_.getLen()|0);}
    function _jN_(k_jL_,b_jJ_)
     {var s_jK_=_ey_(b_jJ_);b_jJ_[2]=0;return _c6_(k_jL_,s_jK_);}
    function _jT_(k_jM_)
     {var _jP_=_c6_(_jN_,k_jM_);
      return _jH_(_jG_,1,_jQ_,_ez_,_eA_,function(_jO_){return 0;},_jP_);}
    function _jV_(fmt_jS_)
     {return _f3_(_jT_,function(s_jR_){return s_jR_;},fmt_jS_);}
    var _jW_=[0,0];
    function _j__(x_jX_,i_jY_)
     {var f_jZ_=x_jX_[i_jY_+1];
      if(caml_obj_is_block(f_jZ_))
       {if(caml_obj_tag(f_jZ_)===_ed_)return _f3_(_jV_,_bE_,f_jZ_);
        if(caml_obj_tag(f_jZ_)===_ec_)
         {var _j0_=caml_format_float(_cz_,f_jZ_),i_j1_=0,l_j2_=_j0_.getLen();
          for(;;)
           {if(l_j2_<=i_j1_)
             var _j3_=_cP_(_j0_,_cy_);
            else
             {var
               _j4_=_j0_.safeGet(i_j1_),
               _j5_=48<=_j4_?58<=_j4_?0:1:45===_j4_?1:0;
              if(_j5_){var _j6_=i_j1_+1|0,i_j1_=_j6_;continue;}
              var _j3_=_j0_;}
            return _j3_;}}
        return _bD_;}
      return _f3_(_jV_,_bF_,f_jZ_);}
    function _j9_(x_j7_,i_j8_)
     {if(x_j7_.length-1<=i_j8_)return _bZ_;
      var _j$_=_j9_(x_j7_,i_j8_+1|0);
      return _fy_(_jV_,_bY_,_j__(x_j7_,i_j8_),_j$_);}
    function _kE_(x_kb_)
     {var param_ka_=_jW_[1];
      for(;;)
       {if(param_ka_)
         {var tl_kg_=param_ka_[2],hd_kc_=param_ka_[1];
          try {var _kd_=_c6_(hd_kc_,x_kb_),_ke_=_kd_;}catch(_kh_){var _ke_=0;}
          if(!_ke_){var param_ka_=tl_kg_;continue;}
          var _kf_=_ke_[1];}
        else
         if(x_kb_[1]===_cD_)
          var _kf_=_bO_;
         else
          if(x_kb_[1]===_cB_)
           var _kf_=_bN_;
          else
           if(x_kb_[1]===_cC_)
            {var
              match_ki_=x_kb_[2],
              char_kj_=match_ki_[3],
              _kf_=
               _jH_
                (_jV_,
                 _e_,
                 match_ki_[1],
                 match_ki_[2],
                 char_kj_,
                 char_kj_+5|0,
                 _bM_);}
           else
            if(x_kb_[1]===_d_)
             {var
               match_kk_=x_kb_[2],
               char_kl_=match_kk_[3],
               _kf_=
                _jH_
                 (_jV_,
                  _e_,
                  match_kk_[1],
                  match_kk_[2],
                  char_kl_,
                  char_kl_+6|0,
                  _bL_);}
            else
             if(x_kb_[1]===_cA_)
              {var
                match_km_=x_kb_[2],
                char_kn_=match_km_[3],
                _kf_=
                 _jH_
                  (_jV_,
                   _e_,
                   match_km_[1],
                   match_km_[2],
                   char_kn_,
                   char_kn_+6|0,
                   _bK_);}
             else
              {var _ko_=x_kb_.length-1,constructor_kr_=x_kb_[0+1][0+1];
               if(_ko_<0||2<_ko_)
                {var
                  _kp_=_j9_(x_kb_,2),
                  _kq_=_fy_(_jV_,_bJ_,_j__(x_kb_,1),_kp_);}
               else
                switch(_ko_)
                 {case 1:var _kq_=_bH_;break;
                  case 2:var _kq_=_f3_(_jV_,_bG_,_j__(x_kb_,1));break;
                  default:var _kq_=_bI_;}
               var _kf_=_cP_(constructor_kr_,_kq_);}
        return _kf_;}}
    function _kF_(outchan_kB_)
     {var
       _ks_=
        caml_convert_raw_backtrace(caml_get_exception_raw_backtrace(0));
      if(_ks_)
       {var a_kt_=_ks_[1],_ku_=0,_kv_=a_kt_.length-1-1|0;
        if(!(_kv_<_ku_))
         {var i_kw_=_ku_;
          for(;;)
           {if(caml_notequal(caml_array_get(a_kt_,i_kw_),_bX_))
             {var
               _kx_=caml_array_get(a_kt_,i_kw_),
               is_raise_ky_=0===_kx_[0]?_kx_[1]:_kx_[1],
               info_kz_=is_raise_ky_?0===i_kw_?_bU_:_bT_:0===i_kw_?_bS_:_bR_,
               _kA_=
                0===_kx_[0]
                 ?_jH_(_jV_,_bQ_,info_kz_,_kx_[2],_kx_[3],_kx_[4],_kx_[5])
                 :_f3_(_jV_,_bP_,info_kz_);
              _fy_(_jU_,outchan_kB_,_bW_,_kA_);}
            var _kC_=i_kw_+1|0;
            if(_kv_!==i_kw_){var i_kw_=_kC_;continue;}
            break;}}
        var _kD_=0;}
      else
       var _kD_=_f3_(_jU_,outchan_kB_,_bV_);
      return _kD_;}
    32===_d5_;
    function _kI_(param_kH_)
     {var seq_kG_=[];
      caml_update_dummy(seq_kG_,[0,seq_kG_,seq_kG_]);
      return seq_kG_;}
    var Canceled_kJ_=[0,_bt_],current_data_kK_=[0,0],max_removed_kS_=42;
    function repr_rec_kO_(t_kL_)
     {var _kM_=t_kL_[1];
      {if(3===_kM_[0])
        {var t__kN_=_kM_[1],t___kP_=repr_rec_kO_(t__kN_);
         if(t___kP_!==t__kN_)t_kL_[1]=[3,t___kP_];
         return t___kP_;}
       return t_kL_;}}
    function repr_kT_(t_kQ_){return repr_rec_kO_(t_kQ_);}
    var
     async_exception_hook_kU_=
      [0,
       function(exn_kR_)
        {_kE_(exn_kR_);
         caml_ml_output_char(stderr_cR_,10);
         _kF_(stderr_cR_);
         do_at_exit_cY_(0);
         return caml_sys_exit(2);}];
    function call_unsafe_li_(f_kW_,x_kV_)
     {try
       {var _kX_=_c6_(f_kW_,x_kV_);}
      catch(_kY_){return _c6_(async_exception_hook_kU_[1],_kY_);}
      return _kX_;}
    function run_waiters_rec_k9_(state_k3_,ws_kZ_,rem_k1_)
     {var ws_k0_=ws_kZ_,rem_k2_=rem_k1_;
      for(;;)
       if(typeof ws_k0_==="number")
        return run_waiters_rec_next_k4_(state_k3_,rem_k2_);
       else
        switch(ws_k0_[0])
         {case 1:
           _c6_(ws_k0_[1],state_k3_);
           return run_waiters_rec_next_k4_(state_k3_,rem_k2_);
          case 2:
           var
            ws1_k5_=ws_k0_[1],
            _k6_=[0,ws_k0_[2],rem_k2_],
            ws_k0_=ws1_k5_,
            rem_k2_=_k6_;
           continue;
          default:
           var _k7_=ws_k0_[1][1];
           return _k7_
                   ?(_c6_(_k7_[1],state_k3_),
                     run_waiters_rec_next_k4_(state_k3_,rem_k2_))
                   :run_waiters_rec_next_k4_(state_k3_,rem_k2_);}}
    function run_waiters_rec_next_k4_(state_k__,rem_k8_)
     {return rem_k8_?run_waiters_rec_k9_(state_k__,rem_k8_[1],rem_k8_[2]):0;}
    function run_cancel_handlers_rec_lk_(chs_k$_,rem_lb_)
     {var chs_la_=chs_k$_,rem_lc_=rem_lb_;
      for(;;)
       if(typeof chs_la_==="number")
        return run_cancel_handlers_rec_next_le_(rem_lc_);
       else
        switch(chs_la_[0])
         {case 1:
           var n_ld_=chs_la_[1];
           if(n_ld_[4]){n_ld_[4]=0;n_ld_[1][2]=n_ld_[2];n_ld_[2][1]=n_ld_[1];}
           return run_cancel_handlers_rec_next_le_(rem_lc_);
          case 2:
           var
            chs1_lf_=chs_la_[1],
            _lg_=[0,chs_la_[2],rem_lc_],
            chs_la_=chs1_lf_,
            rem_lc_=_lg_;
           continue;
          default:
           var f_lh_=chs_la_[2];
           current_data_kK_[1]=chs_la_[1];
           call_unsafe_li_(f_lh_,0);
           return run_cancel_handlers_rec_next_le_(rem_lc_);}}
    function run_cancel_handlers_rec_next_le_(rem_lj_)
     {return rem_lj_?run_cancel_handlers_rec_lk_(rem_lj_[1],rem_lj_[2]):0;}
    function unsafe_run_waiters_lo_(sleeper_lm_,state_ll_)
     {var
       _ln_=
        1===state_ll_[0]
         ?state_ll_[1][1]===Canceled_kJ_
           ?(run_cancel_handlers_rec_lk_(sleeper_lm_[4],0),1)
           :0
         :0;
      
      return run_waiters_rec_k9_(state_ll_,sleeper_lm_[2],0);}
    var wakening_lp_=[0,0],to_wakeup_lq_=_eb_(0);
    function wakeup_result_lB_(t_lr_,result_lu_)
     {var t_ls_=repr_rec_kO_(t_lr_),_lt_=t_ls_[1];
      switch(_lt_[0])
       {case 1:if(_lt_[1][1]===Canceled_kJ_)return 0;break;
        case 2:
         var sleeper_lv_=_lt_[1];
         t_ls_[1]=result_lu_;
         var
          snapshot_lw_=current_data_kK_[1],
          already_wakening_lx_=wakening_lp_[1]?1:(wakening_lp_[1]=1,0);
         unsafe_run_waiters_lo_(sleeper_lv_,result_lu_);
         if(already_wakening_lx_)
          {current_data_kK_[1]=snapshot_lw_;var _ly_=0;}
         else
          for(;;)
           {if(0!==to_wakeup_lq_[1])
             {var closure_lz_=_ee_(to_wakeup_lq_);
              unsafe_run_waiters_lo_(closure_lz_[1],closure_lz_[2]);
              continue;}
            wakening_lp_[1]=0;
            current_data_kK_[1]=snapshot_lw_;
            var _ly_=0;
            break;}
         return _ly_;
        default:}
      return _cE_(_bu_);}
    function wakeup_l3_(t_lC_,v_lA_)
     {return wakeup_result_lB_(t_lC_,[0,v_lA_]);}
    function append_lJ_(l1_lD_,l2_lE_)
     {return typeof l1_lD_==="number"
              ?l2_lE_
              :typeof l2_lE_==="number"?l1_lD_:[2,l1_lD_,l2_lE_];}
    function cleanup_lG_(ws_lF_)
     {if(typeof ws_lF_!=="number")
       switch(ws_lF_[0])
        {case 2:
          var l1_lH_=ws_lF_[1],_lI_=cleanup_lG_(ws_lF_[2]);
          return append_lJ_(cleanup_lG_(l1_lH_),_lI_);
         case 1:break;
         default:if(!ws_lF_[1][1])return 0;}
      return ws_lF_;}
    function connect_l4_(t1_lK_,t2_lM_)
     {var t1_lL_=repr_kT_(t1_lK_),t2_lN_=repr_kT_(t2_lM_),_lO_=t1_lL_[1];
      {if(2===_lO_[0])
        {var sleeper1_lP_=_lO_[1];
         if(t1_lL_===t2_lN_)return 0;
         var _lQ_=t2_lN_[1];
         {if(2===_lQ_[0])
           {var sleeper2_lR_=_lQ_[1];
            t2_lN_[1]=[3,t1_lL_];
            sleeper1_lP_[1]=sleeper2_lR_[1];
            var
             waiters_lS_=append_lJ_(sleeper1_lP_[2],sleeper2_lR_[2]),
             removed_lT_=sleeper1_lP_[3]+sleeper2_lR_[3]|0;
            if(max_removed_kS_<removed_lT_)
             {sleeper1_lP_[3]=0;sleeper1_lP_[2]=cleanup_lG_(waiters_lS_);}
            else
             {sleeper1_lP_[3]=removed_lT_;sleeper1_lP_[2]=waiters_lS_;}
            var
             _lU_=sleeper2_lR_[4],
             _lV_=sleeper1_lP_[4],
             _lW_=
              typeof _lV_==="number"
               ?_lU_
               :typeof _lU_==="number"?_lV_:[2,_lV_,_lU_];
            sleeper1_lP_[4]=_lW_;
            return 0;}
          t1_lL_[1]=_lQ_;
          return unsafe_run_waiters_lo_(sleeper1_lP_,_lQ_);}}
       throw [0,_d_,_bv_];}}
    function fast_connect_l5_(t_lX_,state_l0_)
     {var t_lY_=repr_kT_(t_lX_),_lZ_=t_lY_[1];
      {if(2===_lZ_[0])
        {var sleeper_l1_=_lZ_[1];
         t_lY_[1]=state_l0_;
         return unsafe_run_waiters_lo_(sleeper_l1_,state_l0_);}
       throw [0,_d_,_bw_];}}
    function return_l6_(v_l2_){return [0,[0,v_l2_]];}
    var return_unit_mT_=[0,state_return_unit_bs_];
    function fail_my_(e_l7_){return [0,[1,e_l7_]];}
    function temp_mp_(t_l8_){return [0,[2,[0,[0,[0,t_l8_]],0,0,0]]];}
    function task_mU_(param_l__)
     {var _l9_=[0,[2,[0,1,0,0,0]]];return [0,_l9_,_l9_];}
    function add_immutable_waiter_mA_(sleeper_mb_,waiter_l$_)
     {var
       _ma_=[1,waiter_l$_],
       _mc_=sleeper_mb_[2],
       _md_=typeof _mc_==="number"?_ma_:[2,_ma_,_mc_];
      sleeper_mb_[2]=_md_;
      return 0;}
    function on_cancel_mV_(t_me_,f_mg_)
     {var _mf_=repr_kT_(t_me_)[1];
      switch(_mf_[0])
       {case 1:
         if(_mf_[1][1]===Canceled_kJ_)return call_unsafe_li_(f_mg_,0);break;
        case 2:
         var
          sleeper_mh_=_mf_[1],
          handler_mi_=[0,current_data_kK_[1],f_mg_],
          _mj_=sleeper_mh_[4],
          _mk_=typeof _mj_==="number"?handler_mi_:[2,handler_mi_,_mj_];
         sleeper_mh_[4]=_mk_;
         return 0;
        default:}
      return 0;}
    function _mW_(t_ml_,f_mv_)
     {var t_mm_=repr_kT_(t_ml_),_mn_=t_mm_[1];
      switch(_mn_[0])
       {case 1:var _mo_=[0,_mn_];break;
        case 2:
         var
          sleeper_mr_=_mn_[1],
          res_mq_=temp_mp_(t_mm_),
          data_mt_=current_data_kK_[1];
         add_immutable_waiter_mA_
          (sleeper_mr_,
           function(state_ms_)
            {switch(state_ms_[0])
              {case 0:
                var v_mu_=state_ms_[1];
                current_data_kK_[1]=data_mt_;
                try
                 {var _mw_=_c6_(f_mv_,v_mu_),_mx_=_mw_;}
                catch(_mz_){var _mx_=fail_my_(_mz_);}
                return connect_l4_(res_mq_,_mx_);
               case 1:return fast_connect_l5_(res_mq_,state_ms_);
               default:throw [0,_d_,_by_];}});
         var _mo_=res_mq_;
         break;
        case 3:throw [0,_d_,_bx_];
        default:var _mo_=_c6_(f_mv_,_mn_[1]);}
      return _mo_;}
    function _mX_(t_mB_,f_mK_)
     {var t_mC_=repr_kT_(t_mB_),_mD_=t_mC_[1];
      switch(_mD_[0])
       {case 1:var _mE_=[0,_mD_];break;
        case 2:
         var
          sleeper_mG_=_mD_[1],
          res_mF_=temp_mp_(t_mC_),
          data_mI_=current_data_kK_[1];
         add_immutable_waiter_mA_
          (sleeper_mG_,
           function(state_mH_)
            {switch(state_mH_[0])
              {case 0:
                var v_mJ_=state_mH_[1];
                current_data_kK_[1]=data_mI_;
                try
                 {var _mL_=[0,_c6_(f_mK_,v_mJ_)],_mM_=_mL_;}
                catch(_mN_){var _mM_=[1,_mN_];}
                return fast_connect_l5_(res_mF_,_mM_);
               case 1:return fast_connect_l5_(res_mF_,state_mH_);
               default:throw [0,_d_,_bA_];}});
         var _mE_=res_mF_;
         break;
        case 3:throw [0,_d_,_bz_];
        default:
         var v_mO_=_mD_[1];
         try
          {var _mP_=[0,_c6_(f_mK_,v_mO_)],_mQ_=_mP_;}
         catch(_mR_){var _mQ_=[1,_mR_];}
         var _mE_=[0,_mQ_];}
      return _mE_;}
    var pause_hook_mZ_=[0,function(_mS_){return 0;}],_mY_=_kI_(0),_m2_=[0,0];
    function _nc_(param_m6_)
     {var _m0_=1-(_mY_[2]===_mY_?1:0);
      if(_m0_)
       {var tmp_m1_=_kI_(0);
        tmp_m1_[1][2]=_mY_[2];
        _mY_[2][1]=tmp_m1_[1];
        tmp_m1_[1]=_mY_[1];
        _mY_[1][2]=tmp_m1_;
        _mY_[1]=_mY_;
        _mY_[2]=_mY_;
        _m2_[1]=0;
        var curr_m3_=tmp_m1_[2];
        for(;;)
         {var _m4_=curr_m3_!==tmp_m1_?1:0;
          if(_m4_)
           {if(curr_m3_[4])wakeup_l3_(curr_m3_[3],0);
            var _m5_=curr_m3_[2],curr_m3_=_m5_;
            continue;}
          return _m4_;}}
      return _m0_;}
    function iter_s_m8_(f_m__,l_m7_)
     {if(l_m7_)
       {var
         l_m9_=l_m7_[2],
         x_na_=l_m7_[1],
         _nb_=function(param_m$_){return iter_s_m8_(f_m__,l_m9_);};
        return _mW_(_c6_(f_m__,x_na_),_nb_);}
      return return_unit_mT_;}
    var null_nd_=null,undefined_ne_=undefined;
    function _nC_(x_nf_,f_ng_)
     {return x_nf_==null_nd_?null_nd_:_c6_(f_ng_,x_nf_);}
    function _np_(x_nh_,f_ni_,g_nj_)
     {return x_nh_==null_nd_?_c6_(f_ni_,0):_c6_(g_nj_,x_nh_);}
    function _nD_(x_nk_,f_nl_){return x_nk_==null_nd_?_c6_(f_nl_,0):x_nk_;}
    function _nE_(x_nq_)
     {function _no_(x_nm_){return [0,x_nm_];}
      return _np_(x_nq_,function(param_nn_){return 0;},_no_);}
    function _nF_(x_nr_){return x_nr_!==undefined_ne_?1:0;}
    function _nA_(x_ns_,f_nt_,g_nu_)
     {return x_ns_===undefined_ne_?_c6_(f_nt_,0):_c6_(g_nu_,x_ns_);}
    function _nG_(x_nv_,f_nw_)
     {return x_nv_===undefined_ne_?_c6_(f_nw_,0):x_nv_;}
    function _nH_(x_nB_)
     {function _nz_(x_nx_){return [0,x_nx_];}
      return _nA_(x_nB_,function(param_ny_){return 0;},_nz_);}
    var
     _true_nI_=true,
     _false_nJ_=false,
     regExp_nK_=RegExp,
     array_constructor_nL_=Array;
    function array_get_nQ_(_nM_,_nN_){return _nM_[_nN_];}
    function str_array_nR_(_nO_){return _nO_;}
    function match_result_nS_(_nP_){return _nP_;}
    var date_constr_nT_=Date,math_nX_=Math;
    function escape_nW_(s_nU_){return escape(s_nU_);}
    function _nY_(e_nV_)
     {return e_nV_ instanceof array_constructor_nL_
              ?0
              :[0,new MlWrappedString(e_nV_.toString())];}
    _jW_[1]=[0,_nY_,_jW_[1]];
    function _n1_(_nZ_){return _nZ_;}
    function _n2_(_n0_){return _n0_;}
    function _n8_(f_n4_)
     {return _n2_
              (caml_js_wrap_callback
                (function(e_n3_)
                  {if(e_n3_)
                    {var res_n5_=_c6_(f_n4_,e_n3_);
                     if(!(res_n5_|0))e_n3_.preventDefault();
                     return res_n5_;}
                   var _n6_=event,res_n7_=_c6_(f_n4_,_n6_);
                   if(!(res_n7_|0))_n6_.returnValue=res_n7_;
                   return res_n7_;}));}
    var
     onIE_n9_=caml_js_on_ie(0)|0,
     window_n__=this,
     document_n$_=window_n__.document,
     html_element_oa_=this.HTMLElement,
     float32Array_oe_=this.Float32Array,
     _oc_=
      _n1_(html_element_oa_)===undefined_ne_
       ?function(e_ob_)
         {return _n1_(e_ob_.innerHTML)===undefined_ne_?null_nd_:_n2_(e_ob_);}
       :function(e_od_)
         {return e_od_ instanceof html_element_oa_?_n2_(e_od_):null_nd_;};
    function _oi_(tag_of_,e_og_)
     {var _oh_=tag_of_.toString();
      return e_og_.tagName.toLowerCase()===_oh_?_n2_(e_og_):null_nd_;}
    function _ol_(e_oj_){return _oi_(_bq_,e_oj_);}
    var _om_=caml_js_get_console(0),overflow_limit_on_=2147483;
    function _oq_(e_ok_){return _oi_(_br_,e_ok_);}
    var _op_=this.FileReader;
    pause_hook_mZ_[1]=
    function(param_oo_)
     {return 1===param_oo_
              ?(window_n__.setTimeout(caml_js_wrap_callback(_nc_),0),0)
              :0;};
    function _os_(s_or_){return _om_.log(s_or_.toString());}
    async_exception_hook_kU_[1]=
    function(exn_ot_){_os_(_bk_);_os_(_kE_(exn_ot_));return _kF_(stderr_cR_);};
    function regexp_oE_(s_ou_)
     {return new regExp_nK_(caml_js_from_byte_string(s_ou_),_bh_.toString());}
    function string_match_oF_(r_ov_,s_ox_,i_ow_)
     {r_ov_.lastIndex=i_ow_;
      var
       _oy_=r_ov_.exec(caml_js_from_byte_string(s_ox_)),
       _oz_=_oy_==null_nd_?null_nd_:match_result_nS_(_oy_);
      return _nE_(_oz_);}
    function matched_group_oG_(r_oB_,i_oA_)
     {var
       _oC_=array_get_nQ_(r_oB_,i_oA_),
       _oD_=_oC_===undefined_ne_?undefined_ne_:caml_js_to_byte_string(_oC_);
      return _nH_(_oD_);}
    var
     quote_repl_re_oH_=new regExp_nK_(_bf_.toString(),_bg_.toString()),
     _oL_=regexp_oE_(_be_);
    function split_oK_(c_oI_,s_oJ_)
     {return str_array_nR_(s_oJ_.split(_d1_(1,c_oI_).toString()));}
    var Local_exn_oM_=[0,_aw_];
    function interrupt_oO_(param_oN_){throw [0,Local_exn_oM_];}
    var
     _oP_=
      regexp_oE_
       (caml_js_to_byte_string
         (caml_js_from_byte_string(_av_).replace(_oL_,_bj_.toString()))),
     plus_re_js_string_oQ_=new regExp_nK_(_at_.toString(),_au_.toString());
    function urldecode_js_string_string_oX_(s_oR_)
     {plus_re_js_string_oQ_.lastIndex=0;
      return caml_js_to_byte_string
              (unescape(s_oR_.replace(plus_re_js_string_oQ_,_ay_.toString())));}
    function urlencode_oY_(_opt__oS_,s_oU_)
     {var with_plus_oT_=_opt__oS_?_opt__oS_[1]:1;
      if(with_plus_oT_)
       {var
         _oV_=
          caml_js_to_byte_string(escape_nW_(caml_js_from_byte_string(s_oU_)));
        _oP_.lastIndex=0;
        var afc9aadde_oW_=caml_js_from_byte_string(_oV_);
        return caml_js_to_byte_string
                (afc9aadde_oW_.replace
                  (_oP_,
                   caml_js_from_byte_string(_ax_).replace
                    (quote_repl_re_oH_,_bi_.toString())));}
      return caml_js_to_byte_string
              (escape_nW_(caml_js_from_byte_string(s_oU_)));}
    var Not_an_http_protocol_pz_=[0,_as_];
    function path_of_path_string_o5_(s_oZ_)
     {try
       {var length_o0_=s_oZ_.getLen();
        if(0===length_o0_)
         var _o1_=_bd_;
        else
         {var i_o2_=0,_o4_=47,_o3_=s_oZ_.getLen();
          for(;;)
           {if(_o3_<=i_o2_)throw [0,_c_];
            if(s_oZ_.safeGet(i_o2_)!==_o4_)
             {var _o8_=i_o2_+1|0,i_o2_=_o8_;continue;}
            if(0===i_o2_)
             var
              _o6_=
               [0,_bc_,path_of_path_string_o5_(_d2_(s_oZ_,1,length_o0_-1|0))];
            else
             {var
               _o7_=
                path_of_path_string_o5_
                 (_d2_(s_oZ_,i_o2_+1|0,(length_o0_-i_o2_|0)-1|0)),
               _o6_=[0,_d2_(s_oZ_,0,i_o2_),_o7_];}
            var _o1_=_o6_;
            break;}}}
      catch(_o9_){if(_o9_[1]===_c_)return [0,s_oZ_,0];throw _o9_;}
      return _o1_;}
    function encode_arguments_pA_(l_pb_)
     {return _d4_
              (_aF_,
               _dx_
                (function(param_o__)
                  {var
                    n_o$_=param_o__[1],
                    _pa_=_cP_(_aG_,urlencode_oY_(0,param_o__[2]));
                   return _cP_(urlencode_oY_(0,n_o$_),_pa_);},
                 l_pb_));}
    function decode_arguments_js_string_pB_(s_pc_)
     {var arr_pd_=split_oK_(38,s_pc_),len_py_=arr_pd_.length;
      function aux_pu_(acc_pt_,idx_pe_)
       {var idx_pf_=idx_pe_;
        for(;;)
         {if(0<=idx_pf_)
           {try
             {var
               _pr_=idx_pf_-1|0,
               _ps_=
                function(s_pm_)
                 {function _po_(param_pg_)
                   {var y_pk_=param_pg_[2],x_pj_=param_pg_[1];
                    function get_pi_(t_ph_)
                     {return urldecode_js_string_string_oX_
                              (_nG_(t_ph_,interrupt_oO_));}
                    var _pl_=get_pi_(y_pk_);
                    return [0,get_pi_(x_pj_),_pl_];}
                  var arr_bis_pn_=split_oK_(61,s_pm_);
                  if(2===arr_bis_pn_.length)
                   {var
                     _pp_=array_get_nQ_(arr_bis_pn_,1),
                     _pq_=_n1_([0,array_get_nQ_(arr_bis_pn_,0),_pp_]);}
                  else
                   var _pq_=undefined_ne_;
                  return _nA_(_pq_,interrupt_oO_,_po_);},
               _pv_=
                aux_pu_
                 ([0,
                   _nA_(array_get_nQ_(arr_pd_,idx_pf_),interrupt_oO_,_ps_),
                   acc_pt_],
                  _pr_);}
            catch(_pw_)
             {if(_pw_[1]===Local_exn_oM_)
               {var _px_=idx_pf_-1|0,idx_pf_=_px_;continue;}
              throw _pw_;}
            return _pv_;}
          return acc_pt_;}}
      return aux_pu_(0,len_py_-1|0);}
    var
     url_re_pC_=new regExp_nK_(caml_js_from_byte_string(_ar_)),
     file_re_qb_=new regExp_nK_(caml_js_from_byte_string(_aq_));
    function string_of_url_qa_(param_pD_)
     {switch(param_pD_[0])
       {case 1:
         var
          match_pE_=param_pD_[1],
          frag_pF_=match_pE_[6],
          args_pG_=match_pE_[5],
          port_pH_=match_pE_[2],
          path_pK_=match_pE_[3],
          host_pJ_=match_pE_[1],
          _pI_=
           caml_string_notequal(frag_pF_,_a3_)
            ?_cP_(_a2_,urlencode_oY_(0,frag_pF_))
            :_a1_,
          _pL_=args_pG_?_cP_(_a0_,encode_arguments_pA_(args_pG_)):_aZ_,
          _pN_=_cP_(_pL_,_pI_),
          _pP_=
           _cP_
            (_aX_,
             _cP_
              (_d4_
                (_aY_,
                 _dx_
                  (function(eta_pM_){return urlencode_oY_(0,eta_pM_);},
                   path_pK_)),
               _pN_)),
          _pO_=443===port_pH_?_aV_:_cP_(_aW_,string_of_int_cQ_(port_pH_)),
          _pQ_=_cP_(_pO_,_pP_);
         return _cP_(_aU_,_cP_(urlencode_oY_(0,host_pJ_),_pQ_));
        case 2:
         var
          match_pR_=param_pD_[1],
          frag_pS_=match_pR_[4],
          args_pT_=match_pR_[3],
          path_pV_=match_pR_[1],
          _pU_=
           caml_string_notequal(frag_pS_,_aT_)
            ?_cP_(_aS_,urlencode_oY_(0,frag_pS_))
            :_aR_,
          _pW_=args_pT_?_cP_(_aQ_,encode_arguments_pA_(args_pT_)):_aP_,
          _pY_=_cP_(_pW_,_pU_);
         return _cP_
                 (_aN_,
                  _cP_
                   (_d4_
                     (_aO_,
                      _dx_
                       (function(eta_pX_){return urlencode_oY_(0,eta_pX_);},
                        path_pV_)),
                    _pY_));
        default:
         var
          match_pZ_=param_pD_[1],
          frag_p0_=match_pZ_[6],
          args_p1_=match_pZ_[5],
          port_p2_=match_pZ_[2],
          path_p5_=match_pZ_[3],
          host_p4_=match_pZ_[1],
          _p3_=
           caml_string_notequal(frag_p0_,_bb_)
            ?_cP_(_ba_,urlencode_oY_(0,frag_p0_))
            :_a$_,
          _p6_=args_p1_?_cP_(_a__,encode_arguments_pA_(args_p1_)):_a9_,
          _p8_=_cP_(_p6_,_p3_),
          _p__=
           _cP_
            (_a7_,
             _cP_
              (_d4_
                (_a8_,
                 _dx_
                  (function(eta_p7_){return urlencode_oY_(0,eta_p7_);},
                   path_p5_)),
               _p8_)),
          _p9_=80===port_p2_?_a5_:_cP_(_a6_,string_of_int_cQ_(port_p2_)),
          _p$_=_cP_(_p9_,_p__);
         return _cP_(_a4_,_cP_(urlencode_oY_(0,host_p4_),_p$_));}}
    var l_qc_=location;
    urldecode_js_string_string_oX_(l_qc_.hostname);
    try {}catch(_qd_){if(_qd_[1]!==_a_)throw _qd_;}
    path_of_path_string_o5_(urldecode_js_string_string_oX_(l_qc_.pathname));
    decode_arguments_js_string_pB_(l_qc_.search);
    urldecode_js_string_string_oX_(l_qc_.href);
    var formData_ql_=this.FormData;
    function _qk_(form_contents_qe_,form_elt_qg_)
     {if(891486873<=form_contents_qe_[1])
       {var list_qf_=form_contents_qe_[2];
        list_qf_[1]=[0,form_elt_qg_,list_qf_[1]];
        return 0;}
      var
       f_qh_=form_contents_qe_[2],
       _qi_=form_elt_qg_[2],
       _qj_=form_elt_qg_[1];
      return 781515420<=_qi_[1]
              ?f_qh_.append(_qj_.toString(),_qi_[2])
              :f_qh_.append(_qj_.toString(),_qi_[2]);}
    function _qn_(param_qm_){return ActiveXObject;}
    var _qX_=[0,_N_];
    function error_qu_(f_qp_)
     {return _f3_
              (_jT_,
               function(s_qo_)
                {_om_.error(s_qo_.toString());return _j_(s_qo_);},
               f_qp_);}
    function debug_qY_(f_qr_)
     {return _f3_
              (_jT_,function(s_qq_){return _om_.log(s_qq_.toString());},f_qr_);}
    function check_error_qZ_(gl_qs_)
     {var _qt_=gl_qs_.NO;
      return caml_notequal(gl_qs_.getError(),_qt_)?error_qu_(_m_):0;}
    function load_shader_q0_(gl_qv_,shader_qx_,text_qw_)
     {gl_qv_.shaderSource(shader_qx_,text_qw_);
      gl_qv_.compileShader(shader_qx_);
      if(gl_qv_.getShaderParameter(shader_qx_,gl_qv_.COMPILE_STATUS)|0)
       return 0;
      var _qy_=new MlWrappedString(gl_qv_.getShaderInfoLog(shader_qx_));
      return _fy_(error_qu_,_p_,new MlWrappedString(text_qw_),_qy_);}
    function get_source_q1_(src_id_qz_)
     {function _qB_(param_qA_){return _f3_(error_qu_,_r_,src_id_qz_);}
      return _nD_
              (_nC_(document_n$_.getElementById(src_id_qz_.toString()),_oq_),
               _qB_).text;}
    function float32array_q2_(a_qC_)
     {var
       array_qD_=new float32Array_oe_(a_qC_.length-1),
       _qE_=0,
       _qF_=a_qC_.length-1-1|0;
      if(!(_qF_<_qE_))
       {var i_qG_=_qE_;
        for(;;)
         {array_qD_[i_qG_]=a_qC_[i_qG_+1];
          var _qH_=i_qG_+1|0;
          if(_qF_!==i_qG_){var i_qG_=_qH_;continue;}
          break;}}
      return array_qD_;}
    function _qN_(i_qI_,j_qJ_){return (i_qI_*4|0)+j_qJ_|0;}
    function _q3_(m1_qQ_,m2_qO_)
     {return _dm_
              (16,
               function(p_qK_)
                {var
                  _qL_=p_qK_%4|0,
                  _qM_=p_qK_/4|0,
                  _qP_=caml_array_get(m2_qO_,_qN_(3,_qL_)),
                  _qR_=caml_array_get(m1_qQ_,_qN_(_qM_,3))*_qP_,
                  _qS_=caml_array_get(m2_qO_,_qN_(2,_qL_)),
                  _qT_=caml_array_get(m1_qQ_,_qN_(_qM_,2))*_qS_,
                  _qU_=caml_array_get(m2_qO_,_qN_(1,_qL_)),
                  _qV_=caml_array_get(m1_qQ_,_qN_(_qM_,1))*_qU_,
                  _qW_=caml_array_get(m2_qO_,_qN_(0,_qL_));
                 return caml_array_get(m1_qQ_,_qN_(_qM_,0))*
                        _qW_+
                        _qV_+
                        _qT_+
                        _qR_;});}
    var line_regexp_q4_=regexp_oE_(_l_),couple_regexp_q6_=regexp_oE_(_k_);
    function read_coord_couple_rs_(c_q5_)
     {var _q7_=string_match_oF_(couple_regexp_q6_,c_q5_,0);
      if(_q7_)
       {var _q8_=_dx_(_c6_(matched_group_oG_,_q7_[1]),_s_);
        if(_q8_)
         {var _q9_=_q8_[1];
          if(_q9_)
           {var _q__=_q8_[2];
            if(_q__)
             {var _q$_=_q__[1];
              if(_q$_&&!_q__[2])
               return [0,
                       [0,caml_int_of_string(_q9_[1]),caml_int_of_string(_q$_[1])]];}}}
        return 0;}
      return 0;}
    function concat_rr_(a_rc_)
     {var r_ra_=[0,0],_rb_=0,_rd_=a_rc_.length-1-1|0;
      if(!(_rd_<_rb_))
       {var i_re_=_rb_;
        a:
        for(;;)
         {var len_rf_=0,param_rg_=a_rc_[i_re_+1],_rj_=r_ra_[1];
          for(;;)
           {if(param_rg_)
             {var
               l_ri_=param_rg_[2],
               _rh_=len_rf_+1|0,
               len_rf_=_rh_,
               param_rg_=l_ri_;
              continue;}
            r_ra_[1]=_rj_+len_rf_|0;
            var _rk_=i_re_+1|0;
            if(_rd_!==i_re_){var i_re_=_rk_;continue a;}
            break;}
          break;}}
      var pos_rl_=[0,-1],l_rm_=[0,0],_rq_=r_ra_[1];
      return _dm_
              (_rq_,
               function(param_rp_)
                {for(;;)
                  {var _rn_=l_rm_[1];
                   if(_rn_){var t_ro_=_rn_[1];l_rm_[1]=_rn_[2];return t_ro_;}
                   pos_rl_[1]+=1;
                   l_rm_[1]=caml_array_get(a_rc_,pos_rl_[1]);
                   continue;}});}
    var pi_rW_=4*Math.atan(1);
    function start_v8_(param_rt_)
     {var
       pos_ru_=param_rt_[1],
       norm_rw_=param_rt_[2],
       fps_text_rv_=document_n$_.createTextNode(_I_.toString()),
       _rx_=_nC_(document_n$_.getElementById(_H_.toString()),_oc_);
      if(_rx_!=null_nd_)_rx_.appendChild(fps_text_rv_);
      function _rz_(param_ry_){return _f3_(error_qu_,_n_,_g_);}
      var
       canvas_rA_=
        _nD_(_nC_(document_n$_.getElementById(_g_.toString()),_ol_),_rz_);
      function _rG_(param_rC_)
       {return _f3_
                (_jT_,
                 function(s_rB_)
                  {window_n__.alert(s_rB_.toString());return _j_(s_rB_);},
                 _o_);}
      try
       {var
         ctx_rD_=canvas_rA_.getContext(_M_.toString()),
         _rE_=
          1-(ctx_rD_==null_nd_?1:0)
           ?ctx_rD_
           :canvas_rA_.getContext(_L_.toString()),
         _rF_=_rE_;}
      catch(_sw_){var _rF_=null_nd_;}
      var
       gl_rH_=_nD_(_rF_,_rG_),
       _rI_=get_source_q1_(_G_),
       _rJ_=get_source_q1_(_F_),
       vertexShader_rK_=gl_rH_.createShader(gl_rH_.VERTEX_SHADER),
       fragmentShader_rL_=gl_rH_.createShader(gl_rH_.FRAGMENT_SHADER);
      load_shader_q0_(gl_rH_,vertexShader_rK_,_rJ_);
      load_shader_q0_(gl_rH_,fragmentShader_rL_,_rI_);
      var prog_rM_=gl_rH_.createProgram();
      gl_rH_.attachShader(prog_rM_,vertexShader_rK_);
      gl_rH_.attachShader(prog_rM_,fragmentShader_rL_);
      gl_rH_.linkProgram(prog_rM_);
      if(!(gl_rH_.getProgramParameter(prog_rM_,gl_rH_.LINK_STATUS)|0))
       error_qu_(_q_);
      gl_rH_.useProgram(prog_rM_);
      check_error_qZ_(gl_rH_);
      debug_qY_(_E_);
      gl_rH_.enable(gl_rH_.DEPTH_TEST);
      gl_rH_.depthFunc(gl_rH_.LESS);
      var
       proj_loc_rN_=gl_rH_.getUniformLocation(prog_rM_,_D_.toString()),
       lightPos_loc_rO_=gl_rH_.getUniformLocation(prog_rM_,_C_.toString()),
       ambientLight_loc_rP_=gl_rH_.getUniformLocation(prog_rM_,_B_.toString()),
       lightPos_rQ_=float32array_q2_([254,3,0,-1]),
       ambientLight_rR_=float32array_q2_([254,0.1,0.1,0.1]);
      gl_rH_.uniform3fv(lightPos_loc_rO_,lightPos_rQ_);
      gl_rH_.uniform3fv(ambientLight_loc_rP_,ambientLight_rR_);
      var pos_attr_rS_=gl_rH_.getAttribLocation(prog_rM_,_A_.toString());
      gl_rH_.enableVertexAttribArray(pos_attr_rS_);
      var array_buffer_rT_=gl_rH_.createBuffer();
      gl_rH_.bindBuffer(gl_rH_.ARRAY_BUFFER,array_buffer_rT_);
      gl_rH_.bufferData(gl_rH_.ARRAY_BUFFER,pos_ru_,gl_rH_.STATIC_DRAW);
      gl_rH_.vertexAttribPointer(pos_attr_rS_,3,gl_rH_.FLOAT,_false_nJ_,0,0);
      var norm_attr_rU_=gl_rH_.getAttribLocation(prog_rM_,_z_.toString());
      gl_rH_.enableVertexAttribArray(norm_attr_rU_);
      var norm_buffer_rV_=gl_rH_.createBuffer();
      gl_rH_.bindBuffer(gl_rH_.ARRAY_BUFFER,norm_buffer_rV_);
      gl_rH_.bufferData(gl_rH_.ARRAY_BUFFER,norm_rw_,gl_rH_.STATIC_DRAW);
      gl_rH_.vertexAttribPointer(norm_attr_rU_,3,gl_rH_.FLOAT,_false_nJ_,0,0);
      var
       _rX_=pi_rW_/2,
       mat_rY_=
        _q3_
         ([254,
           1,
           0,
           0,
           0,
           0,
           Math.cos(_rX_),
           Math.sin(_rX_),
           0,
           0,
           -Math.sin(_rX_),
           Math.cos(_rX_),
           0,
           0,
           0,
           0,
           1],
          _q3_
           ([254,0.5,0,0,0,0,0.5,0,0,0,0,0.5,0,0,0,0,1],
            [254,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]));
      check_error_qZ_(gl_rH_);
      debug_qY_(_y_);
      function get_time_r0_(param_rZ_)
       {return new date_constr_nT_().getTime();}
      var last_draw_r1_=[0,get_time_r0_(0)],draw_times_r2_=_eb_(0);
      function f_su_(param_sv_)
       {var _r3_=1*(new date_constr_nT_().getTime()/1e3);
        gl_rH_.uniformMatrix4fv
         (proj_loc_rN_,
          _false_nJ_,
          float32array_q2_
           (_q3_
             (mat_rY_,
              [254,
               Math.cos(_r3_),
               0,
               -Math.sin(_r3_),
               0,
               0,
               1,
               0,
               0,
               Math.sin(_r3_),
               0,
               Math.cos(_r3_),
               0,
               0,
               0,
               0,
               1])));
        gl_rH_.clear(gl_rH_.DEPTH_BUFFER_BIT|gl_rH_.COLOR_BUFFER_BIT);
        gl_rH_.drawArrays(gl_rH_.TRIANGLES,0,pos_ru_.length/3|0);
        check_error_qZ_(gl_rH_);
        var now_r4_=get_time_r0_(0),_r5_=now_r4_-last_draw_r1_[1];
        if(0===draw_times_r2_[1])
         {var cell_r6_=[];
          caml_update_dummy(cell_r6_,[0,_r5_,cell_r6_]);
          draw_times_r2_[1]=1;
          draw_times_r2_[2]=cell_r6_;}
        else
         {var tail_r7_=draw_times_r2_[2],cell_r8_=[0,_r5_,tail_r7_[2]];
          draw_times_r2_[1]=draw_times_r2_[1]+1|0;
          tail_r7_[2]=cell_r8_;
          draw_times_r2_[2]=cell_r8_;}
        last_draw_r1_[1]=now_r4_;
        if(50<_ef_(draw_times_r2_))_ee_(draw_times_r2_);
        var _r9_=0,_r__=_ef_(draw_times_r2_),_sf_=1e3;
        if(0===draw_times_r2_[1])
         var _r$_=_r9_;
        else
         {var tail_sa_=draw_times_r2_[2],accu_sb_=_r9_,cell_sc_=tail_sa_[2];
          for(;;)
           {var _sd_=accu_sb_+cell_sc_[1];
            if(cell_sc_!==tail_sa_)
             {var _se_=cell_sc_[2],accu_sb_=_sd_,cell_sc_=_se_;continue;}
            var _r$_=_sd_;
            break;}}
        fps_text_rv_.data=_f3_(_jV_,_J_,1/_r$_*_r__*_sf_).toString();
        var
         match_sg_=task_mU_(0),
         t_sh_=match_sg_[1],
         id_si_=[0,0],
         _sr_=0.02,
         w_sm_=match_sg_[2];
        function wait_so_(d_sj_,param_sq_)
         {var
           match_sk_=
            overflow_limit_on_<d_sj_
             ?[0,overflow_limit_on_,d_sj_-overflow_limit_on_]
             :[0,d_sj_,0],
           remain_sl_=match_sk_[2],
           step_sp_=match_sk_[1],
           cb_sn_=
            remain_sl_==0?_c6_(wakeup_l3_,w_sm_):_c6_(wait_so_,remain_sl_);
          id_si_[1]=
          [0,
           window_n__.setTimeout(caml_js_wrap_callback(cb_sn_),step_sp_*1e3)];
          return 0;}
        wait_so_(_sr_,0);
        on_cancel_mV_
         (t_sh_,
          function(param_st_)
           {var _ss_=id_si_[1];
            return _ss_?window_n__.clearTimeout(_ss_[1]):0;});
        return _mW_(t_sh_,f_su_);}
      return f_su_(0);}
    window_n__.onload=
    _n8_
     (function(param_wl_)
       {function _sy_(exn_sx_){return _f3_(error_qu_,_K_,_kE_(exn_sx_));}
        try
         {var
           _tu_=0,
           _tv_=0,
           _tw_=0,
           _tx_=0,
           _ty_=0,
           _tz_=0,
           _tA_=0,
           _tC_=
            function(frame_sz_)
             {var
               a_sA_=
                str_array_nR_(frame_sz_[4].toString().split(_x_.toString()));
              window_n__.arr=a_sA_;
              var vertex_sB_=[0,0],norm_sC_=[0,0],face_sD_=[0,0],i_sE_=0;
              for(;;)
               {var _sF_=_nH_(array_get_nQ_(a_sA_,i_sE_));
                if(_sF_)
                 {var
                   _sG_=
                    string_match_oF_
                     (line_regexp_q4_,new MlWrappedString(_sF_[1]),0);
                  if(_sG_)
                   {var _sH_=_dx_(_c6_(matched_group_oG_,_sG_[1]),_w_);
                    if(_sH_)
                     {var _sI_=_sH_[1];
                      if(_sI_)
                       {var _sJ_=_sI_[1];
                        if(caml_string_notequal(_sJ_,_v_))
                         if(caml_string_notequal(_sJ_,_u_))
                          if(caml_string_notequal(_sJ_,_t_))
                           var _sK_=0;
                          else
                           {var _sL_=_sH_[2];
                            if(_sL_)
                             {var _sM_=_sL_[1];
                              if(_sM_)
                               {var _sN_=_sL_[2];
                                if(_sN_)
                                 {var _sO_=_sN_[1];
                                  if(_sO_)
                                   {var _sP_=_sN_[2];
                                    if(_sP_)
                                     {var _sQ_=_sP_[1];
                                      if(_sQ_&&!_sP_[2])
                                       {var
                                         _sR_=
                                          [0,
                                           [1,
                                            [0,
                                             caml_float_of_string(_sM_[1]),
                                             caml_float_of_string(_sO_[1]),
                                             caml_float_of_string(_sQ_[1])]]],
                                         _sK_=1;}
                                      else
                                       var _sK_=0;}
                                    else
                                     var _sK_=0;}
                                  else
                                   var _sK_=0;}
                                else
                                 var _sK_=0;}
                              else
                               var _sK_=0;}
                            else
                             var _sK_=0;}
                         else
                          {var _sS_=_sH_[2];
                           if(_sS_)
                            {var _sT_=_sS_[1];
                             if(_sT_)
                              {var _sU_=_sS_[2];
                               if(_sU_)
                                {var _sV_=_sU_[1];
                                 if(_sV_)
                                  {var _sW_=_sU_[2];
                                   if(_sW_)
                                    {var _sX_=_sW_[1];
                                     if(_sX_&&!_sW_[2])
                                      {var
                                        _sR_=
                                         [0,
                                          [0,
                                           [0,
                                            caml_float_of_string(_sT_[1]),
                                            caml_float_of_string(_sV_[1]),
                                            caml_float_of_string(_sX_[1])]]],
                                        _sK_=1;}
                                     else
                                      var _sK_=0;}
                                   else
                                    var _sK_=0;}
                                 else
                                  var _sK_=0;}
                               else
                                var _sK_=0;}
                             else
                              var _sK_=0;}
                           else
                            var _sK_=0;}
                        else
                         {var _sY_=_sH_[2];
                          if(_sY_)
                           {var _sZ_=_sY_[1];
                            if(_sZ_)
                             {var _s0_=_sY_[2];
                              if(_s0_)
                               {var _s1_=_s0_[1];
                                if(_s1_)
                                 {var _s2_=_s0_[2];
                                  if(_s2_)
                                   {var _s3_=_s2_[1];
                                    if(_s3_&&!_s2_[2])
                                     {var
                                       _s4_=
                                        _dx_
                                         (read_coord_couple_rs_,
                                          [0,_sZ_[1],[0,_s1_[1],[0,_s3_[1],0]]]);
                                      if(_s4_)
                                       {var _s5_=_s4_[1];
                                        if(_s5_)
                                         {var _s6_=_s4_[2];
                                          if(_s6_)
                                           {var _s7_=_s6_[1];
                                            if(_s7_)
                                             {var _s8_=_s6_[2];
                                              if(_s8_)
                                               {var _s9_=_s8_[1];
                                                if(_s9_&&!_s8_[2])
                                                 {var _sR_=[0,[2,[0,_s5_[1],_s7_[1],_s9_[1]]]],_sK_=1,_s__=0;}
                                                else
                                                 var _s__=1;}
                                              else
                                               var _s__=1;}
                                            else
                                             var _s__=1;}
                                          else
                                           var _s__=1;}
                                        else
                                         var _s__=1;}
                                      else
                                       var _s__=1;
                                      if(_s__){var _sR_=0,_sK_=1;}}
                                    else
                                     var _sK_=0;}
                                  else
                                   var _sK_=0;}
                                else
                                 var _sK_=0;}
                              else
                               var _sK_=0;}
                            else
                             var _sK_=0;}
                          else
                           var _sK_=0;}}
                      else
                       var _sK_=0;}
                    else
                     var _sK_=0;
                    if(!_sK_)var _sR_=0;}
                  else
                   var _sR_=0;
                  if(_sR_)
                   {var _s$_=_sR_[1];
                    switch(_s$_[0])
                     {case 1:
                       var match_ta_=_s$_[1];
                       norm_sC_[1]=
                       [0,[0,match_ta_[1],match_ta_[2],match_ta_[3]],norm_sC_[1]];
                       break;
                      case 2:
                       var match_tb_=_s$_[1];
                       face_sD_[1]=
                       [0,[0,match_tb_[1],match_tb_[2],match_tb_[3]],face_sD_[1]];
                       break;
                      default:
                       var match_tc_=_s$_[1];
                       vertex_sB_[1]=
                       [0,[0,match_tc_[1],match_tc_[2],match_tc_[3]],vertex_sB_[1]];}}
                  var _td_=i_sE_+1|0,i_sE_=_td_;
                  continue;}
                var
                 _te_=_do_(_dD_(face_sD_[1])),
                 _tf_=_do_(_dD_(norm_sC_[1])),
                 _tg_=_do_(_dD_(vertex_sB_[1])),
                 vertex__tr_=
                  _dm_
                   (_te_.length-1,
                    function(i_th_)
                     {var
                       _ti_=caml_array_get(_te_,i_th_),
                       match_tj_=caml_array_get(_tg_,_ti_[1][1]-1|0),
                       match_tk_=caml_array_get(_tg_,_ti_[2][1]-1|0),
                       match_tl_=caml_array_get(_tg_,_ti_[3][1]-1|0);
                      return [0,
                              match_tj_[1],
                              [0,
                               match_tj_[2],
                               [0,
                                match_tj_[3],
                                [0,
                                 match_tk_[1],
                                 [0,
                                  match_tk_[2],
                                  [0,
                                   match_tk_[3],
                                   [0,match_tl_[1],[0,match_tl_[2],[0,match_tl_[3],0]]]]]]]]];}),
                 norm__ts_=
                  _dm_
                   (_te_.length-1,
                    function(i_tm_)
                     {var
                       _tn_=caml_array_get(_te_,i_tm_),
                       match_to_=caml_array_get(_tf_,_tn_[1][2]-1|0),
                       match_tp_=caml_array_get(_tf_,_tn_[2][2]-1|0),
                       match_tq_=caml_array_get(_tf_,_tn_[3][2]-1|0);
                      return [0,
                              match_to_[1],
                              [0,
                               match_to_[2],
                               [0,
                                match_to_[3],
                                [0,
                                 match_tp_[1],
                                 [0,
                                  match_tp_[2],
                                  [0,
                                   match_tp_[3],
                                   [0,match_tq_[1],[0,match_tq_[2],[0,match_tq_[3],0]]]]]]]]];}),
                 vertex_tt_=float32array_q2_(concat_rr_(vertex__tr_));
                return [0,vertex_tt_,float32array_q2_(concat_rr_(norm__ts_))];}},
           headers_tB_=_tA_?_tA_[1]:0,
           get_args_tD_=_tx_?_tx_[1]:0,
           check_headers_tE_=_tv_?_tv_[1]:function(param_tF_,_tG_){return 1;};
          if(_tw_)
           {var form_arg_tH_=_tw_[1];
            if(_ty_)
             {var post_args_tJ_=_ty_[1];
              _dE_
               (function(param_tI_)
                 {return _qk_
                          (form_arg_tH_,
                           [0,param_tI_[1],[0,-976970511,param_tI_[2].toString()]]);},
                post_args_tJ_);}
            var form_arg_tK_=[0,form_arg_tH_];}
          else
           if(_ty_)
            {var
              post_args_tL_=_ty_[1],
              _tM_=_nH_(_n1_(formData_ql_)),
              contents_tN_=
               _tM_?[0,808620462,new (_tM_[1])()]:[0,891486873,[0,0]];
             _dE_
              (function(param_tO_)
                {return _qk_
                         (contents_tN_,
                          [0,param_tO_[1],[0,-976970511,param_tO_[2].toString()]]);},
               post_args_tL_);
             var form_arg_tK_=[0,contents_tN_];}
           else
            var form_arg_tK_=0;
          if(form_arg_tK_)
           {var _tP_=form_arg_tK_[1];
            if(_tz_)
             var _tQ_=[0,_ao_,_tz_,126925477];
            else
             {if(891486873<=_tP_[1])
               {var yes_tR_=0,no_tS_=0,param_tT_=_tP_[2][1];
                for(;;)
                 {if(param_tT_)
                   {var
                     l_tU_=param_tT_[2],
                     x_tV_=param_tT_[1],
                     _tW_=781515420<=x_tV_[2][1]?0:1;
                    if(_tW_)
                     {var _tX_=[0,x_tV_,yes_tR_],yes_tR_=_tX_,param_tT_=l_tU_;
                      continue;}
                    var _tY_=[0,x_tV_,no_tS_],no_tS_=_tY_,param_tT_=l_tU_;
                    continue;}
                  var _tZ_=_dD_(no_tS_);
                  _dD_(yes_tR_);
                  if(_tZ_)
                   {var
                     nine_digits_t1_=
                      function(param_t0_)
                       {return string_of_int_cQ_(math_nX_.random()*1e9|0);},
                     _t2_=nine_digits_t1_(0),
                     _t3_=_cP_(_S_,_cP_(nine_digits_t1_(0),_t2_)),
                     _t4_=[0,_am_,[0,_cP_(_an_,_t3_)],[0,164354597,_t3_]];}
                  else
                   var _t4_=_al_;
                  var _t5_=_t4_;
                  break;}}
              else
               var _t5_=_ak_;
              var _tQ_=_t5_;}
            var match_t6_=_tQ_;}
          else
           var match_t6_=[0,_aj_,_tz_,126925477];
          var
           post_encode_t7_=match_t6_[3],
           content_type_t8_=match_t6_[2],
           _t9_=caml_js_from_byte_string(_f_),
           method__uG_=match_t6_[1],
           _uH_=
            function(handle_t__)
             {var
               res_t$_=match_result_nS_(handle_t__),
               _ua_=
                caml_js_to_byte_string
                 (_nG_(array_get_nQ_(res_t$_,1),interrupt_oO_).toLowerCase());
              if
               (caml_string_notequal(_ua_,_aE_)&&
                caml_string_notequal(_ua_,_aD_))
               {if
                 (caml_string_notequal(_ua_,_aC_)&&
                  caml_string_notequal(_ua_,_aB_))
                 {if
                   (caml_string_notequal(_ua_,_aA_)&&
                    caml_string_notequal(_ua_,_az_))
                   {var _uc_=1,_ub_=0;}
                  else
                   var _ub_=1;
                  if(_ub_){var ssl_ud_=1,_uc_=2;}}
                else
                 var _uc_=0;
                switch(_uc_)
                 {case 1:var _ue_=0;break;
                  case 2:var _ue_=1;break;
                  default:var ssl_ud_=0,_ue_=1;}
                if(_ue_)
                 {var
                   path_str_uf_=
                    urldecode_js_string_string_oX_
                     (_nG_(array_get_nQ_(res_t$_,5),interrupt_oO_)),
                   _uh_=
                    function(param_ug_){return caml_js_from_byte_string(_aI_);},
                   _uj_=
                    urldecode_js_string_string_oX_
                     (_nG_(array_get_nQ_(res_t$_,9),_uh_)),
                   _uk_=
                    function(param_ui_){return caml_js_from_byte_string(_aJ_);},
                   _ul_=
                    decode_arguments_js_string_pB_
                     (_nG_(array_get_nQ_(res_t$_,7),_uk_)),
                   _un_=path_of_path_string_o5_(path_str_uf_),
                   _uo_=
                    function(param_um_){return caml_js_from_byte_string(_aK_);},
                   _up_=
                    caml_js_to_byte_string(_nG_(array_get_nQ_(res_t$_,4),_uo_)),
                   _uq_=
                    caml_string_notequal(_up_,_aH_)
                     ?caml_int_of_string(_up_)
                     :ssl_ud_?443:80,
                   url_ur_=
                    [0,
                     urldecode_js_string_string_oX_
                      (_nG_(array_get_nQ_(res_t$_,2),interrupt_oO_)),
                     _uq_,
                     _un_,
                     path_str_uf_,
                     _ul_,
                     _uj_],
                   _us_=ssl_ud_?[1,url_ur_]:[0,url_ur_];
                  return [0,_us_];}}
              throw [0,Not_an_http_protocol_pz_];},
           _uI_=
            function(param_uF_)
             {function _uD_(handle_ut_)
               {var
                 res_uu_=match_result_nS_(handle_ut_),
                 path_str_uv_=
                  urldecode_js_string_string_oX_
                   (_nG_(array_get_nQ_(res_uu_,2),interrupt_oO_));
                function _ux_(param_uw_)
                 {return caml_js_from_byte_string(_aL_);}
                var
                 _uz_=
                  caml_js_to_byte_string(_nG_(array_get_nQ_(res_uu_,6),_ux_));
                function _uA_(param_uy_)
                 {return caml_js_from_byte_string(_aM_);}
                var
                 _uB_=
                  decode_arguments_js_string_pB_
                   (_nG_(array_get_nQ_(res_uu_,4),_uA_));
                return [0,
                        [2,
                         [0,
                          path_of_path_string_o5_(path_str_uv_),
                          path_str_uv_,
                          _uB_,
                          _uz_]]];}
              function _uE_(param_uC_){return 0;}
              return _np_(file_re_qb_.exec(_t9_),_uE_,_uD_);},
           _uJ_=_np_(url_re_pC_.exec(_t9_),_uI_,_uH_);
          if(_uJ_)
           {var _uK_=_uJ_[1];
            switch(_uK_[0])
             {case 0:
               var url_uL_=_uK_[1],_uM_=url_uL_.slice(),_uN_=url_uL_[5];
               _uM_[5]=0;
               var match_uO_=[0,string_of_url_qa_([0,_uM_]),_uN_],_uP_=1;
               break;
              case 1:
               var url_uQ_=_uK_[1],_uR_=url_uQ_.slice(),_uS_=url_uQ_[5];
               _uR_[5]=0;
               var match_uO_=[0,string_of_url_qa_([1,_uR_]),_uS_],_uP_=1;
               break;
              default:var _uP_=0;}}
          else
           var _uP_=0;
          if(!_uP_)var match_uO_=[0,_f_,0];
          var
           url_uT_=match_uO_[1],
           _uU_=_cM_(match_uO_[2],get_args_tD_),
           url_uV_=
            _uU_?_cP_(url_uT_,_cP_(_ai_,encode_arguments_pA_(_uU_))):url_uT_,
           match_uW_=task_mU_(0),
           w_uX_=match_uW_[2],
           res_uY_=match_uW_[1];
          try
           {var _uZ_=new XMLHttpRequest(),req_u0_=_uZ_;}
          catch(_v$_)
           {try
             {var
               a287eef3f_u1_=_qn_(0),
               _u2_=new a287eef3f_u1_(_R_.toString()),
               req_u0_=_u2_;}
            catch(_u9_)
             {try
               {var
                 adf052a6f_u3_=_qn_(0),
                 _u4_=new adf052a6f_u3_(_Q_.toString()),
                 req_u0_=_u4_;}
              catch(_u8_)
               {try
                 {var
                   a90ab7ebb_u5_=_qn_(0),
                   _u6_=new a90ab7ebb_u5_(_P_.toString());}
                catch(_u7_){throw [0,_d_,_O_];}
                var req_u0_=_u6_;}}}
          if(_tu_)req_u0_.overrideMimeType(_tu_[1].toString());
          req_u0_.open(method__uG_.toString(),url_uV_.toString(),_true_nI_);
          if(content_type_t8_)
           req_u0_.setRequestHeader
            (_ah_.toString(),content_type_t8_[1].toString());
          _dE_
           (function(param_u__)
             {return req_u0_.setRequestHeader
                      (param_u__[1].toString(),param_u__[2].toString());},
            headers_tB_);
          var
           headers_ve_=
            function(s_vc_)
             {function _vb_(v_u$_){return [0,new MlWrappedString(v_u$_)];}
              function _vd_(param_va_){return 0;}
              return _np_
                      (req_u0_.getResponseHeader(caml_js_from_byte_string(s_vc_)),
                       _vd_,
                       _vb_);},
           checked_vf_=[0,0],
           do_check_headers_vi_=
            function(param_vh_)
             {var
               _vg_=
                checked_vf_[1]
                 ?0
                 :_f3_(check_headers_tE_,req_u0_.status,headers_ve_)
                   ?0
                   :(wakeup_result_lB_
                      (w_uX_,[1,[0,_qX_,[0,req_u0_.status,headers_ve_]]]),
                     req_u0_.abort(),
                     1);
              
              checked_vf_[1]=1;
              return 0;};
          req_u0_.onreadystatechange=
          caml_js_wrap_callback
           (function(param_vn_)
             {switch(req_u0_.readyState)
               {case 2:if(!onIE_n9_)return do_check_headers_vi_(0);break;
                case 3:if(onIE_n9_)return do_check_headers_vi_(0);break;
                case 4:
                 do_check_headers_vi_(0);
                 var
                  _vm_=
                   function(param_vl_)
                    {var _vj_=_nE_(req_u0_.responseXML);
                     if(_vj_)
                      {var doc_vk_=_vj_[1];
                       return _n2_(doc_vk_.documentElement)===null_nd_
                               ?0
                               :[0,doc_vk_];}
                     return 0;};
                 return wakeup_l3_
                         (w_uX_,
                          [0,
                           url_uV_,
                           req_u0_.status,
                           headers_ve_,
                           new MlWrappedString(req_u0_.responseText),
                           _vm_]);
                default:}
              return 0;});
          if(form_arg_tK_)
           {var _vo_=form_arg_tK_[1];
            if(891486873<=_vo_[1])
             {var l_vp_=_vo_[2];
              if(typeof post_encode_t7_==="number")
               {var _vv_=l_vp_[1];
                req_u0_.send
                 (_n2_
                   (_d4_
                      (_ae_,
                       _dx_
                        (function(param_vq_)
                          {var _vr_=param_vq_[2],_vs_=param_vq_[1];
                           if(781515420<=_vr_[1])
                            {var
                              _vt_=
                               _cP_
                                (_ag_,urlencode_oY_(0,new MlWrappedString(_vr_[2].name)));
                             return _cP_(urlencode_oY_(0,_vs_),_vt_);}
                           var
                            _vu_=
                             _cP_(_af_,urlencode_oY_(0,new MlWrappedString(_vr_[2])));
                           return _cP_(urlencode_oY_(0,_vs_),_vu_);},
                         _vv_)).toString
                     ()));}
              else
               {var
                 boundary_vw_=post_encode_t7_[2],
                 _vz_=
                  function(data_vx_)
                   {var data_vy_=_n2_(data_vx_.join(_ap_.toString()));
                    return _nF_(req_u0_.sendAsBinary)
                            ?req_u0_.sendAsBinary(data_vy_)
                            :req_u0_.send(data_vy_);},
                 _vB_=l_vp_[1],
                 b_vA_=new array_constructor_nL_(),
                 _v6_=
                  function(param_vC_)
                   {b_vA_.push(_cP_(_T_,_cP_(boundary_vw_,_U_)).toString());
                    return b_vA_;};
                _mX_
                 (_mX_
                   (iter_s_m8_
                     (function(v_vD_)
                       {b_vA_.push(_cP_(_Y_,_cP_(boundary_vw_,_Z_)).toString());
                        var _vE_=v_vD_[2],_vF_=v_vD_[1];
                        if(781515420<=_vE_[1])
                         {var
                           value_vG_=_vE_[2],
                           _vN_=-1041425454,
                           _vO_=
                            function(file_vM_)
                             {var
                               _vJ_=_ad_.toString(),
                               _vI_=_ac_.toString(),
                               _vH_=_nH_(value_vG_.name);
                              if(_vH_)
                               var _vK_=_vH_[1];
                              else
                               {var
                                 _vL_=_nH_(value_vG_.fileName),
                                 _vK_=_vL_?_vL_[1]:_j_(_bl_);}
                              b_vA_.push
                               (_cP_(_aa_,_cP_(_vF_,_ab_)).toString(),_vK_,_vI_,_vJ_);
                              b_vA_.push(___.toString(),file_vM_,_$_.toString());
                              return return_l6_(0);},
                           _vP_=_nH_(_n1_(_op_));
                          if(_vP_)
                           {var
                             reader_vQ_=new (_vP_[1])(),
                             match_vR_=task_mU_(0),
                             res_vS_=match_vR_[1],
                             w_vW_=match_vR_[2];
                            reader_vQ_.onloadend=
                            _n8_
                             (function(param_vX_)
                               {if(2===reader_vQ_.readyState)
                                 {var
                                   _vT_=reader_vQ_.result,
                                   _vU_=
                                    caml_equal(typeof _vT_,_bm_.toString())?_n2_(_vT_):null_nd_,
                                   _vV_=_nE_(_vU_);
                                  if(!_vV_)throw [0,_d_,_bn_];
                                  wakeup_l3_(w_vW_,_vV_[1]);}
                                return _false_nJ_;});
                            on_cancel_mV_
                             (res_vS_,function(param_vY_){return reader_vQ_.abort();});
                            if(typeof _vN_==="number")
                             if(-550809787===_vN_)
                              reader_vQ_.readAsDataURL(value_vG_);
                             else
                              if(936573133<=_vN_)
                               reader_vQ_.readAsText(value_vG_);
                              else
                               reader_vQ_.readAsBinaryString(value_vG_);
                            else
                             reader_vQ_.readAsText(value_vG_,_vN_[2]);
                            var _vZ_=res_vS_;}
                          else
                           {var fail_v1_=function(param_v0_){return _j_(_bp_);};
                            if(typeof _vN_==="number")
                             var
                              _v2_=
                               -550809787===_vN_
                                ?_nF_(value_vG_.getAsDataURL)
                                  ?value_vG_.getAsDataURL()
                                  :fail_v1_(0)
                                :936573133<=_vN_
                                  ?_nF_(value_vG_.getAsText)
                                    ?value_vG_.getAsText(_bo_.toString())
                                    :fail_v1_(0)
                                  :_nF_(value_vG_.getAsBinary)
                                    ?value_vG_.getAsBinary()
                                    :fail_v1_(0);
                            else
                             {var
                               e_v3_=_vN_[2],
                               _v2_=
                                _nF_(value_vG_.getAsText)
                                 ?value_vG_.getAsText(e_v3_)
                                 :fail_v1_(0);}
                            var _vZ_=return_l6_(_v2_);}
                          return _mW_(_vZ_,_vO_);}
                        var value_v5_=_vE_[2],_v4_=_X_.toString();
                        b_vA_.push
                         (_cP_(_V_,_cP_(_vF_,_W_)).toString(),value_v5_,_v4_);
                        return return_l6_(0);},
                      _vB_),
                    _v6_),
                  _vz_);}}
            else
             req_u0_.send(_vo_[2]);}
          else
           req_u0_.send(null_nd_);
          on_cancel_mV_(res_uY_,function(param_v7_){return req_u0_.abort();});
          var _v9_=_mW_(_mX_(res_uY_,_tC_),start_v8_),_v__=_v9_;}
        catch(_wa_){var _v__=fail_my_(_wa_);}
        var t_wb_=repr_kT_(_v__),_wc_=t_wb_[1];
        switch(_wc_[0])
         {case 1:_sy_(_wc_[1]);break;
          case 2:
           var
            sleeper_we_=_wc_[1],
            res_wd_=temp_mp_(t_wb_),
            data_wg_=current_data_kK_[1];
           add_immutable_waiter_mA_
            (sleeper_we_,
             function(state_wf_)
              {switch(state_wf_[0])
                {case 0:return fast_connect_l5_(res_wd_,state_wf_);
                 case 1:
                  var exn_wh_=state_wf_[1];
                  current_data_kK_[1]=data_wg_;
                  try
                   {var _wi_=_sy_(exn_wh_),_wj_=_wi_;}
                  catch(_wk_){var _wj_=fail_my_(_wk_);}
                  return connect_l4_(res_wd_,_wj_);
                 default:throw [0,_d_,_bC_];}});
           break;
          case 3:throw [0,_d_,_bB_];
          default:}
        return _true_nI_;});
    do_at_exit_cY_(0);
    return;}
  ());
