// This program was compiled from OCaml by js_of_ocaml 1.4
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (this.len == null) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_convert_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_convert_raw_backtrace' not implemented");
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_raw_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_raw_backtrace' not implemented");
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_get_console () {
  var c = this.console?this.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_const_word_size () { return 32; }
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _iC_(_om_,_on_,_oo_,_op_,_oq_,_or_,_os_)
     {return _om_.length==6
              ?_om_(_on_,_oo_,_op_,_oq_,_or_,_os_)
              :caml_call_gen(_om_,[_on_,_oo_,_op_,_oq_,_or_,_os_]);}
    function _et_(_oi_,_oj_,_ok_,_ol_)
     {return _oi_.length==3
              ?_oi_(_oj_,_ok_,_ol_)
              :caml_call_gen(_oi_,[_oj_,_ok_,_ol_]);}
    function _eY_(_of_,_og_,_oh_)
     {return _of_.length==2?_of_(_og_,_oh_):caml_call_gen(_of_,[_og_,_oh_]);}
    function _cA_(_od_,_oe_)
     {return _od_.length==1?_od_(_oe_):caml_call_gen(_od_,[_oe_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Assert_failure")],
     _d_=new MlString("File \"%s\", line %d, characters %d-%d: %s");
    caml_register_global(6,[0,new MlString("Not_found")]);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _ca_=[0,new MlString("Out_of_memory")],
     _b$_=[0,new MlString("Match_failure")],
     _b__=[0,new MlString("Stack_overflow")],
     _b9_=[0,new MlString("Undefined_recursive_module")],
     _b8_=new MlString("%.12g"),
     _b7_=new MlString("."),
     _b6_=new MlString("%d"),
     _b5_=new MlString("true"),
     _b4_=new MlString("false"),
     _b3_=new MlString("Pervasives.do_at_exit"),
     _b2_=new MlString("\\b"),
     _b1_=new MlString("\\t"),
     _b0_=new MlString("\\n"),
     _bZ_=new MlString("\\r"),
     _bY_=new MlString("\\\\"),
     _bX_=new MlString("\\'"),
     _bW_=new MlString(""),
     _bV_=new MlString("String.blit"),
     _bU_=new MlString("String.sub"),
     _bT_=new MlString("Queue.Empty"),
     _bS_=new MlString("Buffer.add: cannot grow buffer"),
     _bR_=new MlString(""),
     _bQ_=new MlString(""),
     _bP_=new MlString("%.12g"),
     _bO_=new MlString("\""),
     _bN_=new MlString("\""),
     _bM_=new MlString("'"),
     _bL_=new MlString("'"),
     _bK_=new MlString("nan"),
     _bJ_=new MlString("neg_infinity"),
     _bI_=new MlString("infinity"),
     _bH_=new MlString("."),
     _bG_=new MlString("printf: bad positional specification (0)."),
     _bF_=new MlString("%_"),
     _bE_=[0,new MlString("printf.ml"),143,8],
     _bD_=new MlString("'"),
     _bC_=new MlString("Printf: premature end of format string '"),
     _bB_=new MlString("'"),
     _bA_=new MlString(" in format string '"),
     _bz_=new MlString(", at char number "),
     _by_=new MlString("Printf: bad conversion %"),
     _bx_=new MlString("Sformat.index_of_int: negative argument "),
     _bw_=new MlString(""),
     _bv_=new MlString(", %s%s"),
     _bu_=[1,1],
     _bt_=new MlString("%s\n"),
     _bs_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _br_=new MlString("Raised at"),
     _bq_=new MlString("Re-raised at"),
     _bp_=new MlString("Raised by primitive operation at"),
     _bo_=new MlString("Called from"),
     _bn_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _bm_=new MlString("%s unknown location"),
     _bl_=new MlString("Out of memory"),
     _bk_=new MlString("Stack overflow"),
     _bj_=new MlString("Pattern matching failed"),
     _bi_=new MlString("Assertion failed"),
     _bh_=new MlString("Undefined recursive module"),
     _bg_=new MlString("(%s%s)"),
     _bf_=new MlString(""),
     _be_=new MlString(""),
     _bd_=new MlString("(%s)"),
     _bc_=new MlString("%d"),
     _bb_=new MlString("%S"),
     _ba_=new MlString("_"),
     _a$_=[0,new MlString("src/core/lwt.ml"),648,20],
     _a__=[0,new MlString("src/core/lwt.ml"),651,8],
     _a9_=[0,new MlString("src/core/lwt.ml"),498,8],
     _a8_=[0,new MlString("src/core/lwt.ml"),487,9],
     _a7_=new MlString("Lwt.wakeup_result"),
     _a6_=new MlString("Lwt.Canceled"),
     _a5_=new MlString("\""),
     _a4_=new MlString(" name=\""),
     _a3_=new MlString("\""),
     _a2_=new MlString(" type=\""),
     _a1_=new MlString("<"),
     _a0_=new MlString(">"),
     _aZ_=new MlString(""),
     _aY_=new MlString("<input name=\"x\">"),
     _aX_=new MlString("input"),
     _aW_=new MlString("x"),
     _aV_=new MlString("iframe"),
     _aU_=new MlString("br"),
     _aT_=new MlString("textarea"),
     _aS_=new MlString("input"),
     _aR_=new MlString("Exception during Lwt.async: "),
     _aQ_=new MlString("^error_in_anchor^"),
     _aP_=[0,new MlString("main.ml"),72,76],
     _aO_=new MlString("href"),
     _aN_=new MlString("global"),
     _aM_=new MlString("wiki"),
     _aL_=new MlString("^error2_in_anchor^"),
     _aK_=[0,new MlString("]]"),0],
     _aJ_=new MlString("[["),
     _aI_=new MlString(""),
     _aH_=[0,new MlString("]]"),0],
     _aG_=new MlString("|"),
     _aF_=new MlString("[["),
     _aE_=new MlString(""),
     _aD_=[0,new MlString("main.ml"),67,35],
     _aC_=new MlString("#text"),
     _aB_=new MlString("A"),
     _aA_=new MlString("B"),
     _az_=new MlString("BR"),
     _ay_=new MlString("DIV"),
     _ax_=new MlString("H1"),
     _aw_=new MlString("H2"),
     _av_=new MlString("H3"),
     _au_=new MlString("HR"),
     _at_=new MlString("I"),
     _as_=new MlString("P"),
     _ar_=new MlString("^"),
     _aq_=new MlString("^"),
     _ap_=new MlString("\n\n"),
     _ao_=[0,new MlString("//")],
     _an_=new MlString("----"),
     _am_=new MlString("\\\\"),
     _al_=[0,new MlString("**")],
     _ak_=new MlString("wysitype"),
     _aj_=new MlString("\n\n"),
     _ai_=new MlString(""),
     _ah_=new MlString("lololo"),
     _ag_=new MlString("Enter a wikipage"),
     _af_=new MlString(""),
     _ae_=[0,new MlString("</a>"),0],
     _ad_=new MlString("\" wysitype=\"wiki\">"),
     _ac_=new MlString("<a href=\""),
     _ab_=new MlString("inserthtml"),
     _aa_=new MlString("http://google.ru"),
     _$_=new MlString("Enter a link"),
     ___=new MlString("desc"),
     _Z_=new MlString("Enter description"),
     _Y_=[0,new MlString("</a>"),0],
     _X_=new MlString("\" wysitype=\"global\">"),
     _W_=new MlString("<a href=\""),
     _V_=new MlString(""),
     _U_=new MlString("inserthtml"),
     _T_=new MlString("submit"),
     _S_=
      new
       MlString
       ("<html><body><p><b>Camelus</b><i>bactrianus</i></p></body></html>"),
     _R_=new MlString("On"),
     _Q_=new MlString("inserthorizontalrule"),
     _P_=new MlString("hr"),
     _O_=new MlString("removeformat"),
     _N_=new MlString("remove format"),
     _M_=new MlString("bold"),
     _L_=new MlString("B"),
     _K_=new MlString("italic"),
     _J_=new MlString("I"),
     _I_=new MlString("formatblock"),
     _H_=new MlString("p"),
     _G_=[0,[0,new MlString("p")]],
     _F_=new MlString("formatblock"),
     _E_=new MlString("h1"),
     _D_=[0,[0,new MlString("h1")]],
     _C_=new MlString("formatblock"),
     _B_=new MlString("h2"),
     _A_=[0,[0,new MlString("h2")]],
     _z_=new MlString("formatblock"),
     _y_=new MlString("h3"),
     _x_=[0,[0,new MlString("h3")]],
     _w_=new MlString("inserthtml"),
     _v_=new MlString("link"),
     _u_=new MlString("inserthtml"),
     _t_=new MlString("link2wiki"),
     _s_=new MlString("1px black solid"),
     _r_=new MlString("5px"),
     _q_=new MlString("wikiFrame"),
     _p_=new MlString("2px blue solid"),
     _o_=new MlString("5px"),
     _n_=new MlString(""),
     _m_=[0,new MlString("main.ml"),96,17],
     _l_=new MlString("wiki_demo"),
     _k_=new MlString("2px green solid"),
     _j_=new MlString("#"),
     _i_=new MlString("wysiFrame"),
     _h_=new MlString("Main.Break");
    function _g_(s_e_){throw [0,_a_,s_e_];}
    function _cb_(s_f_){throw [0,_b_,s_f_];}
    function _ci_(s1_cc_,s2_ce_)
     {var
       l1_cd_=s1_cc_.getLen(),
       l2_cf_=s2_ce_.getLen(),
       s_cg_=caml_create_string(l1_cd_+l2_cf_|0);
      caml_blit_string(s1_cc_,0,s_cg_,0,l1_cd_);
      caml_blit_string(s2_ce_,0,s_cg_,l1_cd_,l2_cf_);
      return s_cg_;}
    function string_of_int_cj_(n_ch_){return caml_format_int(_b6_,n_ch_);}
    var stderr_ck_=caml_ml_open_descriptor_out(2);
    function output_string_cs_(oc_cm_,s_cl_)
     {return caml_ml_output(oc_cm_,s_cl_,0,s_cl_.getLen());}
    function do_at_exit_cr_(param_cq_)
     {var param_cn_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_cn_)
         {var l_co_=param_cn_[2];
          try {}catch(_cp_){}
          var param_cn_=l_co_;
          continue;}
        return 0;}}
    caml_register_named_value(_b3_,do_at_exit_cr_);
    function _cw_(_cu_,_ct_){return caml_ml_output_char(_cu_,_ct_);}
    function _cD_(_cv_){return caml_ml_flush(_cv_);}
    function _cC_(f_cz_,param_cx_)
     {var param_cy_=param_cx_;
      for(;;)
       {if(param_cy_)
         {var l_cB_=param_cy_[2];
          _cA_(f_cz_,param_cy_[1]);
          var param_cy_=l_cB_;
          continue;}
        return 0;}}
    function _c0_(n_cE_,c_cG_)
     {var s_cF_=caml_create_string(n_cE_);
      caml_fill_string(s_cF_,0,n_cE_,c_cG_);
      return s_cF_;}
    function _c1_(s_cJ_,ofs_cH_,len_cI_)
     {if(0<=ofs_cH_&&0<=len_cI_&&!((s_cJ_.getLen()-len_cI_|0)<ofs_cH_))
       {var r_cK_=caml_create_string(len_cI_);
        caml_blit_string(s_cJ_,ofs_cH_,r_cK_,0,len_cI_);
        return r_cK_;}
      return _cb_(_bU_);}
    function _c2_(s1_cN_,ofs1_cM_,s2_cP_,ofs2_cO_,len_cL_)
     {if
       (0<=
        len_cL_&&
        0<=
        ofs1_cM_&&
        !((s1_cN_.getLen()-len_cL_|0)<ofs1_cM_)&&
        0<=
        ofs2_cO_&&
        !((s2_cP_.getLen()-len_cL_|0)<ofs2_cO_))
       return caml_blit_string(s1_cN_,ofs1_cM_,s2_cP_,ofs2_cO_,len_cL_);
      return _cb_(_bV_);}
    function _c3_(sep_cW_,l_cQ_)
     {if(l_cQ_)
       {var hd_cR_=l_cQ_[1],num_cS_=[0,0],len_cT_=[0,0],tl_cV_=l_cQ_[2];
        _cC_
         (function(s_cU_)
           {num_cS_[1]+=1;len_cT_[1]=len_cT_[1]+s_cU_.getLen()|0;return 0;},
          l_cQ_);
        var
         r_cX_=
          caml_create_string
           (len_cT_[1]+caml_mul(sep_cW_.getLen(),num_cS_[1]-1|0)|0);
        caml_blit_string(hd_cR_,0,r_cX_,0,hd_cR_.getLen());
        var pos_cY_=[0,hd_cR_.getLen()];
        _cC_
         (function(s_cZ_)
           {caml_blit_string(sep_cW_,0,r_cX_,pos_cY_[1],sep_cW_.getLen());
            pos_cY_[1]=pos_cY_[1]+sep_cW_.getLen()|0;
            caml_blit_string(s_cZ_,0,r_cX_,pos_cY_[1],s_cZ_.getLen());
            pos_cY_[1]=pos_cY_[1]+s_cZ_.getLen()|0;
            return 0;},
          tl_cV_);
        return r_cX_;}
      return _bW_;}
    var
     _c4_=caml_sys_const_word_size(0),
     _c5_=caml_mul(_c4_/8|0,(1<<(_c4_-10|0))-1|0)-1|0,
     _do_=252,
     _dn_=253,
     _dm_=[0,_bT_];
    function _dl_(n_c6_)
     {var
       n_c7_=1<=n_c6_?n_c6_:1,
       n_c8_=_c5_<n_c7_?_c5_:n_c7_,
       s_c9_=caml_create_string(n_c8_);
      return [0,s_c9_,0,n_c8_,s_c9_];}
    function _dp_(b_c__){return _c1_(b_c__[1],0,b_c__[2]);}
    function _df_(b_c$_,more_db_)
     {var new_len_da_=[0,b_c$_[3]];
      for(;;)
       {if(new_len_da_[1]<(b_c$_[2]+more_db_|0))
         {new_len_da_[1]=2*new_len_da_[1]|0;continue;}
        if(_c5_<new_len_da_[1])
         if((b_c$_[2]+more_db_|0)<=_c5_)new_len_da_[1]=_c5_;else _g_(_bS_);
        var new_buffer_dc_=caml_create_string(new_len_da_[1]);
        _c2_(b_c$_[1],0,new_buffer_dc_,0,b_c$_[2]);
        b_c$_[1]=new_buffer_dc_;
        b_c$_[3]=new_len_da_[1];
        return 0;}}
    function _dq_(b_dd_,c_dg_)
     {var pos_de_=b_dd_[2];
      if(b_dd_[3]<=pos_de_)_df_(b_dd_,1);
      b_dd_[1].safeSet(pos_de_,c_dg_);
      b_dd_[2]=pos_de_+1|0;
      return 0;}
    function _dr_(b_dj_,s_dh_)
     {var len_di_=s_dh_.getLen(),new_position_dk_=b_dj_[2]+len_di_|0;
      if(b_dj_[3]<new_position_dk_)_df_(b_dj_,len_di_);
      _c2_(s_dh_,0,b_dj_[1],b_dj_[2],len_di_);
      b_dj_[2]=new_position_dk_;
      return 0;}
    function index_of_int_dv_(i_ds_)
     {return 0<=i_ds_?i_ds_:_g_(_ci_(_bx_,string_of_int_cj_(i_ds_)));}
    function add_int_index_dw_(i_dt_,idx_du_)
     {return index_of_int_dv_(i_dt_+idx_du_|0);}
    var _dx_=_cA_(add_int_index_dw_,1);
    function _dE_(fmt_dy_){return _c1_(fmt_dy_,0,fmt_dy_.getLen());}
    function bad_conversion_dG_(sfmt_dz_,i_dA_,c_dC_)
     {var
       _dB_=_ci_(_bA_,_ci_(sfmt_dz_,_bB_)),
       _dD_=_ci_(_bz_,_ci_(string_of_int_cj_(i_dA_),_dB_));
      return _cb_(_ci_(_by_,_ci_(_c0_(1,c_dC_),_dD_)));}
    function bad_conversion_format_ez_(fmt_dF_,i_dI_,c_dH_)
     {return bad_conversion_dG_(_dE_(fmt_dF_),i_dI_,c_dH_);}
    function incomplete_format_eA_(fmt_dJ_)
     {return _cb_(_ci_(_bC_,_ci_(_dE_(fmt_dJ_),_bD_)));}
    function extract_format_d7_(fmt_dK_,start_dS_,stop_dU_,widths_dW_)
     {function skip_positional_spec_dR_(start_dL_)
       {if
         ((fmt_dK_.safeGet(start_dL_)-48|0)<
          0||
          9<
          (fmt_dK_.safeGet(start_dL_)-48|0))
         return start_dL_;
        var i_dM_=start_dL_+1|0;
        for(;;)
         {var _dN_=fmt_dK_.safeGet(i_dM_);
          if(48<=_dN_)
           {if(!(58<=_dN_)){var _dP_=i_dM_+1|0,i_dM_=_dP_;continue;}
            var _dO_=0;}
          else
           if(36===_dN_){var _dQ_=i_dM_+1|0,_dO_=1;}else var _dO_=0;
          if(!_dO_)var _dQ_=start_dL_;
          return _dQ_;}}
      var
       start_dT_=skip_positional_spec_dR_(start_dS_+1|0),
       b_dV_=_dl_((stop_dU_-start_dT_|0)+10|0);
      _dq_(b_dV_,37);
      var l1_dX_=widths_dW_,l2_dY_=0;
      for(;;)
       {if(l1_dX_)
         {var
           l_dZ_=l1_dX_[2],
           _d0_=[0,l1_dX_[1],l2_dY_],
           l1_dX_=l_dZ_,
           l2_dY_=_d0_;
          continue;}
        var i_d1_=start_dT_,widths_d2_=l2_dY_;
        for(;;)
         {if(i_d1_<=stop_dU_)
           {var _d3_=fmt_dK_.safeGet(i_d1_);
            if(42===_d3_)
             {if(widths_d2_)
               {var t_d4_=widths_d2_[2];
                _dr_(b_dV_,string_of_int_cj_(widths_d2_[1]));
                var
                 i_d5_=skip_positional_spec_dR_(i_d1_+1|0),
                 i_d1_=i_d5_,
                 widths_d2_=t_d4_;
                continue;}
              throw [0,_c_,_bE_];}
            _dq_(b_dV_,_d3_);
            var _d6_=i_d1_+1|0,i_d1_=_d6_;
            continue;}
          return _dp_(b_dV_);}}}
    function extract_format_int_f1_
     (conv_eb_,fmt_d$_,start_d__,stop_d9_,widths_d8_)
     {var sfmt_ea_=extract_format_d7_(fmt_d$_,start_d__,stop_d9_,widths_d8_);
      if(78!==conv_eb_&&110!==conv_eb_)return sfmt_ea_;
      sfmt_ea_.safeSet(sfmt_ea_.getLen()-1|0,117);
      return sfmt_ea_;}
    function sub_format_eB_
     (incomplete_format_ei_,bad_conversion_format_es_,conv_ex_,fmt_ec_,i_ew_)
     {var len_ed_=fmt_ec_.getLen();
      function sub_fmt_eu_(c_ee_,i_er_)
       {var close_ef_=40===c_ee_?41:125;
        function sub_eq_(j_eg_)
         {var j_eh_=j_eg_;
          for(;;)
           {if(len_ed_<=j_eh_)return _cA_(incomplete_format_ei_,fmt_ec_);
            if(37===fmt_ec_.safeGet(j_eh_))
             {var _ej_=j_eh_+1|0;
              if(len_ed_<=_ej_)
               var _ek_=_cA_(incomplete_format_ei_,fmt_ec_);
              else
               {var _el_=fmt_ec_.safeGet(_ej_),_em_=_el_-40|0;
                if(_em_<0||1<_em_)
                 {var _en_=_em_-83|0;
                  if(_en_<0||2<_en_)
                   var _eo_=1;
                  else
                   switch(_en_)
                    {case 1:var _eo_=1;break;
                     case 2:var _ep_=1,_eo_=0;break;
                     default:var _ep_=0,_eo_=0;}
                  if(_eo_){var _ek_=sub_eq_(_ej_+1|0),_ep_=2;}}
                else
                 var _ep_=0===_em_?0:1;
                switch(_ep_)
                 {case 1:
                   var
                    _ek_=
                     _el_===close_ef_
                      ?_ej_+1|0
                      :_et_(bad_conversion_format_es_,fmt_ec_,i_er_,_el_);
                   break;
                  case 2:break;
                  default:var _ek_=sub_eq_(sub_fmt_eu_(_el_,_ej_+1|0)+1|0);}}
              return _ek_;}
            var _ev_=j_eh_+1|0,j_eh_=_ev_;
            continue;}}
        return sub_eq_(i_er_);}
      return sub_fmt_eu_(conv_ex_,i_ew_);}
    function sub_format_for_printf_e1_(conv_ey_)
     {return _et_
              (sub_format_eB_,
               incomplete_format_eA_,
               bad_conversion_format_ez_,
               conv_ey_);}
    function iter_on_format_args_ff_(fmt_eC_,add_conv_eN_,add_char_eX_)
     {var lim_eD_=fmt_eC_.getLen()-1|0;
      function scan_fmt_eZ_(i_eE_)
       {var i_eF_=i_eE_;
        a:
        for(;;)
         {if(i_eF_<lim_eD_)
           {if(37===fmt_eC_.safeGet(i_eF_))
             {var skip_eG_=0,i_eH_=i_eF_+1|0;
              for(;;)
               {if(lim_eD_<i_eH_)
                 var _eI_=incomplete_format_eA_(fmt_eC_);
                else
                 {var _eJ_=fmt_eC_.safeGet(i_eH_);
                  if(58<=_eJ_)
                   {if(95===_eJ_)
                     {var _eL_=i_eH_+1|0,_eK_=1,skip_eG_=_eK_,i_eH_=_eL_;
                      continue;}}
                  else
                   if(32<=_eJ_)
                    switch(_eJ_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _eM_=i_eH_+1|0,i_eH_=_eM_;continue;
                      case 10:
                       var _eO_=_et_(add_conv_eN_,skip_eG_,i_eH_,105),i_eH_=_eO_;
                       continue;
                      default:var _eP_=i_eH_+1|0,i_eH_=_eP_;continue;}
                  var i_eQ_=i_eH_;
                  c:
                  for(;;)
                   {if(lim_eD_<i_eQ_)
                     var _eR_=incomplete_format_eA_(fmt_eC_);
                    else
                     {var _eS_=fmt_eC_.safeGet(i_eQ_);
                      if(126<=_eS_)
                       var _eT_=0;
                      else
                       switch(_eS_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,105),_eT_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,102),_eT_=1;break;
                         case 33:
                         case 37:
                         case 44:
                         case 64:var _eR_=i_eQ_+1|0,_eT_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,115),_eT_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,_eS_),_eT_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_eU_=i_eQ_+1|0;
                          if(lim_eD_<j_eU_)
                           {var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,105),_eT_=1;}
                          else
                           {var _eV_=fmt_eC_.safeGet(j_eU_)-88|0;
                            if(_eV_<0||32<_eV_)
                             var _eW_=1;
                            else
                             switch(_eV_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _eR_=
                                  _eY_
                                   (add_char_eX_,_et_(add_conv_eN_,skip_eG_,i_eQ_,_eS_),105),
                                 _eT_=1,
                                 _eW_=0;
                                break;
                               default:var _eW_=1;}
                            if(_eW_)
                             {var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,105),_eT_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,99),_eT_=1;break;
                         case 66:
                         case 98:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,66),_eT_=1;break;
                         case 41:
                         case 125:
                          var _eR_=_et_(add_conv_eN_,skip_eG_,i_eQ_,_eS_),_eT_=1;
                          break;
                         case 40:
                          var
                           _eR_=scan_fmt_eZ_(_et_(add_conv_eN_,skip_eG_,i_eQ_,_eS_)),
                           _eT_=1;
                          break;
                         case 123:
                          var
                           i_e0_=_et_(add_conv_eN_,skip_eG_,i_eQ_,_eS_),
                           j_e2_=_et_(sub_format_for_printf_e1_,_eS_,fmt_eC_,i_e0_),
                           i_e3_=i_e0_;
                          for(;;)
                           {if(i_e3_<(j_e2_-2|0))
                             {var
                               _e4_=_eY_(add_char_eX_,i_e3_,fmt_eC_.safeGet(i_e3_)),
                               i_e3_=_e4_;
                              continue;}
                            var _e5_=j_e2_-1|0,i_eQ_=_e5_;
                            continue c;}
                         default:var _eT_=0;}
                      if(!_eT_)
                       var _eR_=bad_conversion_format_ez_(fmt_eC_,i_eQ_,_eS_);}
                    var _eI_=_eR_;
                    break;}}
                var i_eF_=_eI_;
                continue a;}}
            var _e6_=i_eF_+1|0,i_eF_=_e6_;
            continue;}
          return i_eF_;}}
      scan_fmt_eZ_(0);
      return 0;}
    function count_printing_arguments_of_format_he_(fmt_fg_)
     {var ac_e7_=[0,0,0,0];
      function add_conv_fe_(skip_fa_,i_fb_,c_e8_)
       {var _e9_=41!==c_e8_?1:0,_e__=_e9_?125!==c_e8_?1:0:_e9_;
        if(_e__)
         {var inc_e$_=97===c_e8_?2:1;
          if(114===c_e8_)ac_e7_[3]=ac_e7_[3]+1|0;
          if(skip_fa_)
           ac_e7_[2]=ac_e7_[2]+inc_e$_|0;
          else
           ac_e7_[1]=ac_e7_[1]+inc_e$_|0;}
        return i_fb_+1|0;}
      iter_on_format_args_ff_
       (fmt_fg_,add_conv_fe_,function(i_fc_,param_fd_){return i_fc_+1|0;});
      return ac_e7_[1];}
    function scan_positional_spec_fX_(fmt_fh_,got_spec_fk_,i_fi_)
     {var _fj_=fmt_fh_.safeGet(i_fi_);
      if((_fj_-48|0)<0||9<(_fj_-48|0))return _eY_(got_spec_fk_,0,i_fi_);
      var accu_fl_=_fj_-48|0,j_fm_=i_fi_+1|0;
      for(;;)
       {var _fn_=fmt_fh_.safeGet(j_fm_);
        if(48<=_fn_)
         {if(!(58<=_fn_))
           {var
             _fq_=j_fm_+1|0,
             _fp_=(10*accu_fl_|0)+(_fn_-48|0)|0,
             accu_fl_=_fp_,
             j_fm_=_fq_;
            continue;}
          var _fo_=0;}
        else
         if(36===_fn_)
          if(0===accu_fl_)
           {var _fr_=_g_(_bG_),_fo_=1;}
          else
           {var
             _fr_=
              _eY_(got_spec_fk_,[0,index_of_int_dv_(accu_fl_-1|0)],j_fm_+1|0),
             _fo_=1;}
         else
          var _fo_=0;
        if(!_fo_)var _fr_=_eY_(got_spec_fk_,0,i_fi_);
        return _fr_;}}
    function next_index_fS_(spec_fs_,n_ft_)
     {return spec_fs_?n_ft_:_cA_(_dx_,n_ft_);}
    function get_index_fH_(spec_fu_,n_fv_){return spec_fu_?spec_fu_[1]:n_fv_;}
    function _iB_
     (to_s_hz_,get_out_fx_,outc_hL_,outs_fA_,flush_hj_,k_hR_,fmt_fw_)
     {var out_fy_=_cA_(get_out_fx_,fmt_fw_);
      function outs_hA_(s_fz_){return _eY_(outs_fA_,out_fy_,s_fz_);}
      function pr_hi_(k_fF_,n_hQ_,fmt_fB_,v_fK_)
       {var len_fE_=fmt_fB_.getLen();
        function doprn_hf_(n_hI_,i_fC_)
         {var i_fD_=i_fC_;
          for(;;)
           {if(len_fE_<=i_fD_)return _cA_(k_fF_,out_fy_);
            var _fG_=fmt_fB_.safeGet(i_fD_);
            if(37===_fG_)
             {var
               get_arg_fO_=
                function(spec_fJ_,n_fI_)
                 {return caml_array_get(v_fK_,get_index_fH_(spec_fJ_,n_fI_));},
               scan_flags_fU_=
                function(spec_fW_,n_fP_,widths_fR_,i_fL_)
                 {var i_fM_=i_fL_;
                  for(;;)
                   {var _fN_=fmt_fB_.safeGet(i_fM_)-32|0;
                    if(!(_fN_<0||25<_fN_))
                     switch(_fN_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_fX_
                                (fmt_fB_,
                                 function(wspec_fQ_,i_fV_)
                                  {var _fT_=[0,get_arg_fO_(wspec_fQ_,n_fP_),widths_fR_];
                                   return scan_flags_fU_
                                           (spec_fW_,next_index_fS_(wspec_fQ_,n_fP_),_fT_,i_fV_);},
                                 i_fM_+1|0);
                       default:var _fY_=i_fM_+1|0,i_fM_=_fY_;continue;}
                    var _fZ_=fmt_fB_.safeGet(i_fM_);
                    if(124<=_fZ_)
                     var _f0_=0;
                    else
                     switch(_fZ_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_f2_=get_arg_fO_(spec_fW_,n_fP_),
                         s_f3_=
                          caml_format_int
                           (extract_format_int_f1_(_fZ_,fmt_fB_,i_fD_,i_fM_,widths_fR_),
                            x_f2_),
                         _f5_=
                          cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_f3_,i_fM_+1|0),
                         _f0_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_f6_=get_arg_fO_(spec_fW_,n_fP_),
                         s_f7_=
                          caml_format_float
                           (extract_format_d7_(fmt_fB_,i_fD_,i_fM_,widths_fR_),x_f6_),
                         _f5_=
                          cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_f7_,i_fM_+1|0),
                         _f0_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _f8_=fmt_fB_.safeGet(i_fM_+1|0)-88|0;
                        if(_f8_<0||32<_f8_)
                         var _f9_=1;
                        else
                         switch(_f8_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_f__=i_fM_+1|0,_f$_=_fZ_-108|0;
                            if(_f$_<0||2<_f$_)
                             var _ga_=0;
                            else
                             {switch(_f$_)
                               {case 1:var _ga_=0,_gb_=0;break;
                                case 2:
                                 var
                                  x_gc_=get_arg_fO_(spec_fW_,n_fP_),
                                  _gd_=
                                   caml_format_int
                                    (extract_format_d7_(fmt_fB_,i_fD_,i_f__,widths_fR_),x_gc_),
                                  _gb_=1;
                                 break;
                                default:
                                 var
                                  x_ge_=get_arg_fO_(spec_fW_,n_fP_),
                                  _gd_=
                                   caml_format_int
                                    (extract_format_d7_(fmt_fB_,i_fD_,i_f__,widths_fR_),x_ge_),
                                  _gb_=1;}
                              if(_gb_){var s_gf_=_gd_,_ga_=1;}}
                            if(!_ga_)
                             {var
                               x_gg_=get_arg_fO_(spec_fW_,n_fP_),
                               s_gf_=
                                caml_int64_format
                                 (extract_format_d7_(fmt_fB_,i_fD_,i_f__,widths_fR_),x_gg_);}
                            var
                             _f5_=
                              cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_gf_,i_f__+1|0),
                             _f0_=1,
                             _f9_=0;
                            break;
                           default:var _f9_=1;}
                        if(_f9_)
                         {var
                           x_gh_=get_arg_fO_(spec_fW_,n_fP_),
                           s_gi_=
                            caml_format_int
                             (extract_format_int_f1_(110,fmt_fB_,i_fD_,i_fM_,widths_fR_),
                              x_gh_),
                           _f5_=
                            cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_gi_,i_fM_+1|0),
                           _f0_=1;}
                        break;
                       case 37:
                       case 64:
                        var _f5_=cont_s_f4_(n_fP_,_c0_(1,_fZ_),i_fM_+1|0),_f0_=1;
                        break;
                       case 83:
                       case 115:
                        var x_gj_=get_arg_fO_(spec_fW_,n_fP_);
                        if(115===_fZ_)
                         var x_gk_=x_gj_;
                        else
                         {var n_gl_=[0,0],_gm_=0,_gn_=x_gj_.getLen()-1|0;
                          if(!(_gn_<_gm_))
                           {var i_go_=_gm_;
                            for(;;)
                             {var
                               _gp_=x_gj_.safeGet(i_go_),
                               _gq_=
                                14<=_gp_
                                 ?34===_gp_?1:92===_gp_?1:0
                                 :11<=_gp_?13<=_gp_?1:0:8<=_gp_?1:0,
                               _gr_=_gq_?2:caml_is_printable(_gp_)?1:4;
                              n_gl_[1]=n_gl_[1]+_gr_|0;
                              var _gs_=i_go_+1|0;
                              if(_gn_!==i_go_){var i_go_=_gs_;continue;}
                              break;}}
                          if(n_gl_[1]===x_gj_.getLen())
                           var _gt_=x_gj_;
                          else
                           {var s__gu_=caml_create_string(n_gl_[1]);
                            n_gl_[1]=0;
                            var _gv_=0,_gw_=x_gj_.getLen()-1|0;
                            if(!(_gw_<_gv_))
                             {var i_gx_=_gv_;
                              for(;;)
                               {var _gy_=x_gj_.safeGet(i_gx_),_gz_=_gy_-34|0;
                                if(_gz_<0||58<_gz_)
                                 if(-20<=_gz_)
                                  var _gA_=1;
                                 else
                                  {switch(_gz_+34|0)
                                    {case 8:
                                      s__gu_.safeSet(n_gl_[1],92);
                                      n_gl_[1]+=1;
                                      s__gu_.safeSet(n_gl_[1],98);
                                      var _gB_=1;
                                      break;
                                     case 9:
                                      s__gu_.safeSet(n_gl_[1],92);
                                      n_gl_[1]+=1;
                                      s__gu_.safeSet(n_gl_[1],116);
                                      var _gB_=1;
                                      break;
                                     case 10:
                                      s__gu_.safeSet(n_gl_[1],92);
                                      n_gl_[1]+=1;
                                      s__gu_.safeSet(n_gl_[1],110);
                                      var _gB_=1;
                                      break;
                                     case 13:
                                      s__gu_.safeSet(n_gl_[1],92);
                                      n_gl_[1]+=1;
                                      s__gu_.safeSet(n_gl_[1],114);
                                      var _gB_=1;
                                      break;
                                     default:var _gA_=1,_gB_=0;}
                                   if(_gB_)var _gA_=0;}
                                else
                                 var
                                  _gA_=
                                   (_gz_-1|0)<0||56<(_gz_-1|0)
                                    ?(s__gu_.safeSet(n_gl_[1],92),
                                      n_gl_[1]+=
                                      1,
                                      s__gu_.safeSet(n_gl_[1],_gy_),
                                      0)
                                    :1;
                                if(_gA_)
                                 if(caml_is_printable(_gy_))
                                  s__gu_.safeSet(n_gl_[1],_gy_);
                                 else
                                  {s__gu_.safeSet(n_gl_[1],92);
                                   n_gl_[1]+=1;
                                   s__gu_.safeSet(n_gl_[1],48+(_gy_/100|0)|0);
                                   n_gl_[1]+=1;
                                   s__gu_.safeSet(n_gl_[1],48+((_gy_/10|0)%10|0)|0);
                                   n_gl_[1]+=1;
                                   s__gu_.safeSet(n_gl_[1],48+(_gy_%10|0)|0);}
                                n_gl_[1]+=1;
                                var _gC_=i_gx_+1|0;
                                if(_gw_!==i_gx_){var i_gx_=_gC_;continue;}
                                break;}}
                            var _gt_=s__gu_;}
                          var x_gk_=_ci_(_bN_,_ci_(_gt_,_bO_));}
                        if(i_fM_===(i_fD_+1|0))
                         var s_gD_=x_gk_;
                        else
                         {var
                           _gE_=
                            extract_format_d7_(fmt_fB_,i_fD_,i_fM_,widths_fR_);
                          try
                           {var neg_gF_=0,i_gG_=1;
                            for(;;)
                             {if(_gE_.getLen()<=i_gG_)
                               var _gH_=[0,0,neg_gF_];
                              else
                               {var _gI_=_gE_.safeGet(i_gG_);
                                if(49<=_gI_)
                                 if(58<=_gI_)
                                  var _gJ_=0;
                                 else
                                  {var
                                    _gH_=
                                     [0,
                                      caml_int_of_string
                                       (_c1_(_gE_,i_gG_,(_gE_.getLen()-i_gG_|0)-1|0)),
                                      neg_gF_],
                                    _gJ_=1;}
                                else
                                 {if(45===_gI_)
                                   {var _gL_=i_gG_+1|0,_gK_=1,neg_gF_=_gK_,i_gG_=_gL_;
                                    continue;}
                                  var _gJ_=0;}
                                if(!_gJ_){var _gM_=i_gG_+1|0,i_gG_=_gM_;continue;}}
                              var match_gN_=_gH_;
                              break;}}
                          catch(_gO_)
                           {if(_gO_[1]!==_a_)throw _gO_;
                            var match_gN_=bad_conversion_dG_(_gE_,0,115);}
                          var
                           p_gP_=match_gN_[1],
                           _gQ_=x_gk_.getLen(),
                           _gR_=0,
                           neg_gV_=match_gN_[2],
                           _gU_=32;
                          if(p_gP_===_gQ_&&0===_gR_)
                           {var _gS_=x_gk_,_gT_=1;}
                          else
                           var _gT_=0;
                          if(!_gT_)
                           if(p_gP_<=_gQ_)
                            var _gS_=_c1_(x_gk_,_gR_,_gQ_);
                           else
                            {var res_gW_=_c0_(p_gP_,_gU_);
                             if(neg_gV_)
                              _c2_(x_gk_,_gR_,res_gW_,0,_gQ_);
                             else
                              _c2_(x_gk_,_gR_,res_gW_,p_gP_-_gQ_|0,_gQ_);
                             var _gS_=res_gW_;}
                          var s_gD_=_gS_;}
                        var
                         _f5_=
                          cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_gD_,i_fM_+1|0),
                         _f0_=1;
                        break;
                       case 67:
                       case 99:
                        var x_gX_=get_arg_fO_(spec_fW_,n_fP_);
                        if(99===_fZ_)
                         var s_gY_=_c0_(1,x_gX_);
                        else
                         {if(39===x_gX_)
                           var _gZ_=_bX_;
                          else
                           if(92===x_gX_)
                            var _gZ_=_bY_;
                           else
                            {if(14<=x_gX_)
                              var _g0_=0;
                             else
                              switch(x_gX_)
                               {case 8:var _gZ_=_b2_,_g0_=1;break;
                                case 9:var _gZ_=_b1_,_g0_=1;break;
                                case 10:var _gZ_=_b0_,_g0_=1;break;
                                case 13:var _gZ_=_bZ_,_g0_=1;break;
                                default:var _g0_=0;}
                             if(!_g0_)
                              if(caml_is_printable(x_gX_))
                               {var s_g1_=caml_create_string(1);
                                s_g1_.safeSet(0,x_gX_);
                                var _gZ_=s_g1_;}
                              else
                               {var s_g2_=caml_create_string(4);
                                s_g2_.safeSet(0,92);
                                s_g2_.safeSet(1,48+(x_gX_/100|0)|0);
                                s_g2_.safeSet(2,48+((x_gX_/10|0)%10|0)|0);
                                s_g2_.safeSet(3,48+(x_gX_%10|0)|0);
                                var _gZ_=s_g2_;}}
                          var s_gY_=_ci_(_bL_,_ci_(_gZ_,_bM_));}
                        var
                         _f5_=
                          cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_gY_,i_fM_+1|0),
                         _f0_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _g4_=i_fM_+1|0,
                         _g3_=get_arg_fO_(spec_fW_,n_fP_)?_b5_:_b4_,
                         _f5_=cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),_g3_,_g4_),
                         _f0_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_g5_=get_arg_fO_(spec_fW_,n_fP_),
                         i_g6_=_et_(sub_format_for_printf_e1_,_fZ_,fmt_fB_,i_fM_+1|0);
                        if(123===_fZ_)
                         {var
                           b_g7_=_dl_(xf_g5_.getLen()),
                           add_char_g$_=
                            function(i_g9_,c_g8_){_dq_(b_g7_,c_g8_);return i_g9_+1|0;};
                          iter_on_format_args_ff_
                           (xf_g5_,
                            function(skip_g__,i_hb_,c_ha_)
                             {if(skip_g__)_dr_(b_g7_,_bF_);else _dq_(b_g7_,37);
                              return add_char_g$_(i_hb_,c_ha_);},
                            add_char_g$_);
                          var
                           _hc_=_dp_(b_g7_),
                           _f5_=cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),_hc_,i_g6_),
                           _f0_=1;}
                        else
                         {var
                           _hd_=next_index_fS_(spec_fW_,n_fP_),
                           m_hg_=
                            add_int_index_dw_
                             (count_printing_arguments_of_format_he_(xf_g5_),_hd_),
                           _f5_=
                            pr_hi_
                             (function(param_hh_){return doprn_hf_(m_hg_,i_g6_);},
                              _hd_,
                              xf_g5_,
                              v_fK_),
                           _f0_=1;}
                        break;
                       case 33:
                        _cA_(flush_hj_,out_fy_);
                        var _f5_=doprn_hf_(n_fP_,i_fM_+1|0),_f0_=1;
                        break;
                       case 41:
                        var _f5_=cont_s_f4_(n_fP_,_bR_,i_fM_+1|0),_f0_=1;break;
                       case 44:
                        var _f5_=cont_s_f4_(n_fP_,_bQ_,i_fM_+1|0),_f0_=1;break;
                       case 70:
                        var x_hk_=get_arg_fO_(spec_fW_,n_fP_);
                        if(0===widths_fR_)
                         var _hl_=_bP_;
                        else
                         {var
                           sfmt_hm_=
                            extract_format_d7_(fmt_fB_,i_fD_,i_fM_,widths_fR_);
                          if(70===_fZ_)sfmt_hm_.safeSet(sfmt_hm_.getLen()-1|0,103);
                          var _hl_=sfmt_hm_;}
                        var _hn_=caml_classify_float(x_hk_);
                        if(3===_hn_)
                         var s_ho_=x_hk_<0?_bJ_:_bI_;
                        else
                         if(4<=_hn_)
                          var s_ho_=_bK_;
                         else
                          {var
                            _hp_=caml_format_float(_hl_,x_hk_),
                            i_hq_=0,
                            l_hr_=_hp_.getLen();
                           for(;;)
                            {if(l_hr_<=i_hq_)
                              var _hs_=_ci_(_hp_,_bH_);
                             else
                              {var
                                _ht_=_hp_.safeGet(i_hq_)-46|0,
                                _hu_=
                                 _ht_<0||23<_ht_
                                  ?55===_ht_?1:0
                                  :(_ht_-1|0)<0||21<(_ht_-1|0)?1:0;
                               if(!_hu_){var _hv_=i_hq_+1|0,i_hq_=_hv_;continue;}
                               var _hs_=_hp_;}
                             var s_ho_=_hs_;
                             break;}}
                        var
                         _f5_=
                          cont_s_f4_(next_index_fS_(spec_fW_,n_fP_),s_ho_,i_fM_+1|0),
                         _f0_=1;
                        break;
                       case 91:
                        var
                         _f5_=bad_conversion_format_ez_(fmt_fB_,i_fM_,_fZ_),
                         _f0_=1;
                        break;
                       case 97:
                        var
                         printer_hw_=get_arg_fO_(spec_fW_,n_fP_),
                         n_hx_=_cA_(_dx_,get_index_fH_(spec_fW_,n_fP_)),
                         arg_hy_=get_arg_fO_(0,n_hx_),
                         _hC_=i_fM_+1|0,
                         _hB_=next_index_fS_(spec_fW_,n_hx_);
                        if(to_s_hz_)
                         outs_hA_(_eY_(printer_hw_,0,arg_hy_));
                        else
                         _eY_(printer_hw_,out_fy_,arg_hy_);
                        var _f5_=doprn_hf_(_hB_,_hC_),_f0_=1;
                        break;
                       case 114:
                        var
                         _f5_=bad_conversion_format_ez_(fmt_fB_,i_fM_,_fZ_),
                         _f0_=1;
                        break;
                       case 116:
                        var
                         printer_hD_=get_arg_fO_(spec_fW_,n_fP_),
                         _hF_=i_fM_+1|0,
                         _hE_=next_index_fS_(spec_fW_,n_fP_);
                        if(to_s_hz_)
                         outs_hA_(_cA_(printer_hD_,0));
                        else
                         _cA_(printer_hD_,out_fy_);
                        var _f5_=doprn_hf_(_hE_,_hF_),_f0_=1;
                        break;
                       default:var _f0_=0;}
                    if(!_f0_)
                     var _f5_=bad_conversion_format_ez_(fmt_fB_,i_fM_,_fZ_);
                    return _f5_;}},
               _hK_=i_fD_+1|0,
               _hH_=0;
              return scan_positional_spec_fX_
                      (fmt_fB_,
                       function(spec_hJ_,i_hG_)
                        {return scan_flags_fU_(spec_hJ_,n_hI_,_hH_,i_hG_);},
                       _hK_);}
            _eY_(outc_hL_,out_fy_,_fG_);
            var _hM_=i_fD_+1|0,i_fD_=_hM_;
            continue;}}
        function cont_s_f4_(n_hP_,s_hN_,i_hO_)
         {outs_hA_(s_hN_);return doprn_hf_(n_hP_,i_hO_);}
        return doprn_hf_(n_hQ_,0);}
      var
       kpr_hS_=_eY_(pr_hi_,k_hR_,index_of_int_dv_(0)),
       _hT_=count_printing_arguments_of_format_he_(fmt_fw_);
      if(_hT_<0||6<_hT_)
       {var
         loop_h6_=
          function(i_hU_,args_h0_)
           {if(_hT_<=i_hU_)
             {var
               a_hV_=caml_make_vect(_hT_,0),
               _hY_=
                function(i_hW_,arg_hX_)
                 {return caml_array_set(a_hV_,(_hT_-i_hW_|0)-1|0,arg_hX_);},
               i_hZ_=0,
               param_h1_=args_h0_;
              for(;;)
               {if(param_h1_)
                 {var _h2_=param_h1_[2],_h3_=param_h1_[1];
                  if(_h2_)
                   {_hY_(i_hZ_,_h3_);
                    var _h4_=i_hZ_+1|0,i_hZ_=_h4_,param_h1_=_h2_;
                    continue;}
                  _hY_(i_hZ_,_h3_);}
                return _eY_(kpr_hS_,fmt_fw_,a_hV_);}}
            return function(x_h5_)
             {return loop_h6_(i_hU_+1|0,[0,x_h5_,args_h0_]);};},
         _h7_=loop_h6_(0,0);}
      else
       switch(_hT_)
        {case 1:
          var
           _h7_=
            function(x_h9_)
             {var a_h8_=caml_make_vect(1,0);
              caml_array_set(a_h8_,0,x_h9_);
              return _eY_(kpr_hS_,fmt_fw_,a_h8_);};
          break;
         case 2:
          var
           _h7_=
            function(x_h$_,y_ia_)
             {var a_h__=caml_make_vect(2,0);
              caml_array_set(a_h__,0,x_h$_);
              caml_array_set(a_h__,1,y_ia_);
              return _eY_(kpr_hS_,fmt_fw_,a_h__);};
          break;
         case 3:
          var
           _h7_=
            function(x_ic_,y_id_,z_ie_)
             {var a_ib_=caml_make_vect(3,0);
              caml_array_set(a_ib_,0,x_ic_);
              caml_array_set(a_ib_,1,y_id_);
              caml_array_set(a_ib_,2,z_ie_);
              return _eY_(kpr_hS_,fmt_fw_,a_ib_);};
          break;
         case 4:
          var
           _h7_=
            function(x_ig_,y_ih_,z_ii_,t_ij_)
             {var a_if_=caml_make_vect(4,0);
              caml_array_set(a_if_,0,x_ig_);
              caml_array_set(a_if_,1,y_ih_);
              caml_array_set(a_if_,2,z_ii_);
              caml_array_set(a_if_,3,t_ij_);
              return _eY_(kpr_hS_,fmt_fw_,a_if_);};
          break;
         case 5:
          var
           _h7_=
            function(x_il_,y_im_,z_in_,t_io_,u_ip_)
             {var a_ik_=caml_make_vect(5,0);
              caml_array_set(a_ik_,0,x_il_);
              caml_array_set(a_ik_,1,y_im_);
              caml_array_set(a_ik_,2,z_in_);
              caml_array_set(a_ik_,3,t_io_);
              caml_array_set(a_ik_,4,u_ip_);
              return _eY_(kpr_hS_,fmt_fw_,a_ik_);};
          break;
         case 6:
          var
           _h7_=
            function(x_ir_,y_is_,z_it_,t_iu_,u_iv_,v_iw_)
             {var a_iq_=caml_make_vect(6,0);
              caml_array_set(a_iq_,0,x_ir_);
              caml_array_set(a_iq_,1,y_is_);
              caml_array_set(a_iq_,2,z_it_);
              caml_array_set(a_iq_,3,t_iu_);
              caml_array_set(a_iq_,4,u_iv_);
              caml_array_set(a_iq_,5,v_iw_);
              return _eY_(kpr_hS_,fmt_fw_,a_iq_);};
          break;
         default:var _h7_=_eY_(kpr_hS_,fmt_fw_,[0]);}
      return _h7_;}
    function _iP_(oc_iy_)
     {function _iA_(_ix_){return 0;}
      return _iC_
              (_iB_,
               0,
               function(param_iz_){return oc_iy_;},
               _cw_,
               output_string_cs_,
               _cD_,
               _iA_);}
    function _iL_(fmt_iD_){return _dl_(2*fmt_iD_.getLen()|0);}
    function _iI_(k_iG_,b_iE_)
     {var s_iF_=_dp_(b_iE_);b_iE_[2]=0;return _cA_(k_iG_,s_iF_);}
    function _iO_(k_iH_)
     {var _iK_=_cA_(_iI_,k_iH_);
      return _iC_(_iB_,1,_iL_,_dq_,_dr_,function(_iJ_){return 0;},_iK_);}
    function _iQ_(fmt_iN_)
     {return _eY_(_iO_,function(s_iM_){return s_iM_;},fmt_iN_);}
    var _iR_=[0,0];
    function _i5_(x_iS_,i_iT_)
     {var f_iU_=x_iS_[i_iT_+1];
      if(caml_obj_is_block(f_iU_))
       {if(caml_obj_tag(f_iU_)===_do_)return _eY_(_iQ_,_bb_,f_iU_);
        if(caml_obj_tag(f_iU_)===_dn_)
         {var _iV_=caml_format_float(_b8_,f_iU_),i_iW_=0,l_iX_=_iV_.getLen();
          for(;;)
           {if(l_iX_<=i_iW_)
             var _iY_=_ci_(_iV_,_b7_);
            else
             {var
               _iZ_=_iV_.safeGet(i_iW_),
               _i0_=48<=_iZ_?58<=_iZ_?0:1:45===_iZ_?1:0;
              if(_i0_){var _i1_=i_iW_+1|0,i_iW_=_i1_;continue;}
              var _iY_=_iV_;}
            return _iY_;}}
        return _ba_;}
      return _eY_(_iQ_,_bc_,f_iU_);}
    function _i4_(x_i2_,i_i3_)
     {if(x_i2_.length-1<=i_i3_)return _bw_;
      var _i6_=_i4_(x_i2_,i_i3_+1|0);
      return _et_(_iQ_,_bv_,_i5_(x_i2_,i_i3_),_i6_);}
    function _jz_(x_i8_)
     {var param_i7_=_iR_[1];
      for(;;)
       {if(param_i7_)
         {var tl_jb_=param_i7_[2],hd_i9_=param_i7_[1];
          try {var _i__=_cA_(hd_i9_,x_i8_),_i$_=_i__;}catch(_jc_){var _i$_=0;}
          if(!_i$_){var param_i7_=tl_jb_;continue;}
          var _ja_=_i$_[1];}
        else
         if(x_i8_[1]===_ca_)
          var _ja_=_bl_;
         else
          if(x_i8_[1]===_b__)
           var _ja_=_bk_;
          else
           if(x_i8_[1]===_b$_)
            {var
              match_jd_=x_i8_[2],
              char_je_=match_jd_[3],
              _ja_=
               _iC_
                (_iQ_,
                 _d_,
                 match_jd_[1],
                 match_jd_[2],
                 char_je_,
                 char_je_+5|0,
                 _bj_);}
           else
            if(x_i8_[1]===_c_)
             {var
               match_jf_=x_i8_[2],
               char_jg_=match_jf_[3],
               _ja_=
                _iC_
                 (_iQ_,
                  _d_,
                  match_jf_[1],
                  match_jf_[2],
                  char_jg_,
                  char_jg_+6|0,
                  _bi_);}
            else
             if(x_i8_[1]===_b9_)
              {var
                match_jh_=x_i8_[2],
                char_ji_=match_jh_[3],
                _ja_=
                 _iC_
                  (_iQ_,
                   _d_,
                   match_jh_[1],
                   match_jh_[2],
                   char_ji_,
                   char_ji_+6|0,
                   _bh_);}
             else
              {var _jj_=x_i8_.length-1,constructor_jm_=x_i8_[0+1][0+1];
               if(_jj_<0||2<_jj_)
                {var
                  _jk_=_i4_(x_i8_,2),
                  _jl_=_et_(_iQ_,_bg_,_i5_(x_i8_,1),_jk_);}
               else
                switch(_jj_)
                 {case 1:var _jl_=_be_;break;
                  case 2:var _jl_=_eY_(_iQ_,_bd_,_i5_(x_i8_,1));break;
                  default:var _jl_=_bf_;}
               var _ja_=_ci_(constructor_jm_,_jl_);}
        return _ja_;}}
    function _jA_(outchan_jw_)
     {var
       _jn_=
        caml_convert_raw_backtrace(caml_get_exception_raw_backtrace(0));
      if(_jn_)
       {var a_jo_=_jn_[1],_jp_=0,_jq_=a_jo_.length-1-1|0;
        if(!(_jq_<_jp_))
         {var i_jr_=_jp_;
          for(;;)
           {if(caml_notequal(caml_array_get(a_jo_,i_jr_),_bu_))
             {var
               _js_=caml_array_get(a_jo_,i_jr_),
               is_raise_jt_=0===_js_[0]?_js_[1]:_js_[1],
               info_ju_=is_raise_jt_?0===i_jr_?_br_:_bq_:0===i_jr_?_bp_:_bo_,
               _jv_=
                0===_js_[0]
                 ?_iC_(_iQ_,_bn_,info_ju_,_js_[2],_js_[3],_js_[4],_js_[5])
                 :_eY_(_iQ_,_bm_,info_ju_);
              _et_(_iP_,outchan_jw_,_bt_,_jv_);}
            var _jx_=i_jr_+1|0;
            if(_jq_!==i_jr_){var i_jr_=_jx_;continue;}
            break;}}
        var _jy_=0;}
      else
       var _jy_=_eY_(_iP_,outchan_jw_,_bs_);
      return _jy_;}
    32===_c4_;
    function _jD_(param_jC_)
     {var seq_jB_=[];
      caml_update_dummy(seq_jB_,[0,seq_jB_,seq_jB_]);
      return seq_jB_;}
    var Canceled_jE_=[0,_a6_],current_data_jF_=[0,0],max_removed_jN_=42;
    function repr_rec_jJ_(t_jG_)
     {var _jH_=t_jG_[1];
      {if(3===_jH_[0])
        {var t__jI_=_jH_[1],t___jK_=repr_rec_jJ_(t__jI_);
         if(t___jK_!==t__jI_)t_jG_[1]=[3,t___jK_];
         return t___jK_;}
       return t_jG_;}}
    function repr_jO_(t_jL_){return repr_rec_jJ_(t_jL_);}
    var
     async_exception_hook_jP_=
      [0,
       function(exn_jM_)
        {_jz_(exn_jM_);
         caml_ml_output_char(stderr_ck_,10);
         _jA_(stderr_ck_);
         do_at_exit_cr_(0);
         return caml_sys_exit(2);}];
    function call_unsafe_kd_(f_jR_,x_jQ_)
     {try
       {var _jS_=_cA_(f_jR_,x_jQ_);}
      catch(_jT_){return _cA_(async_exception_hook_jP_[1],_jT_);}
      return _jS_;}
    function run_waiters_rec_j4_(state_jY_,ws_jU_,rem_jW_)
     {var ws_jV_=ws_jU_,rem_jX_=rem_jW_;
      for(;;)
       if(typeof ws_jV_==="number")
        return run_waiters_rec_next_jZ_(state_jY_,rem_jX_);
       else
        switch(ws_jV_[0])
         {case 1:
           _cA_(ws_jV_[1],state_jY_);
           return run_waiters_rec_next_jZ_(state_jY_,rem_jX_);
          case 2:
           var
            ws1_j0_=ws_jV_[1],
            _j1_=[0,ws_jV_[2],rem_jX_],
            ws_jV_=ws1_j0_,
            rem_jX_=_j1_;
           continue;
          default:
           var _j2_=ws_jV_[1][1];
           return _j2_
                   ?(_cA_(_j2_[1],state_jY_),
                     run_waiters_rec_next_jZ_(state_jY_,rem_jX_))
                   :run_waiters_rec_next_jZ_(state_jY_,rem_jX_);}}
    function run_waiters_rec_next_jZ_(state_j5_,rem_j3_)
     {return rem_j3_?run_waiters_rec_j4_(state_j5_,rem_j3_[1],rem_j3_[2]):0;}
    function run_cancel_handlers_rec_kf_(chs_j6_,rem_j8_)
     {var chs_j7_=chs_j6_,rem_j9_=rem_j8_;
      for(;;)
       if(typeof chs_j7_==="number")
        return run_cancel_handlers_rec_next_j$_(rem_j9_);
       else
        switch(chs_j7_[0])
         {case 1:
           var n_j__=chs_j7_[1];
           if(n_j__[4]){n_j__[4]=0;n_j__[1][2]=n_j__[2];n_j__[2][1]=n_j__[1];}
           return run_cancel_handlers_rec_next_j$_(rem_j9_);
          case 2:
           var
            chs1_ka_=chs_j7_[1],
            _kb_=[0,chs_j7_[2],rem_j9_],
            chs_j7_=chs1_ka_,
            rem_j9_=_kb_;
           continue;
          default:
           var f_kc_=chs_j7_[2];
           current_data_jF_[1]=chs_j7_[1];
           call_unsafe_kd_(f_kc_,0);
           return run_cancel_handlers_rec_next_j$_(rem_j9_);}}
    function run_cancel_handlers_rec_next_j$_(rem_ke_)
     {return rem_ke_?run_cancel_handlers_rec_kf_(rem_ke_[1],rem_ke_[2]):0;}
    function unsafe_run_waiters_kj_(sleeper_kh_,state_kg_)
     {var
       _ki_=
        1===state_kg_[0]
         ?state_kg_[1][1]===Canceled_jE_
           ?(run_cancel_handlers_rec_kf_(sleeper_kh_[4],0),1)
           :0
         :0;
      
      return run_waiters_rec_j4_(state_kg_,sleeper_kh_[2],0);}
    var wakening_kk_=[0,0],_kl_=[0,0,0];
    function wakeup_kI_(t_ko_,v_km_)
     {var _kn_=[0,v_km_],t_kp_=repr_rec_jJ_(t_ko_),_kq_=t_kp_[1];
      switch(_kq_[0])
       {case 1:
         if(_kq_[1][1]===Canceled_jE_){var _kr_=0,_ks_=1;}else var _ks_=0;
         break;
        case 2:
         var sleeper_kt_=_kq_[1];
         t_kp_[1]=_kn_;
         var
          snapshot_ku_=current_data_jF_[1],
          already_wakening_kv_=wakening_kk_[1]?1:(wakening_kk_[1]=1,0);
         unsafe_run_waiters_kj_(sleeper_kt_,_kn_);
         if(already_wakening_kv_)
          {current_data_jF_[1]=snapshot_ku_;var _kw_=0;}
         else
          for(;;)
           {if(0!==_kl_[1])
             {if(0===_kl_[1])throw [0,_dm_];
              _kl_[1]=_kl_[1]-1|0;
              var tail_kx_=_kl_[2],head_ky_=tail_kx_[2];
              if(head_ky_===tail_kx_)_kl_[2]=0;else tail_kx_[2]=head_ky_[2];
              var _kz_=head_ky_[1];
              unsafe_run_waiters_kj_(_kz_[1],_kz_[2]);
              continue;}
            wakening_kk_[1]=0;
            current_data_jF_[1]=snapshot_ku_;
            var _kw_=0;
            break;}
         var _kr_=_kw_,_ks_=1;
         break;
        default:var _ks_=0;}
      if(!_ks_)var _kr_=_cb_(_a7_);
      return _kr_;}
    function append_kG_(l1_kA_,l2_kB_)
     {return typeof l1_kA_==="number"
              ?l2_kB_
              :typeof l2_kB_==="number"?l1_kA_:[2,l1_kA_,l2_kB_];}
    function cleanup_kD_(ws_kC_)
     {if(typeof ws_kC_!=="number")
       switch(ws_kC_[0])
        {case 2:
          var l1_kE_=ws_kC_[1],_kF_=cleanup_kD_(ws_kC_[2]);
          return append_kG_(cleanup_kD_(l1_kE_),_kF_);
         case 1:break;
         default:if(!ws_kC_[1][1])return 0;}
      return ws_kC_;}
    var
     pause_hook_kK_=[0,function(_kH_){return 0;}],
     _kJ_=_jD_(0),
     _kN_=[0,0],
     null_kS_=null;
    function _k2_(param_kR_)
     {var _kL_=1-(_kJ_[2]===_kJ_?1:0);
      if(_kL_)
       {var tmp_kM_=_jD_(0);
        tmp_kM_[1][2]=_kJ_[2];
        _kJ_[2][1]=tmp_kM_[1];
        tmp_kM_[1]=_kJ_[1];
        _kJ_[1][2]=tmp_kM_;
        _kJ_[1]=_kJ_;
        _kJ_[2]=_kJ_;
        _kN_[1]=0;
        var curr_kO_=tmp_kM_[2];
        for(;;)
         {var _kP_=curr_kO_!==tmp_kM_?1:0;
          if(_kP_)
           {if(curr_kO_[4])wakeup_kI_(curr_kO_[3],0);
            var _kQ_=curr_kO_[2],curr_kO_=_kQ_;
            continue;}
          return _kP_;}}
      return _kL_;}
    var undefined_k1_=undefined;
    function _k0_(x_kT_,f_kU_){return x_kT_==null_kS_?0:_cA_(f_kU_,x_kT_);}
    function _k3_(x_kV_,f_kW_,g_kX_)
     {return x_kV_==null_kS_?_cA_(f_kW_,0):_cA_(g_kX_,x_kV_);}
    function _k4_(x_kY_,f_kZ_){return x_kY_==null_kS_?_cA_(f_kZ_,0):x_kY_;}
    var _true_k5_=true,_false_k6_=false,array_constructor_k7_=Array;
    function _k9_(e_k8_)
     {return e_k8_ instanceof array_constructor_k7_
              ?0
              :[0,new MlWrappedString(e_k8_.toString())];}
    _iR_[1]=[0,_k9_,_iR_[1]];
    function _k$_(_k__){return _k__;}
    function _lh_(p_la_,n_lb_){p_la_.appendChild(n_lb_);return 0;}
    function _li_(f_ld_)
     {return _k$_
              (caml_js_wrap_callback
                (function(e_lc_)
                  {if(e_lc_)
                    {var res_le_=_cA_(f_ld_,e_lc_);
                     if(!(res_le_|0))e_lc_.preventDefault();
                     return res_le_;}
                   var _lf_=event,res_lg_=_cA_(f_ld_,_lf_);
                   if(!(res_lg_|0))_lf_.returnValue=res_lg_;
                   return res_lg_;}));}
    var window_lj_=this,document_lk_=window_lj_.document;
    function opt_iter_ls_(x_ll_,f_lm_){return x_ll_?_cA_(f_lm_,x_ll_[1]):0;}
    function createElement_lp_(doc_lo_,name_ln_)
     {return doc_lo_.createElement(name_ln_.toString());}
    function unsafeCreateElement_lt_(doc_lr_,name_lq_)
     {return createElement_lp_(doc_lr_,name_lq_);}
    var createElementSyntax_lu_=[0,785140586];
    function unsafeCreateElementEx_lN_(_type_lv_,name_lw_,doc_ly_,elt_lx_)
     {for(;;)
       {if(0===_type_lv_&&0===name_lw_)
         return createElement_lp_(doc_ly_,elt_lx_);
        var _lz_=createElementSyntax_lu_[1];
        if(785140586===_lz_)
         {try
           {var
             el_lA_=document_lk_.createElement(_aY_.toString()),
             _lB_=_aX_.toString(),
             _lC_=el_lA_.tagName.toLowerCase()===_lB_?1:0,
             _lD_=_lC_?el_lA_.name===_aW_.toString()?1:0:_lC_,
             _lE_=_lD_;}
          catch(_lG_){var _lE_=0;}
          var _lF_=_lE_?982028505:-1003883683;
          createElementSyntax_lu_[1]=_lF_;
          continue;}
        if(982028505<=_lz_)
         {var a_lH_=new array_constructor_k7_();
          a_lH_.push(_a1_.toString(),elt_lx_.toString());
          opt_iter_ls_
           (_type_lv_,
            function(t_lI_)
             {a_lH_.push
               (_a2_.toString(),caml_js_html_escape(t_lI_),_a3_.toString());
              return 0;});
          opt_iter_ls_
           (name_lw_,
            function(n_lJ_)
             {a_lH_.push
               (_a4_.toString(),caml_js_html_escape(n_lJ_),_a5_.toString());
              return 0;});
          a_lH_.push(_a0_.toString());
          return doc_ly_.createElement(a_lH_.join(_aZ_.toString()));}
        var res_lK_=createElement_lp_(doc_ly_,elt_lx_);
        opt_iter_ls_(_type_lv_,function(t_lL_){return res_lK_.type=t_lL_;});
        opt_iter_ls_(name_lw_,function(n_lM_){return res_lK_.name=n_lM_;});
        return res_lK_;}}
    function createTextarea_lS_(_type_lQ_,name_lP_,doc_lO_)
     {return unsafeCreateElementEx_lN_(_type_lQ_,name_lP_,doc_lO_,_aT_);}
    function createBr_lT_(doc_lR_)
     {return unsafeCreateElement_lt_(doc_lR_,_aU_);}
    this.HTMLElement===undefined_k1_;
    var overflow_limit_lU_=2147483,_lW_=caml_js_get_console(0);
    pause_hook_kK_[1]=
    function(param_lV_)
     {return 1===param_lV_
              ?(window_lj_.setTimeout(caml_js_wrap_callback(_k2_),0),0)
              :0;};
    function _lY_(s_lX_){return _lW_.log(s_lX_.toString());}
    async_exception_hook_jP_[1]=
    function(exn_lZ_){_lY_(_aR_);_lY_(_jz_(exn_lZ_));return _jA_(stderr_ck_);};
    function _l2_(x_l0_,f_l1_){return _cA_(f_l1_,x_l0_);}
    var Break_l3_=[0,_h_];
    function html2wiki_mm_(_opt__l4_,body_mf_)
     {
      var ans_l5_=_dl_(10);
      function add_str_me_(_opt__l6_,s_l8_)
       {var surr_l7_=_opt__l6_?_opt__l6_[1]:_ai_,len_l9_=s_l8_.getLen();
        try
         {var i_l__=0;
          for(;;)
           {if(!(len_l9_<=i_l__))
             {if
               (92===
                s_l8_.safeGet(i_l__)&&
                i_l__<
                (len_l9_-1|0)&&
                92===
                s_l8_.safeGet(i_l__+1|0))
               {var _mb_=i_l__+2|0,i_l__=_mb_;continue;}
              if(10===s_l8_.safeGet(i_l__))
               {var _mc_=i_l__+1|0,i_l__=_mc_;continue;}
              throw [0,Break_l3_,1];}
            var _l$_=0,_ma_=_l$_;
            break;}}
        catch(_md_){if(_md_[1]!==Break_l3_)throw _md_;var _ma_=_md_[2];}
        return _ma_?_dr_(ans_l5_,_ci_(surr_l7_,_ci_(s_l8_,surr_l7_))):0;}
      var
       childNodes_mg_=body_mf_.childNodes,
       _mh_=0,
       _mi_=childNodes_mg_.length-1|0;
      if(!(_mi_<_mh_))
       {var i_mj_=_mh_;
        for(;;)
         {var
           _mH_=
            function(node_mk_)
             {var _ml_=new MlWrappedString(node_mk_.nodeName);
              if(caml_string_notequal(_ml_,_aC_))
               {if(caml_string_notequal(_ml_,_aB_))
                 {if(caml_string_notequal(_ml_,_aA_))
                   {if(caml_string_notequal(_ml_,_az_))
                     {if(caml_string_notequal(_ml_,_ay_))
                       {if
                         (caml_string_notequal(_ml_,_ax_)&&
                          caml_string_notequal(_ml_,_aw_)&&
                          caml_string_notequal(_ml_,_av_))
                         return caml_string_notequal(_ml_,_au_)
                                 ?caml_string_notequal(_ml_,_at_)
                                   ?caml_string_notequal(_ml_,_as_)
                                     ?_dr_(ans_l5_,_ci_(_aq_,_ci_(_ml_,_ar_)))
                                     :add_str_me_(0,_ci_(html2wiki_mm_(0,node_mk_),_ap_))
                                   :add_str_me_(_ao_,html2wiki_mm_(0,node_mk_))
                                 :_dr_(ans_l5_,_an_);
                        var prefix_mn_=_c0_((_ml_.safeGet(1)-48|0)+1|0,61);
                        return _dr_
                                (ans_l5_,
                                 _ci_(prefix_mn_,_ci_(html2wiki_mm_(0,node_mk_),_aj_)));}
                      return _dr_(ans_l5_,html2wiki_mm_(0,node_mk_));}
                    return _dr_(ans_l5_,_am_);}
                  return add_str_me_(_al_,html2wiki_mm_(0,node_mk_));}
                var
                 x_mp_=_k$_(node_mk_),
                 el_mq_=_k4_(x_mp_,function(param_mo_){throw [0,_c_,_aD_];}),
                 _mA_=
                  function(s_mw_)
                   {function _mt_(_mr_){return new MlWrappedString(_mr_);}
                    function _mu_(param_ms_){throw [0,_c_,_aP_];}
                    var
                     url_mv_=
                      _l2_(_k4_(el_mq_.getAttribute(_aO_.toString()),_mu_),_mt_),
                     _mx_=new MlWrappedString(s_mw_);
                    if(caml_string_notequal(_mx_,_aN_))
                     {if(caml_string_notequal(_mx_,_aM_))
                       return _dr_(ans_l5_,_aL_);
                      var _my_=_cA_(_dr_,ans_l5_);
                      return _l2_(_c3_(_aI_,[0,_aJ_,[0,url_mv_,_aK_]]),_my_);}
                    return _dr_
                            (ans_l5_,
                             _c3_
                              (_aE_,
                               [0,
                                _aF_,
                                [0,url_mv_,[0,_aG_,[0,html2wiki_mm_(0,node_mk_),_aH_]]]]));},
                 _mB_=function(param_mz_){return _dr_(ans_l5_,_aQ_);};
                return _k3_(el_mq_.getAttribute(_ak_.toString()),_mB_,_mA_);}
              var
               _mE_=node_mk_.nodeValue,
               _mF_=function(x_mC_){return [0,x_mC_];},
               _mG_=_k3_(_mE_,function(param_mD_){return 0;},_mF_);
              return _mG_?_dr_(ans_l5_,new MlWrappedString(_mG_[1])):0;};
          _k0_(childNodes_mg_.item(i_mj_),_mH_);
          var _mI_=i_mj_+1|0;
          if(_mi_!==i_mj_){var i_mj_=_mI_;continue;}
          break;}}
      return _dp_(ans_l5_);}
    window_lj_.onload=
    _li_
     (function(param_oc_)
       {function _mK_(param_mJ_){throw [0,_c_,_m_];}
        var
         body_mL_=_k4_(document_lk_.getElementById(_l_.toString()),_mK_),
         _mM_=unsafeCreateElement_lt_(document_lk_,_aV_);
        _mM_.style.border=_k_.toString();
        _mM_.src=_j_.toString();
        _mM_.id=_i_.toString();
        _lh_(body_mL_,_mM_);
        function _ob_(iDoc_mN_)
         {iDoc_mN_.open();
          iDoc_mN_.write(_S_.toString());
          iDoc_mN_.close();
          iDoc_mN_.designMode=_R_.toString();
          var iWin_mO_=_mM_.contentWindow;
          _lh_(body_mL_,createBr_lT_(document_lk_));
          function createButton_mY_(_opt__mP_,_mR_,title_mU_,action_mW_)
           {var
             show_mQ_=_opt__mP_?_opt__mP_[1]:_false_k6_,
             value_mS_=_mR_?_mR_[1]:0,
             _mT_=
              unsafeCreateElementEx_lN_
               ([0,_T_.toString()],0,document_lk_,_aS_);
            _mT_.value=title_mU_.toString();
            _mT_.onclick=
            _li_
             (function(param_mX_)
               {iWin_mO_.focus();
                var _mV_=value_mS_?_k$_(value_mS_[1].toString()):null_kS_;
                iDoc_mN_.execCommand(action_mW_.toString(),show_mQ_,_mV_);
                return _true_k5_;});
            _lh_(body_mL_,_mT_);
            return _mT_;}
          createButton_mY_(0,0,_P_,_Q_);
          createButton_mY_(0,0,_N_,_O_);
          createButton_mY_(0,0,_L_,_M_);
          createButton_mY_(0,0,_J_,_K_);
          _lh_(body_mL_,createBr_lT_(document_lk_));
          createButton_mY_(0,_G_,_H_,_I_);
          createButton_mY_(0,_D_,_E_,_F_);
          createButton_mY_(0,_A_,_B_,_C_);
          createButton_mY_(0,_x_,_y_,_z_);
          function prompt_m5_(query_m4_,default_m0_)
           {function _m2_(_mZ_){return new MlWrappedString(_mZ_);}
            function _m3_(param_m1_){return default_m0_.toString();}
            return _l2_
                    (_k4_
                      (iWin_mO_.prompt
                        (query_m4_.toString(),default_m0_.toString()),
                       _m3_),
                     _m2_);}
          var a518dfd7a_m__=createButton_mY_(0,0,_v_,_w_);
          a518dfd7a_m__.onclick=
          _li_
           (function(param_m9_)
             {var
               link_m6_=prompt_m5_(_$_,_aa_),
               link_m7_=
                _c3_
                 (_V_,
                  [0,_W_,[0,link_m6_,[0,_X_,[0,prompt_m5_(_Z_,___),_Y_]]]]);
              iWin_mO_.alert(link_m7_.toString());
              var _m8_=_k$_(link_m7_.toString());
              iDoc_mN_.execCommand(_U_.toString(),_false_k6_,_m8_);
              return _true_k5_;});
          var a95c43e00_nd_=createButton_mY_(0,0,_t_,_u_);
          a95c43e00_nd_.onclick=
          _li_
           (function(param_nc_)
             {var
               link_m$_=prompt_m5_(_ag_,_ah_),
               link_na_=
                _l2_
                 ([0,_ac_,[0,link_m$_,[0,_ad_,[0,link_m$_,_ae_]]]],
                  _cA_(_c3_,_af_));
              iWin_mO_.alert(link_na_.toString());
              var _nb_=_k$_(link_na_.toString());
              iDoc_mN_.execCommand(_ab_.toString(),_false_k6_,_nb_);
              return _true_k5_;});
          _lh_(body_mL_,createBr_lT_(document_lk_));
          var preview_ne_=createTextarea_lS_(0,0,document_lk_);
          preview_ne_.readOnly=_true_k5_;
          preview_ne_.cols=34;
          preview_ne_.rows=10;
          preview_ne_.style.border=_s_.toString();
          preview_ne_.style.padding=_r_.toString();
          _lh_(body_mL_,preview_ne_);
          var wikiFrame_nf_=createTextarea_lS_(0,0,document_lk_);
          wikiFrame_nf_.id=_q_.toString();
          wikiFrame_nf_.readOnly=_true_k5_;
          wikiFrame_nf_.cols=34;
          wikiFrame_nf_.rows=10;
          preview_ne_.style.border=_p_.toString();
          preview_ne_.style.padding=_o_.toString();
          _lh_(body_mL_,wikiFrame_nf_);
          function dyn_preview_no_(old_text_nh_,n_nk_)
           {var text_ng_=new MlWrappedString(iDoc_mN_.body.innerHTML);
            if(caml_string_notequal(text_ng_,old_text_nh_))
             {try
               {preview_ne_.value=text_ng_.toString();
                wikiFrame_nf_.value=html2wiki_mm_(0,iDoc_mN_.body).toString();}
              catch(_nj_){}
              var n_ni_=20;}
            else
             {var
               _nl_=n_nk_-1|0,
               _nm_=0,
               _nn_=caml_greaterequal(_nm_,_nl_)?_nm_:_nl_,
               n_ni_=_nn_;}
            function _nq_(param_np_){return dyn_preview_no_(text_ng_,n_ni_);}
            var _nr_=0===n_ni_?0.5:0.1,_ns_=[0,[2,[0,1,0,0,0]]],id_nt_=[0,0];
            function wait_ny_(d_nu_,param_nA_)
             {var
               match_nv_=
                overflow_limit_lU_<d_nu_
                 ?[0,overflow_limit_lU_,d_nu_-overflow_limit_lU_]
                 :[0,d_nu_,0],
               remain_nw_=match_nv_[2],
               step_nz_=match_nv_[1],
               cb_nx_=
                remain_nw_==0?_cA_(wakeup_kI_,_ns_):_cA_(wait_ny_,remain_nw_);
              id_nt_[1]=
              [0,
               window_lj_.setTimeout
                (caml_js_wrap_callback(cb_nx_),step_nz_*1e3)];
              return 0;}
            wait_ny_(_nr_,0);
            function _nD_(param_nC_)
             {var _nB_=id_nt_[1];
              return _nB_?window_lj_.clearTimeout(_nB_[1]):0;}
            var _nE_=repr_jO_(_ns_)[1];
            switch(_nE_[0])
             {case 1:
               var
                _nF_=
                 _nE_[1][1]===Canceled_jE_?(call_unsafe_kd_(_nD_,0),1):0;
               break;
              case 2:
               var
                sleeper_nG_=_nE_[1],
                handler_nH_=[0,current_data_jF_[1],_nD_],
                _nI_=sleeper_nG_[4],
                _nJ_=typeof _nI_==="number"?handler_nH_:[2,handler_nH_,_nI_];
               sleeper_nG_[4]=_nJ_;
               var _nF_=1;
               break;
              default:var _nF_=0;}
            
            var t_nK_=repr_jO_(_ns_),_nL_=t_nK_[1];
            switch(_nL_[0])
             {case 1:var _nM_=[0,_nL_];break;
              case 2:
               var
                sleeper_nN_=_nL_[1],
                _nO_=[0,[2,[0,[0,[0,t_nK_]],0,0,0]]],
                data_nQ_=current_data_jF_[1],
                _n__=
                 [1,
                  function(state_nP_)
                   {switch(state_nP_[0])
                     {case 0:
                       var v_nR_=state_nP_[1];
                       current_data_jF_[1]=data_nQ_;
                       try
                        {var _nS_=_nq_(v_nR_),_nT_=_nS_;}
                       catch(_nU_){var _nT_=[0,[1,_nU_]];}
                       var
                        t1_nV_=repr_jO_(_nO_),
                        t2_nW_=repr_jO_(_nT_),
                        _nX_=t1_nV_[1];
                       {if(2===_nX_[0])
                         {var sleeper1_nY_=_nX_[1];
                          if(t1_nV_===t2_nW_)
                           var _nZ_=0;
                          else
                           {var _n0_=t2_nW_[1];
                            if(2===_n0_[0])
                             {var sleeper2_n1_=_n0_[1];
                              t2_nW_[1]=[3,t1_nV_];
                              sleeper1_nY_[1]=sleeper2_n1_[1];
                              var
                               waiters_n2_=append_kG_(sleeper1_nY_[2],sleeper2_n1_[2]),
                               removed_n3_=sleeper1_nY_[3]+sleeper2_n1_[3]|0;
                              if(max_removed_jN_<removed_n3_)
                               {sleeper1_nY_[3]=0;
                                sleeper1_nY_[2]=cleanup_kD_(waiters_n2_);}
                              else
                               {sleeper1_nY_[3]=removed_n3_;sleeper1_nY_[2]=waiters_n2_;}
                              var
                               _n4_=sleeper2_n1_[4],
                               _n5_=sleeper1_nY_[4],
                               _n6_=
                                typeof _n5_==="number"
                                 ?_n4_
                                 :typeof _n4_==="number"?_n5_:[2,_n5_,_n4_];
                              sleeper1_nY_[4]=_n6_;
                              var _nZ_=0;}
                            else
                             {t1_nV_[1]=_n0_;
                              var _nZ_=unsafe_run_waiters_kj_(sleeper1_nY_,_n0_);}}
                          return _nZ_;}
                        throw [0,_c_,_a8_];}
                      case 1:
                       var t_n7_=repr_jO_(_nO_),_n8_=t_n7_[1];
                       {if(2===_n8_[0])
                         {var sleeper_n9_=_n8_[1];
                          t_n7_[1]=state_nP_;
                          return unsafe_run_waiters_kj_(sleeper_n9_,state_nP_);}
                        throw [0,_c_,_a9_];}
                      default:throw [0,_c_,_a$_];}}],
                _n$_=sleeper_nN_[2],
                _oa_=typeof _n$_==="number"?_n__:[2,_n__,_n$_];
               sleeper_nN_[2]=_oa_;
               var _nM_=_nO_;
               break;
              case 3:throw [0,_c_,_a__];
              default:var _nM_=_nq_(_nL_[1]);}
            return _nM_;}
          dyn_preview_no_(_n_,0);
          return 0;}
        _k0_(_mM_.contentDocument,_ob_);
        return _false_k6_;});
    do_at_exit_cr_(0);
    return;}
  ());
